PTXprint 3.0.37 Release Notes
23 Jul 2026

"Bible Layout For Everyone" - Easily create scripture PDFs for trial publications
_____________________________________________________________

Bug fixes and Improvements in 3.0.37 - (23 Jul 2026)
  * Don't output cropmarks for covers with no spine
  * If no spine, then no cover bleed
  * Improve merging behaviour and write versioning info to merge file
  * Build the merge score/weight array from the 'Weight' column
  * Make some versions of python happy

Bug fixes and Improvements in 3.0.36 - (22 Jul 2026)
  - Fix installer: remove old font folders before copying new files into place

Bug fixes and Improvements in 3.0.35 - (21 Jul 2026)

  * Diglot
    - Diglot: the page-full maths was confused, fix it
    - 2 minbaselines works much better across multiple projects than 1 maxbaseline
    - Make paragraph counting during diglot merges fractional
    - Deactivating not-activated custom chars should *not* cause a crash
    - Solve the unexpected lineskips
    - Clean up random spaces
    - Make AboveStudyNoteSpace a variable (Fix #1245)
    - Let midverse poetry paragraphs chain
    - Fix note positions
    - Fix error in height calcs when BelowBaseline is active

  * Printers tab
    - Rebuild Printers tab: shared job spec, printer directory list, dynamic panels
    - Refine the Printers tab to make it more compact
    - Extract shared currency service and decouple price comparison from Pretore
    - Fix total price for 2-up print jobs on Printers tab
    - Explain why Pothi paper type often leaves the price unchanged

  * Page Filler
    - Fix stopping page filler
    - Support expanded regular font
    - Clear probes after failing page
    - Solve(?) late-stage reflow issues

  * Pictures
    - Stop smart quotes before loading piclist (#1175)
    - Solve repeated image bug

  * Testing Framework
    - Reduce test file sizes, use a better default location, limit redundant test error reporting
    - Return exit code 1 when a test fails
    - Ensure testing works with relative paths
    - Allow test recording via GUI
    - Modify code dealing with filepaths to hopefully work cross-platform
    - Check diffs for cfg and sty files, otherwise just report files are not identical
    - Exclude the local subdir from the test reduced archive
    - Compare all files after running test
    - Raise NotImplementedError if full_archive is False

  * Other
    - Fix TypeError in Cover Wizard when LineSpacing/FontSize returned as string
    - Find missing icons; make sure fonts are installed in the right place
    - Register Source Code Pro as an installed Windows font
    - Fix version out of date messaging
    - Attempt a slightly more nuanced approach to unprintable contents
    - Add QR to tooltip so that it appears when a user searches for it
    - Fix color.org typo

Bug fixes and Improvements in 3.0.33 - (24 Jun 2026)

  * Automatic Page Filler (Note: This is still an experimental feature)
    - Make Auto Page Filler (in PDFviewer) more intuitive to use
    - Add parameters to control Page Fill algorithm
    - Improve color-coding and wording of Page Fill dialog with Color Key button
    - Make the completed page reporting more accurate
    - Disable all peripherals for page_filler

  * Diglot/Polyglot
    - Add a Diglot-specific Front Matter template
    - Allow pdf viewer to switch around polyglot views
    - Handle diglot folders for pictures from multiple sources
    - Refactor picinfo searchlist to support searching across diglot projects
    - Ensure Secondary project sets S/R flag when adjustments are made to the project
    - Don't make it too easy to enable Diglot (and warn about implications first)
    - When Diglot is enabled, show the project selector for the Sec project
    - Add warning and "Save as Monoglot..." dialog when disabling a Diglot
    - Cope with cutouts when there has not been a previous chunk
    - Fix bug blocking switch to another config when Diglot was enabled
    - Fix bottom pictures in diglot

  * Covers (for alpha testing - work in progress)
    - Get covers working from the wizard (see top of Peripherals tab)
    - Fix border maths for covers (#1231)
    - Finish implementing BorderMargins
    - Implement \csname cover-hinge\endcsname parameter (TeX) for hardbacks
    - Add some docs, centre rotated spines
    - Minor fix for negative spine-widths

  * Pictures
    - Add various items to PicList context menu
    - Use gray in PicList to indicate if picture is missing / source not found
    - Add peachpuff highlighting for selected problem rows in PicList
    - Add Tooltip for scale error on PicList and peachpuff Scale spinner
    - Fix bug of Frame Size being set to span when inner or outer was selected
    - Fix big pictures not appearing (part 1)

  * Book Selection
    - Add Toggle Books button on book chooser dialog
    - Only validate the book list on print

  * PDFviewer
    - Add support to detect and highlight in purple bad/missing glyphs (Tofu)
    - Move PDFviewer status messages to become a Tooltip on (i) button - right edge
    - Make sure Ctrl-scroll zooming also works when cursor is NOT hovering over page or spread
    - Try to improve placement of temp msgs and dialogs in PDFviewer
    - Add reset all adjustments until end of book to context menu
  
  * Other
    - Add highlighting capability (Ctrl-Click) to Adv->Other settings
    - Ensure Reset/Delete config always shows the right button/label
    - Improve "Jump to Ref in Paratext" by foregrounding PT after sending Ref
    - Add a standard for BSB test
    - Cleanup adjlists to remove duplicates, before saving
    - Improve archive creation (generating better paths for files)
    - Add hyphenation word list advanced controls
    - Tidy up and fill in missing info in TechRef documentation
    - Fix the zimagecopyrights generation in other languages - especially 'in'donesian.
    - Update picCopyrights.json with missing fr,es,pt localized strings
    - Fix missing Localization
    - Fix back to front reading of (sub)modules
    - Fix TOC again
    - Fix typo in copyright file reading
    - Flag unexpected state rather than just pretending it is not there
    - Add import site to pdfinish
    - Prevent unvboxing of things that are not vboxes
    - Fix timewasting (cycle-wasting) typo
    - Allow zero \Raise to be considered the same as no \Raise entry
    - Ensure that texpert note estimation controls match TeXs values

Bug fixes and Improvements in 3.0.32 - (4 Jun 2026)
  * Make sure settings are stored in all PDFs when 2-up pagination is set
  * Turn zpdf into a milestone with attributes and include in codelets
  * Fix the Zoom control to update the zoom %age when Zoom to fit has been clicked
  * One line fix to sort the sections of the report better
  * Bring back long lost Status bar messages with info, warn and error counts
  * Always open TechRef documentation in system viewer (making it searchable)
  * Fix bug of passing the wrong file to the PDFviewer
  * Add MRU list to Copy Configuration to... dialog
  * Merge pull request #1172 scale-to-fit

Bug fixes and Improvements in 3.0.31 - (1 Jun 2026)
  * Improve Picture Catalog behaviour
  * Resolve picture references to bridged verses
  * Right-click context menu to copy fig details to clipboard in USFM format
  * Autofill plugins when polyglot requires them
  * Add attach_console for windows (should give stdout if run from a console)
  * Enable filtering of non-default settings on Adv->Other tab
  * Add a status message on the left side of PDF Viewer button bar
  * Protect or remove chunk-final skips (EEK avoidance)
  * Add Piclist and Module to the sections codelets for changes
  * Deactiveate custom chars for vp and va
  * Improve choose base projects location dialog and wording
  * Improve diglot notespace calcs, expose diglotBalNotes
  * Treat poetry different to non-poetry (WIP)
  * Add texpert options for page_filler badness
  * Add extra texpert controls
  * Get paths sorted for wizards
  * Add various json files and Windows build set bug
  * Get file saving working in pdfinish across filesystems
  * Allow complexpages layout strings in experimental mode -E 1
  * First stab at diglotjointtype{gridone}
  * Fix numverses add clubpenalty snippet
  * Fix vernacular font not being applied to Variables
  * Fix paragraph counting in glossary, so figures include correctly
  * Fixed (?) repeated footers 

Bug fixes and Improvements in 3.0.30 - (18 May 2026)
  * Get covers working in some way
  * Replace getSrcDir with pytcodedir and remember to use it
  * Enable pdfinish again
  * Fix broken .spec file

Bug fixes and Improvements in 3.0.27 - (14 May 2026)
  * Improve layout of Pretore options and sign-up
  * Fix path problems for downloading ImageSets
  * Make sure PDF viewer's Page count is updated consistently
  * Improve scrollwheel behaviour when zoomed in with PDF viewer
  * Get multiprocessing working for pyinstaller apps

Bug fixes and Improvements in 3.0.26 - (14 May 2026)
  * Fix bad bug in adjlist triggers generation
  * Make Project dropdown scrollable
  * Fix bug on create archive.
  * Get internal files better from windows .exe
  * Update the techref
  * Fix bug #1162 bug03-nonstopmode-not-reset
  * Fix bug #1165 firstnote-false-before-check
  * Remove pdfinish as not ready yet
  
Bug fixes and Improvements in 3.0.25 - (11 May 2026)
  * Add -S to enable external scripts during CLI printing, for protection
  * Minor fixes and hopefully handle cross platform paths in archive creation
  * Integrate pdfinish into the build
  * Tighten up the UI vertically to take less space
  * Make sure PDF Preview shows the updated page
  * Fix python-bug16-17-20-usfmerge      #1157 
  * Fix tex-bug05-leftmarks-logic-typo   #1164 
  * Fix tex-bug01-getcalleres-typo       #1160 
  * Fix tex-bug02-set-utonum-overwrites  #1161 
  * Fix tex-bug04-duplicate-gdef         #1163 
  * Fix tex-bug07-wrong-if-conditional   #1166 
  * Fix image padding bug causing pics to disappear completely
  * Fix missing cinfo/topx bug
  * Fix end of ayah for verse ranges

Bug fixes and Improvements in 3.0.24 - (9 May 2026)
  * Use new dialog for choosing base project location if -Z 8 is used from CLI
  * Fix bare except on Windows DPI and WindowGeometry.fromConfig drops frame fields
  * Fix bare except: in parselog swallows KeyboardInterrupt
  * Fix PDF color variant suffix silently dropped from filename
  * Fix analyse_script can crash or loop forever
  * Fix path typo shard->shared and _mergecfg uses wrong config variable
  * Fix getBooks returns None instead of [] when no project loaded
  * Fix doError logs txt instead of secondary for secondary message
  * Fix duplicate Thumb Tabs widget_map key and Log Analysis excluded from summary

Bug fixes and Improvements in 3.0.23 - (7 May 2026)
  * Provide options if multiple Paratext projects are located on initial run. #1143
  * Make the booklist more robust to handle wrong book names or codes #1142
  * Add link to Master Slides on Help tab
  * Only one wordlist footnote per word in a verse
  * Add comments to uwtv converter
  * Add unfoldingWord conversion script
  * Add mode to markdown converter
  * Make sure we don't store None when we mean ''
  * Turn on space before studynotes if after other notes
  * Add developer overview doc for the diglot/polyglot system
  * Refactor wizards
  * Add Layout (configuration) Wizard; keep button hidden behind -E 1
  * Fix markdown parsing
  * Fix intercharspace to have a nobreak at start
  * Fix style tristate values

Bug fixes and Improvements in 3.0.22 - (30 Apr 2026)
  * Attempt to improve page-fill and avoid some crashes
  * Enable "downgrading" study notes to normal notes
  * Make study notes in diglots calculate space better
  * Define tri@lsplitRej once should be enough
  * Fix typo that stopped special attributes from detecting properly

Bug fixes and Improvements in 3.0.21 - unreleased (29 Apr 2026)
  * Only show the OK-Cancel dialog for larger (2MB+) PDFs
  * Move version stuff out of view into version.py
  * Study notes in diglots
  * Reduce required fonts to Charis
  * Make broken startup (runsplash) error message is more helpful
  * Add long load message dialog with OK or Cancel option
  * Add markdown-it-py dependency to pyproject.toml
  * Add initial markdown support (requires markdown_it python module)
  * Fix bug that prevented Diglot working after first setup
  * Fix minor bugs in ptx-diglot.tex and load_parlocs
  * Fix glossary as footnotes

Bug fixes and Improvements in 3.0.20 - (26 Apr 2026)
  * Update VCS trigger when adjlist changes
  * Get marginal notes working
  * Try to get page_filler to finish the good work it starts
  * Incremental improvements to Printers tabs
  * Implement 'no whitespace' background image sizes for covers
  * Add tweaks needed for cropping images
  * QR codes in coloured contexts should not generate bad .XDV, but inherit that colour
  * Prepare to allow non crop mark bleeds (partly completed)
  * Auto-close warning message after 30s and carry on with job
  * Add better colour support to covers, etc.
  * Ensure 'Layout Only' is disabled when a config changes
  * Add DEBUG to pyinstaller output on windows build
  * Minor PDF navigation fixes
  * Fix nlines error
  * Fix syntax error that only Python 3.11.0 seems to care about

Bug fixes and Improvements in 3.0.19 - unreleased (19 Apr 2026)
  * Add (Auto) Fill Page feature to PDF Viewer and show book progress (parallel processing)
  * Remove the Cover tab and add a Cover Wizard instead (peripherals tab)
  * Add the Printers tab with cost comparisons graph (for Pretore, Print_Gallery, Pothi)
  * Smarter choice of anchor ref if an image has multiple options (uses the filtered book ref)
  * Improve picture catalogue to be more responsive and flexible
  * Improve ImageSet downloader dialog to be dynamic
  * When saving diglot content at a layout style break clear values for interleaving.
  * Implement cropped background images and positioning thereof
  * Add Charis to bundled fonts
  * Fix support .png images in the picture catalogue, etc.
  * Fix picture preview pane to also shows 1st image at startup #1096
  * Fix configuration names should be sorted caseless
  * Fix avoid EEK from mispalced marks on sections (diglot issue)
  * Fix cover figure image shift bug
  * Fix shortcuts not working as they should
  * Fix don't sort the book list (allowing non-canonical book order as before)
  * Fix cover wizard UI

Bug fixes and Improvements in 3.0.18 (3 Apr 2026)
  * Solve issue of lineskiplimit causing mangled small textborder boxes
  * Improve cover wizard UI
  * Wire up Pretore behind -E 1
  * Make page_filler more robust
  * page_filler to support verse ranges
  * Remove default timeout from page_filler
  * Handle radio buttons when no gui

Bug fixes and Improvements in 3.0.17 (27 Mar 2026)
  * Merge pull request #1138 from sillsdev/feature/dmg-ux
  * Look harder for resources
  * Get page callers working again
  * Use appdmg to create better dmg UX
  * Don't run the whole thing at the end
  * Use multiprocessing.spawn on everything in page_filler
  * Add multiprocessing to page_filler
  * Fix design_badness in page_filler
  * Add more picture support to parlocs

Bug fixes and Improvements in 3.0.16 (17 Mar 2026)
  * Add generated values to the header drop down
  * Fix window position memory on Linux by going to X11
  * Fix Alt-x showUnicodeValues consuming the selected text
  * Fix unable to update peripheral values in table
  * Fix ColInfo for polyglots
  * New badness function and work to reduce workload
  * Get page_filler doing something useful (work in progress)
  
Bug fixes and Improvements in 3.0.15 (11 Mar 2026)
  * Fix missing printers folder (causing crash at startup)
  
Bug fixes and Improvements in 3.0.14 (10 Mar 2026)
  * Fix HebrewDigit mapping
  * Fix adjlist trigger files (get shrink/expand text working again)
  * Add page_filler but expect radical changes

Bug fixes and Improvements in 3.0.13 (5 Mar 2026)
  * Handle bad bookcodes more gracefully
  * Get view & edit final sfm working again
  * Invert y in outline collision tests
  * Don't short circuit loading config in GUI on project change
  * Fix bad style updates on config change
  * Fix reporting bad books

Bug fixes and Improvements in 3.0.12 (3 Mar 2026)
  * Look for books first in shared config and then project dir
  * Add UI Extention capability to right-click context menu in PDF Viewer Pane
  * Get AdjList to save custom triggers and add to triggers file
  * Allow tabbing between rows/values in the variables
  * Refactor to add getBookSrcPath to view
  * Recurse any 'include' files in report generation
  * Get manual change of page number working again
  * Handle fonts without hmtx for space_width
  * Don't generate tildes for hard spaces
  * Possible RTL TOC fix
  * Fix bottom pictures for non grid (warning: this may adjust pictures)
  * Fix bottom alignment for off grid setting
  * Fix variable spacing
  * Fix menu item alignment
  * Fix reduplication bug while inserting strongs numbers
  * Fix marginnote header
  * Fix generating xrefs for verse ranges

  Several diglot improvements:
  * Get XXM maps to print even when in diglot mode
  * Check for negative splits, to avoid some(?) EEK situations.
  * Make \d merge as part of the body, rather than a part of the chapter-block
  * Stop accidentally overriding a split point because of a \b. NEEDS TESTING.
  * Solve ifcheck errors from  run@a@trial triggering itself
  * Make diglot triggers count paragraphs better
  * Remember dc@rref from one chunk to the next
  * Refactor Underfill msg to be clearer
  * Be resiliant against diglot oddities
  * Add afterchunk hooks to diglot

Bug fixes and Improvements in 3.0.11 (17 Feb 2026)
  * First steps towards a paragraph badness figure. Currently just based on widths of spaces
  * Override font for finalSFM
  * Fix diglot triggers filename so that shrink/expand text works
  * Fix diglot RH/RF center positioning
  * Fix Layout Only (noUpdate) regression, and force processing when chapter range changes
  * Fix non implicit closure inside notes (e.g. \it)

Bug fixes and Improvements in 3.0.10 (13 Feb 2026)
  * Improve context menu with color-coded options and tooltips for keyboard-mouse shortcuts
  * Turn off Layout Only (pauseNoUpdate) whenever SpeedSlice is used
  * Get pictures in non-Scripture books working again
  * Attempt to align drop chaps and centred paragraphs
  * Add ptxprint-mods.tex codelet for Side-Aligned Notes
  * Add changes.txt codelet to Insert break in Columned References
  * Remove some spaces that crept into footnotes handling
  * Include note callers in parlocs
  * Fix filtering of glossaries with chapters and chapter labels
  * Fix chaining char style from a disabled style and get zvar working again
  * Fix onecol side notes which means full pages of intro will have the side notes too
  * Fix note-duplication at book-end

Bug fixes and Improvements in 3.0.9 (2 Feb 2026)
  * Enable noupdate by default
  * Pause no update on edits to settings files
  * Implement handling shrink/expand text with noupdate enabled
  * Add precise glyph collisions
  * Enhance changes.txt with ability to use functions (see snippets.md)
  * Add dropdown to control marginal verse hyphens (Advanced, Other)
  * Make 'in' changes match multiple lines for .
  * Destroy old main window when switching languages
  * Pause if script newer than pdf
  * Increase blank white threshold for diglots
  * Add check for content in scripture file to catch it before TeX gives an unhelpful error
  * Add runchecks when canonicalising
  * Avoid spurious \vid|* in diglots
  * Allow interlinear with no language (assumes \rb is provided)
  * Move interlinear processing earlier in process
  * Address the regular overriding other font settings on project load (#1127)
  * Add footnote magic when enabling shift ayahs
  * Get TOCs working for RTL no leaders
  * Set rejected height when rejecting a galley
  * Add usfm checks to reports
  * Add widgets to processing_needed list
  * Change Lists to be VerseText, not Other (because this allows pagebreaks after)
  * Tidy up button clicking in pdf_viewer
  * Tidy up the noupdate logic and fix autoupdate timing bug
  * Fix losing font styling, and harden the style editor
  * Fix report generation
  * Fix p^96, add full footnote test
  * Fix mis-paragraphing in RTL merged notes (#1125)
  * Fix cv feature values in font selector to give correct output
  * Fix legacy config for section header borders
  * Fix crash in moving ayahs
  * Fix noaction on diglots
  * Issue when enumerating font weights on macOS (#1093) - Needs testing

Bug fixes and Improvements in 3.0.8 (17 Jan 2026)
  * Add 'Layout Only' mode to skip re-processing of USFM data on every run (speeds things up)
  * Automatically turn off 'Layout Only' if shrinking or expanding text (e.g. 97% / 102%)
  * 'Make Diff' checkbox moved to the Finishing tab to make space for 'Layout Only'
  * Add shortcuts for -1 and +1 adjustments (Ctrl+Left/Right-click) for rapid multiple adjustments
  * Add abililty to call $functions in changes.txt (early 
  * Add side aligned notes to the snippet.md
  * Better file handling of bad UTF8 data (replace with U+FFFD and capture error in report)
  * Optimise tracing for faster XeTeX run-times
  * Don't break between book and chapter in \ref
  * Make mismatch warning both more truthful and informative
  * Avoid impossible-to-debug crashes due to unexpected output during macro definitions
  * Default to FastTracing, since slow tracing is buggy
  * Fix truncated tables, which also affected Table of Contents across more than one page
  * Fix bug where headers weren't editable (for typing a custom header, or code)
  * Fix handling of empty string on RHS of changes
  * Fix Variable Line Spacing toggle
  * Fix setppagecontents typo
  * Fix beginL problems for ifs
  * Fix starting pagenumber bug
  * Fix unwanted space at start of some xt refs
  * Fix variable line spacer toggle not sliding
  * Fix cutout when baselineskip isnt rigid

Bug fixes and Improvements in 3.0.7 (6 Dec 2025)
  * solve IF problems from diglot headers
  * Add parlocs end-of-page logging
  * Only disable covers if frt not set

Bug fixes and Improvements in 3.0.6 (3 Dec 2025)
  * Re-instate refresh picture captions functionality
  * Handle right indents correctly in tables and tocs
  * Handle multiple references in module refs
  * Make sure Diglot merge mode is remembered
  * Enforce cover and FRT synchronization
  * Make sure prepress file can be renamed (procpdf). fix typo in runjob
  * Refactor where the intermediate generated pdf goes
  * Add underline control to Styles
  * Update tech ref to 3.0.4
  * Start adding timing checks
  * Cherry pick extended changes from dev
  * Fix Font Reset in Styles
  * Fix faulty calculation scaling maximum
  * Fix Paratext shortcodes typo

Bug fixes and Improvements in 3.0.5 (28 Nov 2025)
  * When missing a font, inform user about which styles use that font (making it easier to fix)
  * Run the whole windows build from pyinstaller
  * Refactor mac build code into functions
  * Refactor icons into ptxprint.spec
  * Fix Diglot trialheight issue
  * Fix analysing non files
  * Fix syntax error (for python 3.11) no backslash allowed in f-string
  * Reorder build internally to pyinstaller to help with debugging
  * Fix minor import syntax error
  * Add DEBUG log to pyinstaller
  * Fix typos in gtktester

Bug fixes and Improvements in 3.0.4 (21 Nov 2025 - Linux only release)
  * Use maintitle for PDF if available (instead of Project Fullname)
  * Fix pictures in MODules
  * Fix spacing of paragraphed footnotes
  * Quit gracefully if specified -p dir doesn't exist
  * Use other range separators specified in Paratext settings
  * User-settable chapter pair separator - using TeX codelet
  * Stop testing zipfile writing from winging
  * First attempt at broadway integration on windows
  * Add --testwithgui for UI regression testing (linux only testing atm)

Bug fixes and Improvements in 3.0.3 (15 Nov 2025)
  * Ensure Local Front Matter is enabled if Cover is selected; and vice versa
  * Get PDF borders working again
  * Work towards better trial lengths

Bug fixes and Improvements in 3.0.2 (13 Nov 2025 - unreleased)
  * Allow textborder in diglots to appear around just selected column(s) (e.g. original Greek) via \def\TextBorderColumns{L}
  * Improved behaviour of textborder in diglots - they can now surround just verse text when there's a book intro.
  * Implement new expert control \TextBorderMode for selecting textborder behaviour (in diglots)
  * Allow ornament patterns to define a group of ornaments to be repeated as a group
  * Make sure MacOS doesn't open up the ZIP file when selecting it in file-chooser dialog
  * Increase resilience against garbled input
  * Only inhibit spaces if interchar spacing enabled (affects beng scriptsnippet)
  * Register all polyglot boxes as inserts (most are) so that when insert counts are set up they do not mangle other values
  * Don't output empty config entries
  * More maths corrections for textborders
  * Check for intro->body swapping in a better place
  * Introduce per-column catergories, make textborder one
  * Solve some issues with diglot background position/size
  * Add a couple of snippets to the docs
  * Find footnote placement bug
  * Correct some more maths in diglot
  * Add TextBorderMode control, apply to pagewide borders
  * Correct positioning with notes for individual textborders
  * Avoid triggering some confusing errors
  * Re-jig tracing
  * Bug also triggered on XeTeXinterwordspaceshaping=1
  * Work-around for intercharwordspacespacing bug
  * fix: mac: dmg cleaning not looking in the correct directory
  * fix: mac: Delete old dmg images from previous runs

Bug fixes and Improvements in 3.0.1 (20 Oct 2025)
  * Add version number to macOS installer
  * Fix Windows dialog positioning

Bug fixes and Improvements in 3.0 (18 Oct 2025)
  * Change default poetry indents
  * Change heading styles defaults
  * Reorganize the Basic tab to be more logical
  * Hide copyright information behind twisty; make it a multi-line control
  * Install BSB automatically if no other project is found
  * Add tabs to PDF Preview window for Content, Cover, Diff, Finished and Reference
  * Ensure Catalogue and TechRef come to the fore after being opened in the Preview pane
  * Improve the Styles tab - searching, filtering, highlighting, scroll to active style
  * Improve UI to make it easier to enable dynamic borders
  * Restore the extra font details (expand, slant, thickness etc.) on Styles tab
  * Mitigate empty Justification setting in Styles editor
  * Move menu button to top-left in main dialog
  * Refine layout of Diglot tab
  * Multiple improvements to get importing from ZIP files working more predictably
  * Improve window position restoring logic to handle unexpected situations correctly
  * Refactor marginal chapters for better spacing control
  * Use a better 'Refresh' icon on multiple buttons
  * Add 'DoubleSided' (2-sided unmirrored) option to Advanced > Other > Page Layout & Spacing
  * Change illustration credits and add option to list ALL pages
  * Highlight combo boxes on search; enabling various settings to be found easier
  * Tweak tooltip for 'Show USFM codes' and use SourceCodePro
  * Improve UI around End of Ayah and add line to \va style to control appearance
  * Don't move verses/ayahs to end if ornamental verses is disabled
  * Improve auto-setting Project on initial run
  * Disable Save and Print buttons until a project has been set
  * Include Charis 7.0 in PTXprint installer - available by default
  * Make sure treeDirs is updated in ptxprint_user.cfg file
  * Add button to Help tab for changing Base Projects Directory
  * Integrate tag hacking support for f^98 et al
  * Only show interchar problems if letter spacing enabled
  * View+Edit tab: only truncate .log files - let others load completely
  * Protect figure borders from peripheral interaction, semi-solve map borders
  * Suppress unknown tag error messages
  * Introduce garbage collection to prevent locked file when being cleared
  * Add various Codelets
  * Get rid of spurious sp inserted in 2 col margin notes
  * Avoid a prevdepth usage error
  * Correct Vectorian1 border
  * Process Strongs before localChanges regexes and allow \xts inside \w for keyword marking
  * Remove crash on print stopping PDF updating
  * Gridding righteousness partially restored
  * Don't put list chapter index when not a chapter
  * Refactor runptxchanges to use changes.py
  * Avoid *some* parts of #1110
  * Fix a leaky space in footnote text callers
  * Fix finishing files naming
  * Fix saving config on BSB load
  * Fix PTXprint path in Help tab link for Win
  * Fix modal msgQuestion to use the right parent window
  * Fix gridding limits?
  * Fix subheading gridding sometimes missing some space
  * Fix text borders
  * Fix style strikethrough
  * Fix unescaped \ codes
  * Fix bug where 'NoInternet' was still leaving some links clickable
  * Fix missing Project settings for Mini & Basic view level
  * Fix segfault crashes when trying to update PDF viewer
  * Fix procpdf filename handling problems
  * Fix time and version on title of pdf viewer
  * Fix Zoom level on multiple tabs
  * Fix chapters for interlinear
  * Fix vid and zsetref for modules
  * Fix bottom margin aligning pictures, not removing top space, active characters

Bug fixes and Improvements in 2.9.9 (2 Oct 2025)
  * Refactor PDF Viewer to display mutiple PDFs
  * Add tabs on preview pane for cover and diff
  * Remove Print Cover button - as Cover will just appear as a tab in viewer
  * Update zoom and page settings when switching tabs in pdf_viewer
  * Various UI tweaks/improvements to the Peripherals tab
  * Add automatic creation of BookNames.xml to import process (if missing)
  * Move 'Import Scripture' to 'Import...' option at end of Project selector
  * Update BSB (Berean Standard Bible) example text shipped with PTXprint (see Import...)
  * Install BSB automatically if no other project is found on startup
  * Add default font (Charis 7.0) 
  * Don't crash if no project is selected and user chooses single book radio
  * Improve auto-setting Project on initial run
  * Swap XXS and XXM numeric values 101/102
  * Stop Spinner from making it hang
  * Improve ColorTabs logic - especially for Basic view
  * Turn off refs as links by default
  * Provide options for jmp/ref link border styles; tooltips on how to change the colour
  * Prevent report from crashing if no bad spaces
  * Prevent inappropriate breaking of old-style notes
  * Add ptlite support to MacOS version
  * Add DoubleSided (true) option to Advanced > Other (don't swap L/R margins on odd/even pages)
  * Re-generate style stack properly after closing a headingsbox
  * No title stuff in module refs
  * Update TechRef documentation
  * Ensure Catalogue and TechRef open in the appropriate viewer, and come to the fore
  * Add links to dynamic section heading decorations style
  * Move the dynamic borders around in the UI to be more consistent.
  * Improve UI behaviour for dynamic borders
  * Flip 'Hide/exclude marker' to 'Show contents of marker' in Style editor
  * Integrate tag hacking support for f^98 et al
  * Highlight combo boxes, enabling Digit Mapping settings to be found easier
  * Don't show unused tabs in pdf_viewer
  * Fix Chapter 1 error - appearing alone at end of page (#1091)
  * Fix open of OrnamentsCatalogue and TechRef
  * Fix Diglot Project chooser selecting Import option
  * Fix page numbering bug, (page numbers being reset twice)
  * Fix 'at' changes not working for before chapter 1 in single chapter books
  * Fix bug to enable open.bible and DBL links
  * Fix tooltips in Preview pane
  * Fix text borders

Bug fixes and Improvements in 2.9.8 (12 Sep 2025)
  * Implement generic ID C:V parser and get zsetref and vid milestones using it
  * Add a codelets for hook to keep with next para
  * Add a debugging option to help figure out drifting notes
  * Add sample code for icon to launch the AI Support Assistant (unimplemented)
  * Add TagableRef to picture catalogues
  * Make the installation info point to the right places
  * Tweak UI of Picture tab
  * Improve stats report
  * Update ptx2pdf-faq.md  
  * Fix import config not saving
  * Fix \ca processing for all 3 scenarios
  * Fix module reference localization
  * Fix broken footnote removal in module flattening
  * Fix missing picture previews
  * Fix RTL ch:verse-ranges in TXL questions

Bug fixes and Improvements in 2.9.6 (5 Sep 2025)
  * Prevent preview pane opening when other PDF view options are set
  * Add left+right arrow keys as for PDF navigation (PgDn/Pgup)
  * Add required gi modules for windows
  * Add win32 and fontconfig gi typelib hooks
  * Add hooks for poppler for pyinstaller
  * Fix minor bug self.mainapp.win

Bug fixes and Improvements in 2.9.5 (4 Sep 2025)
  * Refactor code for MacOS
  * Get Mac packaging working and make available on downloads page
  * Add button to install BSB as an option in Import Scripture
  * Enable Import to handle .zip files with either USX or USFM
  * Tweak wording grid/baseline/graph paper in UI
  * Move forward from appdirs which is now deprecated
  * End of Ayahs have the space before moved after
  * Auto analyse projects for script
  * Update ptx-unicode to latest unicode and support U+FDD0 as interchar space inhibiter
  * Refactor decorative boxes snippet for modern diglots
  * Re-enable shortcut/accelerator keys after Mac refactoring
  * Tidy up Project and Scope area of UI (stop expanding horizontally)
  * Test guid when changing project
  * Color Project codes from _PTXprint in purple - distinguishing them from normal projects
  * Get accelerators (shortcut keys) working again on the main window
  * Tidy up creation and management of XXM details for Maps
  * Catch bad chapter ranges perhaps
  * Reduce installer size (remove redundant binaries)
  * Add icon to AppWindow
  * Add support for \ca (without styling)
  * Fix bug of processing stale data - now reloads usfm files on each print
  * Fix parsing zvar and add early ldml lookup support
  * Fix ptxsettings.bookNames -> bkNames
  * Fix diglot border

Bug fixes and Improvements in 2.9.4 (19 Aug 2025)
  * Place bottom images on the baseline
  * Provide various options for Locate... issues in PDF Viewer
  * Improve Linux packaging toolchain
  * Add typesetting report page numbers in pdf viewer
  * Fix versesToEnd
  * Disable Layout Analysis when switching configs/projects/books
  * Fix end of ayahs
  * Fix missing spaces in pyproject.toml version field to get auto-updated

Bug fixes and Improvements in 2.9.3 (9 Aug 2025)
  * Fix crash on Import Scripture
  * Improve Linux packaging options

Bug fixes and Improvements in 2.9.2 (8 Aug 2025)
  * New feature: Layout Analysis in PDF Previewer
     - highlight bad word spaces
     - highlight bad inter character spaces
     - highlight vertical rivers of whitespace
     - highlight vertical glyph collisions between lines
     - Analysis settings are configurable (Advanced > Other > Preview)
  * Add support for inner and outer paragraphs
  * For diglots, style secondary header material using secondary \h style
  * Fix USFM 3.1 support for implicit closure inside notes

_____________________________________________________________

Bug fixes and Improvements in 2.8.22 (24 Jul 2025)
  * Attempt to fix/prevent style corruptions (debounce to avoid rapid, repeated searches)
  * Improve everyfirstverse handling
  * Multiple bug fixes to usfmtc lib
  * Refactor subdoc to use usfmtc
  * Add intros to subdoc-ed books
  * Minor tweaks to UI and map header
  * Reword DBL button -> Import Scripture
  * Fix chapter indents for li-type paragraphs
  * Fix bunching in margin note collision avoidance
  * Fix tests with the demise of usxutils subdoc()

Bug fixes and Improvements in 2.8.21 (17 Jul 2025)
  * Fix modules and \inc
  * Update DBL link to new URL (new site requires login)
  * Minor bugs in xref and pos being None
  * Fallback scripture files to usfm
  * Nearly fix strongs and xrefs
  * Add to snippets.md (kerning digits in a chapter number)
  * Refactor s@tsideskips ready for note integration
  * Add inner and outer as paragraph alignment options
  * Add Blue, Orange, Red status for Update available button
  * Fix marginnotes both 1 and 2 col
  * Fix collision avoidance direct algorithm
  * Improve margin note positioning
  * Refactor out old RefList.filterBooks
  * Fix bug where the log file wasn't being tailed well
  * Add war stories (subtle user errors with troubleshooting tips)
  * Refined report details
  * Update report for changed markers
  * Update ployglot cfg for newly created config
  * Add TOC marker list to report
  * Try to get more info on changed markers

Bug fixes and Improvements in 2.8.20 (9 Jul 2025)
  * Add tex standalones to parser and assume files are usfm
  * Add daggers to glossary options
  * Add colors to book chooser
  * Add some UI for Adding Maps [work in progress]
  * Add missing dependency for universalopen in utils
  * Highlight recently used projects
  * Treat file= as src= in localChanges
  * Refactor module learning for usfm3.1
  * Refactor modules to give better errors
  * Refactor module parsing
  * Warn not crash on empty book in addorncv
  * Refactor model filling in gtkpiclist
  * Don't give existing project name to DBL expander
  * Minor usfm reading fixes
  * Fix minor modname bug
  * Refactor converting to usx model in texmodel convertBook

Bug fixes and Improvements in 2.8.19 (4 Jul 2025)
  * Change labels of buttons in SpeedSlice to Enable and Disable
  * Add Section Links and date-time with summary at top and bottom of HTML report
  * Add support for marginal notes adjustment
  * Add sections(piclist) support
  * Remove xyzREF and xyzCAP changes feature
  * Remove marginnotes file at start of run
  * Stop addorncv raising errors
  * Improve USFM error reports
  * Don't process for adjlist if the adjlist is empty
  * Fix xo outputting book, bad at references in changes
  * Cross reference xo should have no book
  * Small (1st line) indents at chapters now behave the same in 1st and 2nd lines
  * Fix ancient bug with dropcaps and firstline / paragraph indents
  * Over zealous with the line ending %
  * Refactor to separate changes.py
  * Fix localising xrefs, shifting the bottom cluster of marginal notes
  * Adjusted the manual installation steps just a tiny bit

Bug fixes and Improvements in 2.8.18 (1 Jul 2025)
  * Add some hooks to the tech ref
  * Avoid some diglot crashes, and set old paragraph style (or something) on column switch, in case no par style is used.
  * Add merged changes sections to tech ref
  * Add chapter range to at changes
  * Add support for marginal chapters, notes and headings
  * Fix merged changes section
  * Minor fix for pdf_viewer index error
  * Get rid of chapters too long error
  * Fix at changes and version 3.1 output
  * Get at changes for verse ranges working
  * Add logger INFO and above to report
  * Try to handle 'at' changes more succinctly

Bug fixes and Improvements in 2.8.17 (24 Jun 2025)
  * Add link to auto-update delay settings
  * Add link to PTXprint Support chatbot
  * Add capabilities for marginal section heads
  * Add vertical alignment to marginnotes (work in progress)
  * Fix missing FigInfo import in pdf_viewer

Bug fixes and Improvements in 2.8.16 (20 Jun 2025)
  * Flip flop the licensing information to make launchpad happy
  * Fix bug with book codes starting with a digit not printing

Bug fixes and Improvements in 2.8.15 (20 Jun 2025)
  * Ensure that changing the page size recalculates the lines per page
  * Add FRT and INT to picture active books, if enabled
  * Add importing custom script
  * Freshen up DBL import
  * XDVPositionedReader sets font size in points
  * First step to moving texmf-dist to texmf_dist etc.
  * mv texmf- to texmf_ to make pyproject linux build happy
  * Don't include xetex/bin since pyproject is only for linux/mac packaging
  * Refactor python packaging and put texmf-dist back
  * Fix minor font bug where case on Bold or bold makes a difference
  * Fix missing/empty bks

Bug fixes and Improvements in 2.8.13 (18 Jun 2025)
  * Add feature to generate a publication report with pertinent details
    * Fix changed markers in report
    * Added page layout visualization
  * Add Hans script support
    * for Chinese vertical alignment (not yet vertical text flow)
    * Add tooltips to CJK script snippet minidialog
    * Move local changes after adjlist for cjk scriptsnippet \cjksp
  * QR code generation for chapters:
    * Chapter number QRcodes can now also go inside the chapter number box
    * Update documentation; make sure that everyfirstverse gets called for \nb chapters too
    * Add Chapter codelet (.tex) for inserting QR codes
  * Refactor checking for updates to be threaded and only every 24hrs
  * Add Alt-X keyboard shortcut on View+Edit tab to show unicode values of selected text
  * Add TTC (True Type Collection) font support at least for font 0
  * Explicitly mark to omit verses
  * Don't insert afterversespace in the text when no verses or marginal verses
  * Add codelets for chapter number adjustments - exp. QR code next 
  * Adjlist now ignores \b
  * Add support for \csname \typef@ce _spacefactor to multiply the space in a font. e.g. to make it thinner
  * Add missing \h check
  * Get marginal verse hyphenup working
  * Refactor pdf_viewer to pull out parlocs
  * Allow PTXprint to be hooked
  * Fix xrefs and dependency bugs

Bug fixes and Improvements in 2.8.12 (3 Jun 2025)
  * Add (re-)versification to xrefs
  * Add new code for a hook every first verse in a chapter. e.g. for QR links
  * Add new novpadding parameter to QR generator.
  * Add new nohpadding option to QR generator, making horizontal paddig the users problem
  * Add key files to the report, more to come
  * Add the start of a report generator via Create Report... button on Help tab
  * Don't crash in picselection if there is no description
  * Fix QR code alignment if positioned centrally
  * Fix interlinear minor bug with big effects
  * Fix report output if not available
  * Fix xrefs and versification
  * Fix #1082 styles editor pane issue.
  * Fix manual pagebreaks
  * Fix changing picture src not printing

Bug fixes and Improvements in 2.8.11 (27 May 2025)
  * Integrate reversification (to align diglot texts)
  * Add getting the versification out of paratext
  * Add TeXpert options for reversification
  * Layout changes to tech ref
  * Add copyright and license for diglots (\zcopyrightR \zlicenseR etc.)
  * Turn off letter spacing if hyphenate is enabled and display warning message
  * Add missing locale data for ml and en_GB
  * Ensure usfmtc data files are installed in build
  * Refactor texmodel reversify

Bug fixes and Improvements in 2.8.10 (24 May 2025)
  * Work around MapCreator pdf generation bug
  * Swap inactive Share button for an active Open PDF button in preview pane
  * Don't quit if the (new) UI language is the same as the current value
  * Improve main menu options to highlight current value
  * Hide main menu options after an option has been selected
  * Right-click context menu in Polyglot no longer hangs around after selecting choice
  * Add Donate button to menu
  * Add a More... link for codelets (pointing to the online Snippets.md file)
  * Add 3 column output, sufficient at least for a concordance
  * Add documentation snippet for 3 column concordance (in Snippets.md)
  * Solve character-styles in tables issue
  * Allow colour / color as attribute for zrule
  * Capture marks to top level in section paras (e.g. for k)
  * Some changes to endnotes and clearnotes, for better behaviour
  * Prevent breaking after write{@nontextstop} to parlocs
  * Open Preview or System Viewer or Folder when selecting menu option
  * Ensure the Open in System viewer gets the right PDF file, including TechRef or _diff
  * dimexpr needs a \relax to stop processing
  * Update TechRef documentation and test results
  * Layout v4: split column boxes to height + last line depth rather than just height
  * Add a few more debugging lines to help identify issues with changes sections
  * Implement loc parsing for ref character style
  * Fix crash on usfm3.1 attribute grab
  * Fix 'missing csname' bug
  * Fix UI level resetting

Bug fixes and Improvements in 2.8.8 (15 May 2025)
  * Replace archive-specific font lookup location
  * Allow catcode update to process
  * Better document subsetting for not starting with chapter 1
  * Include headers in subset documents
  * Add test cases, make \fig work (outside piclist) solve caption styling issue
  * Start working on character-styling in captions
  * Fix caption styling leaking into main text (pop styles)
  * Ensure glossary-depth entries only get processed in thier own level
  * Minor fixes to get tests working
  * Attempt to address issue #1078 (Chained glossary entries broken)
  * Add single option to 'Shrink Line and Text' and re-arrange context menu
  * Fix addorncv
  * Don't crash if you change language with no project set
  * Improve pagebreak handling in diglots
  * Fix pdfviewer picture boxes before colstarts
  * Ensure rectangles in pdfviewer are closed off
  * Fix pdf_viewer picture loading?

Bug fixes and Improvements in 2.8.7 (9 May 2025)
  * Add UI languages (AI-drafts) for: Burmese, Hindi, Korean, Malayalam, Thai, Tok Pisin
  * Added .tex codelet to Other button to start book on an odd page
  * Prevent crashing due to a bad picture \fig parameter
  * Clarify some things in technical reference, and document some macros
  * Add code to differentiate between structural and non-structural char markers in notes
  * Solve crash with usfm3.1 and nonpublishable notes
  * Update Crowdin localizations
  * Fix Start books on odd page typo
  * Create StyleType and TextType from mrkrtype when creating a new marker
  * Include blank lines in cutout calculations

Bug fixes and Improvements in 2.8.6 (8 May 2025)
  * Restore notes to previous state when there's a rejected chunk
  * Solve lost text on rejecting a galley
  * Keep Fontsize and Baseline spacing in sync with Diglot L in polyglot
  * Prevent polyglot L linespacing and fontsize from corrupting primary settings
  * Refactor to new usfmtc api
  * Make sure resetToInitValues clears out polyglot settings and variables
  * Fix Glossary filtering (removeGlosses by doc)
  * Update direct tr@ceout call
  * Make providing DiglotXFraction optional

Bug fixes and Improvements in 2.8.5 (2 May 2025)
  * Make unlabelled pictures be L in diglots
  * Improve background color options for polyglot setup
  * Add support for polyglot caption choice 
  * Ensure the Dialog Title gets updated when polyglot values change
  * More diglot picture update code
  * Handle adding and removing diglot views with regard to pictures
  * Don't use xdef when storing periphs
  * Don't try to interlinearise outside doc chapter ranges
  * Fix missing interlinear folder in archives
  * Fix polyglot interlinear settings
  * Fix polyglot piclist changes to code or config
  * Fix getting pictures in both glots of GLO
  * Fix Donebooks polyglot issue

Bug fixes and Improvements in 2.8.4 (29 Apr 2025)
  * Dont run paragraph triggers for milestones with blank/lost attributes
  * Fix preview right-click bug
  * Sort out GLO for polyglot
  * Fix diglot int file processing
  * Fix paths in diglot files

Bug fixes and Improvements in 2.8.3 (26 Apr 2025)
  * Speed up pdf viewer page switching
  * Automatically fill in plugin name for polyglot
  * Don't spit out inter peripheral project books twice
  * Fix diglots with swapped sides (#1073)
  * Fix NoneType bug in layout

Bug fixes and Improvements in 2.8.2 (22 Apr 2025)
  * Fix issue with packaging usfmtc module (for \f* issue and other fixes)
  * Reconfigure @parlen reporting to help python identify pars

Bug fixes and Improvements in 2.8.1 (20 Apr 2025)
  * New feature: Polyglot (more than 2 texts) is now possible (via the Diglot tab)
  * pdf_viewer improvements for diglots and polyglots:
    * Right-click to change styles and settings in any of the project-configs
    * Option to display Paragraph boxes
  * Fix 'mirrored' view-swapping in multipage polyglots
  * Get background colours to work in polyglot
_____________________________________________________________

Bug fixes and Improvements in 2.7.38 (17 Apr 2025)
  * Fix some stylesheet-handling errors
  * Fix usfmerge2
  * Fix template to hide coverpage when not needed
  * Add telemetry to find why fonts sometimes reset to 1

Bug fixes and Improvements in 2.7.36 (2 Apr 2025)
  * Switch from OccursUnder to Mrktype for styles
  * Add mrktypes to ptx2pdf.sty
  * Cope with active chars/spaces in running headers
  * Don't localize paper size settings on finishing tab
  * Make display of Paragraph Boxes user-configurable in Preview Panel
  * Include changes file "sections()" in TechRef
  * Tidy up and add Standalone Milestone
  * Add Mac fonts list to fonts.conf (work in progress)
  * Don't remove normal chapter numbers in stripChVs
  * Extra font config in archives, so that directly running the tex file doesn't moan about missing fonts
  * Fix grid lines with cropmarks
  * Fix strip empty ch.vs and ellipsis
  * Fix paragraph identification when k is not first in para (MH)

Bug fixes and Improvements in 2.7.35 (28 Mar 2025)
  * Make per-book OmitChapterNumberRH booleans, so rangeref etc works properly (#1054)
  * Ensure latest usfmtc code is being used in build (.33 and .34 used stale code)
  
Bug fixes and Improvements in 2.7.34 (27 Mar 2025)
  * Prepare to make code snippet searches switch window
  * Fix poetry special measures to revert correctly
  * Don't allow Page Size to be translatable
  * Improve user feedback when Anchor Ref is missing
  * id in a diglot only resets it own side's chapter number
  * Synchronise log formats between ptxprint and usfmerge script

Bug fixes and Improvements in 2.7.33 (26 Mar 2025)
  * Picist fix - make sure piclist is deleted when all pics are deleted
  * Add rectangle overlays to help move them
  * Switch usfmtc dependency from pypi to github
  * Fix several minor bugs
  * Fix adding pictures

Bug fixes and Improvements in 2.7.32 (25 Mar 2025)
  * [Built against usfmtc 0.3.4]
  * Fix parpicstart in diglot
  * Add attrib support to usxutils
  * Fix overfull pages (affecting study Bibles)
  * Fix notelines, picture problems, scored merging

Bug fixes and Improvements in 2.7.31 (24 Mar 2025)
  * Replace underlying USFM parser with a new USX-based parser
    [Built against usfmtc 0.3.3]
  * Adjlists (context menu changes) work with indexed paragraphs e.g. q2[2]
  * GLO word adjustments now working as expected
  * Modified option to 'Pagebreak on all other chapters'
  * Allow pagebreak at start of body-text (PBOnBody)
  * Make BorderColor stick
  * Re-instate the red-X Close button on the PDF Preview dialog
  * Fix issue 'failure when using forward slash' #1060 and similar
  * Get interlinear doing pre chapter headings (1:0)
  * Fix tending to categorise as footnotechar instead of char
  * Fix RTL hbox header left/right content
  * Fix showing PDF overlay on indexed paragraphs

Bug fixes and Improvements in 2.7.29 (14 Mar 2025)
  * parse the whole of parlocs file (don't early return)
  * Make sure other PDFs don't crash due to lack of parlocs file
  * Add ptxstats report script
  * Fix guidelines headers
  * pdf_viewer resilience

Bug fixes and Improvements in 2.7.28 (12 Mar 2025)
  * Add width to insert rule codelet
  * Footnote glossary work-around, and backslashed-slash
  * Fix - only add to anchormap if 'anchor' key exists in p (PR#1053 n8marti)
  * Escape any slashes in glossary footnote contents
  * Improve glossary-entry finding regex
  * Recover pre-section title (etc) spacing
  * Add in margin scope gridlines
  * Add another Grid option for 'In Margin Areas' and rename the Text Area option
  * Get Guides working for RTL as well
  * Get left and right pages working for gridding in pdf_viewer
  * Keep going if no parlocs file
  * Fix unbalanced gutters
  * Add gridlines to viewer
  * Move guidelines to being drawn only in the viewer

Bug fixes and Improvements in 2.7.27 (1 Mar 2025)
  * Fix missing stylesheets after folder moved (usfm_sb.sty was missing)
  * Don't stick everything in the internal config of the pdf
  * Choose a grid line colour that works in B&W
  * Ensure that full pages encountered by sppb go to onecol for proper handling
  * Solve bug where a \rem as the last line of a USFM file caused a crash
  * Update test standards and add more tests

Bug fixes and Improvements in 2.7.26 (26 Feb 2025)
  * Delete old/redundant ptx2pdf and xetex folders prior to installation (.iss file changed)
  * Adjusted the venv installation example to have the [gui] optional dependencies #1047
  * Fix verse numbers in tables (tables are not footnotes, no setting the innote flag)
  * Fix pnums typo - affecting page navigation
  * Give friendly error message to docker users, et al.
  * Add a bunch of common fonts to docker image
  * Dockerfile must have Unix-style lf line endings
  * Create docker-image.yml
  * More docker image shaving (780MB)
  * Optimise docker image size a bit

Bug fixes and Improvements in 2.7.24 (20 Feb 2025)
  * Allow scroll wheel beyond edge of page to navigate page numbers
  * Modify insertion of tatweels to allow multiple locations and longer texts
  * Perhaps fix windows font caching
  * Shrink docker image by cleaning up apt cache
  * Add Dockerfile
  * Add cache dir logging
  * Various buglet fixes
  * Put setup.py back

Bug fixes and Improvements in 2.7.23 (19 Feb 2025)
  * Add tatweel rule generator dialog
  * Change tatweel shortcut key Ctrl ` to accelerate.py with other shortcuts
  * Get Windows build working again after major refactor
  * Get packaging working again (paths etc.) for windows
  * Change show_pdf to use page index
  * Hide 'annot' until we can use it for something helpful
  * Now show the verse the mouse clicked inside
  * Make sure that even the unchecked c_ labels get bold applied if not default
  * Get paths sorted out for pypi and dev. pyinstaller might work
  * Refactor pyproject packaging to remove need for symlinks
  * Tidy up TeXpert options which weren't being added to .tex file
  * Tidy up if grid settings
  * Perhaps capture xetex run output in debug
  * Replace Tahoma with Lato
  * Update standards
  * Why disable pdf generation for testing?
  * Fix styleeditor reading floats with comments
  * Refactor for pypi packaging

Bug fixes and Improvements in 2.7.22 (14 Feb 2025)
  * Updated information about Ubuntu package as well as steps to install from source
  * Added missing dependency and removed outdated docstring
  * Get refs working properly for SpeedSlice
  * Change name of PDF-asset to: A5 section head border-RTL-taller.pdf
  * Fix missing paragraph rects before pictures in pdf viewer
  * Fix tests trying to load visual display
  * Add missing file for tests
  * Fix regression on _diff.pdf production
  * Fix jump to reference in Paratext 

Bug fixes and Improvements in 2.7.20 (8 Feb 2025)
  * Ensure prev+next undefilled page buttons are active from the start after printing
  * Resize the main settings window to the same size it was when last closed
  * Activate SpeedSlice (experimental feature)
  * Fix RTL PageUp+PageDn going the wrong way
  * Fix page navigation (again) allowing page number to be typed in

Bug fixes and Improvements in 2.7.19 (7 Feb 2025)
  * Enhance PDF Preview UI, and save 'Auto-update' and 'Book View' settings in user config
  * Enhance 'Reset Adjustments' to have more options: Para, Column, Page, or Spread
  * First attempt at remembering window sizes, positions, and monitors (Win32 only feature)
  * Improved context menu layout (grouping shrink options, and expand options)
  * Add Auto-Update delay and Advanced > Other option to modify default val (3sec)
  * Add button to bring main dialog (settings) to front
  * Allow digits in any script when adding non breaking spaces
  * Another attempt to prevent references from breaking away from bookname
  * Move Rules, Guides and Grid settings to PDF Viewer and TeXpert; Cropmarks to Finishing tab
  * Get Guides and Baselines and Grids working properly again
  * Disable default \par in generating graphpaper, notelines
  * Add SpeedSlice to allow faster updates to PDF when paginating in Preview pane [unreleased]
  * Fix rects after pictures [MH]
  * Fix immediately update ref after changing picture anchor to prevent crashing
  * Fix Fallback font not handling smart quotes

Bug fixes and Improvements in 2.7.18 (3 Feb 2025)
  * Fix regression with pgpos not working
  * Prevent Index Errors while navigating in PDF previewer

Bug fixes and Improvements in 2.7.17 (1 Feb 2025)
  * Allow stretch and shrink (text) in GLO paragraphs
  * Fix navigation tooltip regression (next/prev/first/last)
  * Allow selecting and deleting multiple rows in AdjLists
  
Bug fixes and Improvements in 2.7.16 (31 Jan 2025)
  * Allow right-click DEL AdjList rows; and reset Para removes the row as well
  * Improve RTL UI for prev and next underfilled pages
  * Swap pg navigation button behaviour and tooltips for RTL PDF with non Arabic UI
  * Fix page indexing bugs and improve tooltip for prev and next undefilled page
  * Move btnSensitivity to pdf_viewer, get add_hints working again
  * Fix xo and fr to be no-break space after
  * Clean up context menu
  * Handle pdf page numbers if no parlocs
  * Put the paragraph number on the context menu
  * Refactor continuing paragraph after a picture
  * In pdf viewer introduce current_index to parallel current_page
  * Fix page number on pdf viewer context menu
  * Fix handling out of range page indices
  * Add usfmutils unit tests and fix abarent parlen between pages
  * Add PTXPRINT_OPTS and --diffdpi

Bug fixes and Improvements in 2.7.15 (24 Jan 2025)
  * Use right font in Preview contents (index) pane
  * Get zimagecopyrights working again (by handling ./tmpPics/)
  * Make Peripheral page numbers start with -1 and count down
  * Advance pages in pdfviewer by folio number
  * Handle folio numbers in pdf viewer
  * Add prev issue button and handle peripheral PDF offsets
  * Make prev-next issue buttons only active when applicable
  * Fix startup bug if no MyParatextProjects folder found
  * Refactor tests to include archive creation
  * Fix missing icon for find prev issue in Preview pane
  
Bug fixes and Improvements in 2.7.13 (22 Jan 2025)
  * Happy New Year! update About... info to 2025
  * Vastly improved right-click context menu in PDF viewer for text AND pictures
  * Add ability to change anchor ref via context menu
  * Add right-click option to Send Ref to Paratext, to make it scroll to current para
  * Add auto-update PDF option to preview pane (prints right after context menu change) 
  * Improve page and zoom controls in the PDF viewer
  * Don't enable both contextual spaces and letter spacing
  * Add support for \ib and Allow it to be styleable i.e have different dimension to b
  * Add more @parpicsize output locations
  * Add \slash
  * Simplify color bars (LHS=shrink, RHS=expand, blue=lines, red=text)
  * Fix adjustment color bars being offset by a front PDF attachment
  * Fix col initial images not selectable when in continuation paragraph
  * Fix tex macros picsize typos
  * Fix piclists and make it more responsive
  * Don't check graph paper line thicknesses, as its unlikely to be professionally printed
  * Move parlocs open to onetimesetup

Bug fixes and Improvements in 2.7.12 (18 Dec 2024)
  * Fit PDF to window size after showing PDF
  * Fix bold on fonts
  * Fix font and footnote removal
  * Fix font defns in .tex file
  * Fix not printing footnotes
  * Fix minor typo causing a leak of digits on output
  * Set min Font size to 0.1 and default to 1.0 in UI
  * Fix various little crashes
  * Fix \resetautonum

Bug fixes and Improvements in 2.7.11 (17 Dec 2024)
  * Fix bugs in Style Editor related to font settings and display
  * Enable cover and diff PDFs to show up in the Preview Pane
  * Add docs/help/fonttag.md to help people decode font tags
  * Differentiate between end-headings and normal ones
  * Swap default action when meeting very rare diglot condition
  * Ensure that \@parpicstop (in parlocs file) is giving sane IDs for sidebars
  * Fix implicit closing of boxed styles (for footnotes and xrefs)
  * Fix mapins for style edits
  * Update README.md to remove redundant date of last update info

Bug fixes and Improvements in 2.7.9 (13 Dec 2024)
  * Fix missing icons - esp in File Save As dialog, and update UI tooltips etc.
  * Bad copyrightInfo in gtkpiclist
  * Prevent exceptions when reading parlocs files
  * Get better parpicstops in parlocs
  
Bug fixes and Improvements in 2.7.8 (12 Dec 2024)
  * Start towards a right menu for figures
  * Fix not checking far enough back in pars into the previous page
  * Various fixes for diglot pdf viewer
  * Fix crashing if trying to import from non existent pdf
  * Fix fontsize in style editor

Bug fixes and Improvements in 2.7.7 (11 Dec 2024)
  * Add Save As button and a few others to Preview Pane
  * Don't allow 0 linespacing
  * Get font changing working in the style editor
  * Make adjlist more resiliant to bad references
  * Make parlocs more resiliant to maps and full page stuff
  * Add missing icons for home and desktop in filechooser
  * Support sections(periph,intial,default,adjust,final,merged) in changes.txt
  * Only show context menu if ref contains : or .
  * Add option to Edit Style \fig to context menu for pictures
  * Add mirror options for context menu [unactivated]
  * Add Talu scriptsnippet
  * getstockitems now checks different extensions

Bug fixes and Improvements in 2.7.6 (6 Dec 2024)
  * Don't put code in the PDF bookmark
  * Get insert pic from Catalogue working again
  * Add a spinner to the PDF Preview Pane to show when it has finished updating
  * Fix book codes in the pdf toc
  * Add Color of NoteLines option to Layout page
  * Fix colours of pdf in pdf_viewer
  * Make context menu options localizable (and update FR)
  
Bug fixes and Improvements in 2.7.5 (5 Dec 2024)
  * Fix prevowels in Bengali
  * Improve Help page links; re-instate open Output PDF folder.
  * Make sure Right-Click context menu items are localizable
  * Fix missing parlocs in pdf_viewer
  * Add links to Ornaments Catalog and Technical Ref documents
  
Bug fixes and Improvements in 2.7.4 (4 Dec 2024)
  * Allow starting new book on current page
  * Make printer settings more resiliant
  * Micro refactors to open things up a little
  * Fix odd behaviour with column notes
  * Improve mini and basic view UI and fix +-0 bug related to interactive pdf
  * Fix a fix that was a bad fix for a fix that was needed and is now fixed (texpert)
  * Fix bugs, start support for \usfm version-defined behaviour
  * Crowdin localization sync

Bug fixes and Improvements in 2.7.3 (2 Dec 2024)
  * Various fixes to get the PDF Preview pane and interaction working better
  * Fixed texpert c and v spacing factors

Major new features in 2.7 (30 Nov 2024)
  * A built-in PDF Preview pane to view the output of PTXprint
  * Interactive right-click context menu for making layout adjustments
  * Option to send a PDF to the printer - 'Print (on paper)' in PDF viewer

Other features and improvements in 2.7
### PDF Viewer Enhancements
  * Add page or spread counts
  * Show in: actions can now be reinitiated (to re-open preview pane)
  * Get the PDF viewer to resize properly
  * Ensure PDF viewer is available even for mini View and Basic view
  * Get PDF viewer TOC working
  * Add treeview for PDF outline; change zoom to spinner
  * Add diglot support to PDF viewer right-click
  * Change PDF viewer on book change
  * Track changes enough to allow PDF viewer switch on book switch
  * Refactor PDF viewer load-n-show
  * Refine the PDF viewer context menu options
  * Add items to context menu for interactive PDF
  * Refactor PDF viewer menus to stop temporary window errors
  * Tidy up after action events

### Scrolling and Zooming Enhancements
  * Speed up zooming
  * Use a timer instead of a thread for zoom
  * Refactor PDF zoom to perhaps work in Windows
  * Dumb down the zoom for non-forking windows
  * Make PDF scroll wheel zooming even smoother
  * Get scroll-zoom working properly on both sides of a spread
  * Make scrollwheel trigger PgUp and PgDw if v_adjust is NOT active

### Interactive Adjustments & Context Menus
  * Debug interactive adjustments
  * Add middle click drag on viewport
  * Get smart right menu up in PDF viewer
  * Adjust changes so that if a reference is in a range, match the range
  * Refine the context menus and make it easier to reset paragraphs
  * Add feature to jump to a paragraph's style in the Style Editor
  * Support subverses

### AdjList & Diglot Adjustments
  * Sort out adjlist for diglots
  * Various adjlist fixes
  * Add comment field to adjlist
  * Link adjlist_changes.txt file to texmodel
  * Modify parlen string to ease parsing (and revert as needed)

### Styling & Display Refinements
  * Swap expansion color
  * Change adjlist color bars
  * Apply boxes to styles more selectively and with improved logic

### Note Handling Improvements
  * Recognize note-in-note message
  * Refuse to start note-in-note. 
  * Warn of end-of-note outside one to avoid crashing
  * Reset footnotes for modules. 

### General Improvements
  * Unify OS file starting
  * Apply minor changes to get things working on a Mac
  * Only display startup the once

### Bug Fixes and Debugging
  * Fix adjustment changes file being read
  * Fixups for pdfview overlay
  * Fix lowercased keys in styleeditor
  * Avoid crashes with unfinished notes slurping up verse text
  * Debugging info coloring
  * Handle stretchable line spacing in PDF viewer
  * Make sure switching projects or configs doesn't dirty the project config
  * Fix missing _1 versions due to file being held by preview pane
  * Fix crash on writing new config

### Miscellaneous
  * Add "CC BY-SA" license to the list of available choices and link to CC site in tooltip
  * Add insert option to 'getinfo'
  * Use 'c@rref' in 'parlocs' file
  * Solve various issues with glue in baselineskips

Bug fixes and Improvements in 2.6.11 (16 Nov 2024)

  * Look everywhere for _PTXprint and _projectsByGuid

  * Refactor for saved projects

  * Fix bleed on back cover of RTL book

  * Ensure that page is printed before makecover starts

  * Fixup minor bugs preventing archives from being created

  * Fix cover behaviour

  * Fix textproperties no longer being a set in gtkstyleditor

  * Part-way fix for diglot covers

  * Make cutout positions more robust

Bug fixes and Improvements in 2.6.10 (4 Nov 2024)

  * Handle C: type directories in projecdirs list in config

  * Fix creating shared dir and VersionStr

  * Fix messed up reading of 1= type projectdirs

Bug fixes and Improvements in 2.6.9 [release withdrawn] (1 Nov 2024)

  * Fix keyword headings (in glossary)

  * Fix exclusive picture folders (#984)

  * Improve diglot archives

  * Tech: Define addtohook

  * Tech: Add prefixhook macros

  * Tech: Don't save marks EVERY call to calcavailht, but do save all of them

  * Get from DBL to print path working

Bug fixes and Improvements in 2.6.8 (22 Oct 2024)

  * Add in margin marginal verse controls

  * TeX process sholdn't crash if given a fractional paragraph offset, just moan.

  * First steps to better 1-2 column transitions (\goone and \gotwo)

  * Add codelet for 1-column poetry toggle

  * Add a couple of codelets: page num on title page; debug tracing

  * Fix writing picchecks and picinfos to the right directories

  * Allow cutouts in piclists to have smaller increments 2 dec places 

  * Prevent notes breaking from images

  * Add paragraph badness to parlocs (parend)

  * Add an example tex snippet for GLO headers (work in progress)

  * Start working on pdfinish app (work in progress)

  * Refactor for separate finishing; 

Bug fixes and Improvements in 2.6.7 (19 Oct 2024)

  * Fix empty usfm2 fig fields

  * Fix blowing up if partial page filled; layout versioning of orphans

  * Allow control over the end of paragraph orphoan protection word length

  * Refine mkptxunicode

  * Fix bidi digit processing

  * Solve the immediate problem of galleys ending in skips which cause EEKs

  * Fix table row margins

  * Get consistant output with or without leaders

  * Minor UI improvements

  * Fix shaving notes with gluey baselineskip

  * Keep element annotations (nested, etc.) when copying elements when processing usfm docs

  * Fix LTR tocs for RTL diglot

Bug fixes and Improvements in 2.6.6 (4 Oct 2024)

  * Figure inclusion / triggers: obey paragraph numbering for start-of-paragraph figures

  * More picture cleanups + fixups for Piclist refreshing

  * Add sethook{after}{final}

  * Add model pausing GtkPiclist (to speed up refreshing list)

  * Switch the Piclist when Diglot is (un)selected

Bug fixes and Improvements in 2.6.5 (3 Oct 2024)

  * Fix colophon for single columns

  * Tidy up URL // slashes and fix tooltip for Chapter Label

  * Setup serial diglots properly

  * Improve codelet(s) for Note Lines

  * More work on notelines (texpert tab)

  * Finish adding Notelines UI items, set sensible defaults and units

  * Fix diglot picture loading

  * Fix picinfo bugs

  * Fixing diglot generate pictures

  * Catch looping for overfull page

  * More tweaks and fixes to get pictures working

  * Handle page abort conditions

  * Improved piclist generation and no zfiga for k

  * Fix strongs fallback project

  * Fix withvars and code around crazy path.relative_to

  * Merge branch 'refactor' (and Remove old code)

Bug fixes and Improvements in 2.6.4 (30 Sep 2024)

  * First stab at rules for note-taking
  
  * Improve NoteLine processing

  * Fix archive generation and changeLabel

  * Improve k para counts in piclists

  * Fix pic numbering preventing duplicates

  * Piclist to load BOTH L and R

  * Make xdv reading in archive creation resiliant

  * Handle missing .xdv file when making archive

  * Fix path and unf issue

Bug fixes and Improvements in 2.6.3 (27 Sep 2024)

  * Fix texborder space calculations. 

  * Add piclist refactor (unstitched code)

  * If no grid then stretch text to fully fill the space above the notes

  * One col fill page if no grid

  * Don't crash with poor setup (if missing Projects folder arg)

  * Suppress bookend-hooks if no \id line, not no \h line

Bug fixes and Improvements in 2.6.2 (24 Sep 2024)

  * Introduce a inp@gegap which puts only one vfil on a page

  * Obey ifFinalNotesDown in single column output

  * Fix TOC alignment for RTL (again!)

  * Have texpert hacks bold check buttons if changed

  * TeXpert hacks can now autoreset (spinners and checkboxes)

  * Fix TeXpert Adv-Other options to work, and to reset

  * Fixup some TeXpert hacks to fit with the macros

  * Fix PageFullFactor setting

  * Crowdin localization sync

  * Fix picture import for diglots

Bug fixes and Improvements in 2.6.1 (17 Sep 2024)

  * Fix unhandled exception when switching UI level

Bug fixes and Improvements in 2.6 (16 Sep 2024)

  * NEW FEATURE
      Introduce Variable Line Spacing option and Fill Columns (on Layout Tab)
  
  * Improve Tooltips and fix UI interaction surrounding Unbalanced Columns
  
  * Move all TeXpert hacks to 'Other' tab of Advanced page
  
  * Ensure highlight of texpert labels works when searching
  
  * Don't exit if we can't open the selected project on startup
  
  * Dataclasses backported for python 3.8
  
  * Revert adjusted sidebar and figure positionings to layout v3
  
  * Fix poetry and drop chaps in layout v3
  
  * Diglot-related book-end fix for ht=0, dp>0 boxes
  
  * Fixup custom.sty path for secondary in .tex
  
  * Fix go round data gathering in ptxprint (#978 configId error)
  
Bug fixes and Improvements in 2.5.12 (2 Sep 2024)

  * Add off-grid setting for single column
  
  * Add double-column support for NoGridtrue
  
  * Between hooks for transition to table
  
  * Make letterspace on the secondary project come from secondary settings

  * Stop UnderChar from breaking things
  
  * Put back vertical justification for single column
  
  * Remove interchartokenstate stack for Bidi controls since Arabic is supported now
  
  * DEB info file generator needs to handle 3 Ubuntu versions now
  
  * Fix modules to only include what is asked for. Add c to the \inc list
  
  * Fix rounding .2f down to 0 for inter char spacing
  
  * Fix glossarydepth control and minitests example
  
  * Don't squeal during typing a reflist in the book list
  
  * Don't delete the output file before we have an opportunity to copy it away to _1
  
Bug fixes and Improvements in 2.5.11 (27 Aug 2024)

  * Fix editor pages and files to at least not corrupt
  
  * Fix import project

  * Remove redundant os.path.join to create project path

  * Change fallback to font to one we have

Bug fixes and Improvements in 2.5.10 (26 Aug 2024)

  * Fix issue with Create Archive and update title

Bug fixes and Improvements in 2.5.9 (26 Aug 2024)

  * Allow for 3 Settings tabs in View+Edit for 2x changes.txt files when creating Diglots

  * Add blue=left; red=right and green shading to 3 settings tabs when diglot in use
  
  * Adjust background colors and add background shading for FRT=yellow and AdjList=purple

  * Refactor to enable multiple project folders and duplicate IDs using guid-based projects

  * Switch texmode /ptxpath to include prjid, add /ptxdocpath

  * Fix writing projectdirs to config

  * Fix handling of new configs
  
  * Fix guid reading from settings.xml

  * Fix bug with zcustommarks

  * Refactor DBL expansion, and add \ref support

  * Enable Underline with characters

  * Improve docs, handle character underline better.

  * Fix usfm parser for standalone z markers

  * Update path to USFM documentation online

  * Refactor glossary calculations

  * Fix ColAdjskip for diglots

Bug fixes and Improvements in 2.5.8 (16 Aug 2024)

  * Fix reading fonts from xdv file
  
  * Fix fonts and images into archive
  
  * Get Sidebar Size and Position dialog with preview working
  
  * Fix style editing if there is no main font
  
  * Solve colour leakages
  
  * Downgrade version number for figure layout to 2.
  
  * Fix ref for paragraphs in modules
  
  * Fix archiving crash
  
  * Fix archive generation for diglots
  
  * Fix module generation & Put \c back in module output
  
  * Add (and fix) a module test. Update standards
  
  * Include TeXhacks in widget search
  
  * Non-UI portion of chained glossary items (#633)
  
  * Work around USFM 3.0 data model to get modules mostly working
  
  * Diglot book-end code needs to actually be reached
  
Bug fixes and Improvements in 2.5.7 (10 Aug 2024)

  * Fix TOC wrapping and layout for doublecolumns
  
  * Fix RTL tables
  
  * Make paragraph-based positioning work in top-of-page sidebars
  
  * Improve error msgs around failed AdjList
  
  * Add missing Pic position options. start UI for esb positioning
  
  * Fix paragraph counting for pgpos="pcN"
  
  * Protect pic position changes with version check
  
Bug fixes and Improvements in 2.5.6 (8 Aug 2024)

  * Add option to protect existing PicList settings when (re-)generating 
  
  * Enable table entries to span multiple columns
  
  * Disable (initial) verse nums (on Body tab) if Move (end of) Ayah is enabled
  
  * Removed Tracing from Advanced Tab (available through TeX Code Snippets instead)
  
  * Solve end-of-2cols multi-run issue
  
  * Don't force blank pages when we just want to end partially full ones
  
  * Fix accumulate missing from hyphen.py (#970)
  
  * Fix getting al the right fonts into the ZIP archive
  
  * Fix styletype of missing markers being None causing problems
  
Bug fixes and Improvements in 2.5.5 (29 Jul 2024)

  * Improve diglot note positioning
  
  * Enable processing of \k with attributes (#958)
  
  * First steps to resolve double-bounce "INTERNAL ERROR" state
  
  * First steps to support interchar spacing for Arabic
  
  * Include Mongolian as an arabic script even if it is LTR
  
  * Update Crowdin localizations
  
  * Add macros path to fonts (for mappings) when using system fonts
  
  * Don't save empty editing panes (prevent Front Matter from being wiped)
  
  * Fix \inc in modules (enabling footnotes and xrefs to show up again)
  
Bug fixes and Improvements in 2.5.4 (23 Jul 2024)

  * Add option of annotated borders (for maps)
  
  * Fix noUpdate looping
  
  * Add default GLO styling for \p 
  
  * Add a codelet for emdash after \k* in GLO
  
  * Minor crash fixes
  
  * Improved standard borders
  
  * Fix some errors in map borders
  
  * Update ornament catalogue
  
  * Enable hboxed character styles in figure captions and image credits (#976)
  
  * Fix headings detaching when theres a note on them
  
  * Backport typing in texpert to 3.8
  
  * Fix minor typo bugs preventing Create Archive from working

Bug fixes and Improvements in 2.5.3 (18 Jul 2024)

  * Fix texpert config loading to set defaults
  
  * Implement figure borders and SpaceBetween control for caption placement
  
  * Fix non paragraphed notes in tables
  
  * Fix unwarranted movement of figures
  
  * Tidy up some bits of ornament code
  
  * Fix bottom margin display value when placing footer above bottom margin
  
  * Add w and zglm shortcuts to Glossary area
  
  * Improve FRTtemplateAdvanced to make it easier to use
  
Bug fixes and Improvements in 2.5.2 (13 Jul 2024)

  * Update SideBars.md
  
  * Solve diglot bookmarks
  
  * Make book end decoration behave better
  
  * Added codelet for end-of-book decoration to apply to all books
  
  * Suppress textborder if no bodytext since last switch to single/double column
  
  * Maybe solve occasional double-textborder on last page
  
  * Correct marginnotes to be resistant to multi-loading
  
  * Fix parser to output conforming footnote strings
  
  * Improve shorkcut key behaviour to allow toggles
  
  * Remove empty f|ef|fe|x
  
  * Clear buffers when switching views so that FRTmatter doesn't get clobbered
  
  * Process single->single transitions better for textborder
  
  * Fixes for python 3.12
  
  * Add texpert/usesysfonts to allow disable use of system fonts
  
  * Improve interaction surrounding installation of Image Sets and other .zipped image files. 
  
  * Make Cover page call more robust, especially for Diglot
  
  * Add column background colours for diglots
  
  * Fix known problems with coloured diglot backgrounds
  
  * Tidy up non system fonts.conf
  
  * stick a plaster over Path again
  
  * document RangeChar et al
  
  * Work around buggy pathlib in v3.12 of python
  
  * Add bypass alpha for diglot shading
  
  * Tweak DiglotColourPad default and add control to TeXhacks
  
  * Include all fonts in archive and clear usesysfonts
  
  * chapter line footnotes (#962)
  
  * Fix pesky 3.12 breaking backward compat with pathlib and get test working
  
  * Fix mappings directory and tests
  
  * Ensure chvseparator=true > colon and false > period in versionFwdConfig
  
Bug fixes and Improvements in 2.5.1 (3 Jul 2024)

  * Refactor PicList generation for GLO book (not to use para numbers)
  
  * Get Adwaita icons working on new TC Win 10 build agent (manage our own icons)
  
  * Fix left margin in tc1 for example and update some test configs
  
  * Update WinDevEnvSetupGuide.md added mingw-w64-x86_64-adwaita-icon-theme
  
  * Guard v2 on no forced page break if intro missing
  
  * Add bookstartpage to TeXpert hacks
  
  * Add IntroPageAlign and PageAlign defs and texhacks
  
  * Fix post intropages page insertions
  
  * Don't crash if the diglot project doesn't have the config
  
  * Extra macros for ranges (#955)
  
  * Add background gray for diglot secondary in adjlist
  
  * Solve periph group not closing (fix for out of memory issue)
_______________________________________________________________

Version 2.5 release summary: (changes since last major version 2.4)

There are 2 significant changes in this version of PTXprint which you need to be aware of:

(1) Changes have been made to the underlying XeTeX macros which will improve the layout of the text, particularly footnotes. However, these minor changes could cause the text to flow differently, which is not ideal if you are part way through a typesetting project. To help maintain backward compatibility, a system has been introduced which enables you to Lock the XeTeX Layout engine to a previous level. So if you need to revert to the previous XeTeX layout then take the following steps:
      (a) Enable the option (on the Advanced tab) "Lock XeTeX Layout Level"
      (b) Enable the option "Show TeXpert Hacks"
      (c) Switch to the "TeXpert Hacks" tab
      (d) Set the "Maximum Layout Version" to 1 (down from 2) at top of list (0=latest)
Doing this should cause the text to flow exactly as it was in previous versions.

(2) In order to keep up with underlying software changes (Python 3.11+) Regular Expressions are now stricter. You must ‘escape’ any \ backslash codes with an additional \ in your changes.txt rules. So for example, a rule like:
    "\p" > "\m" will need to be 'fixed':  "\\p" > "\\m"
But notice that you only need to add the \ to escape USFM codes, not all the other valid codes like \r \n \1 \2 and so on:
    "(\\id (...).*\n)" > "\1\\h1 \2\r\n"
_______________________________________________________________

Significant New features:
  * Text Borders (dynamically generated) can be set up with a few clicks (Tabs+Borders)
  * Enable diacritic colouring (primarily for decorating Arabic script)
  * Added 'Give Feedback' button and link to Google user survey form

  * Improved Global Options tab on the Pictures Page
  * Added functionality to pre-populate Google Forms before submission:
    a) Request hi-res illustrations from SIL's repository of illustrations and maps
    b) Get Permission to use (primarily) David C Cook illustrations
  
  * Import/unpack configuration settings is much more powerful
    ** You can now set the TARGET of import/unpacking of settings
    ** Enable importing from PDF/ZIP to a new/different config
    ** Allow extracting settings to a folder
    ** Added more import categories and also allow "Import Everything"
    ** Auto-detect main project from a diglot archive

  * Table of Contents improvements
    ** Fix RTL and LTR Table of Contents generation and improve leaders
    ** Make toc leaders "fully" stylable
    ** Define toc fill in context, not before
    ** Allow disable TOC writing

  * Significant improvements to how hyphenation works
    ** Allow letter-spaced text to be hyphenated
    ** Added option to force hyphens (in text) to be non-breaking

  * Added Lock XeTeX Layout (retains backward compatibility to a particular
    Maximum Layout Version to ensure stability from layout-altering changes)

  * Added Lock UI Layout (stop accidental changes to layout settings
    fonts, and styles while doing final page layout)

User Interface improvements:
  * Make sure correct View Level (Mini, Basic, Full) shows at startup
  * Provide status message with list of unfilled pages
  * Added shortcuts keys for editor (^d=Duplicate, ^l=deLete line, ^i=shrInk, ^1-9=grow/shrink)
  * Added control for position of drop-cap chapter numbers
  * Add UI controls for note multipliers
  * Add example of non-contiguous verses in a chapter for setting of the print range
  * Simplify wording on Advanced tab for changes.txt (making it easier to find)
  * Make Quick Run option 'sticky' - keep with user config settings
  * Download program update button now works more consistently
  * Remove image from preview when deleting pictures, and changing configs
  * Internationalize URIs on Help tab via Google Translate
  * Improved error handling for issues in changes.txt
  * Get help directories working on Linux and Windows
  * Improvements for working with AdjLists
    ** New format of generated AdjLists now makes lines easier to edit
    ** Add AdjList syntax highlighting (helps highlight/fix errors quicker)
    ** Check AdjustList for odd input, and emit warning if there's a space
    ** Fix over-full AdjLists (which was losing the end of PSA)

Diglot + Interlinear fixes and improvements:
  * Make UI footnote/xref control work on diglots
  * Solve diglot error with character styles in chapter-level heading paragraphs
  * Improved diglot balancing (\BelowBaselineX)
  * Make pagehooks work for diglots
  * Add punctuation controls to interlinear (on Advanced tab)
  * Add per side IndentUnit in diglots
  * Improve handling of cl in diglots
  * Implement @diglot@pagebreak (correct paragraph break behaviour for diglots)
  * Diglot availht calcs need to consider joint calcs.
  * Trigger side-hooks for mongolot sections of a diglot text
  * Fix gridline-column separator for left-opening (RTL-binding) diglots
  * Fix \cl in diglots
  * Fix diglot cutout continuation problem(?)
  * Fix diglot vertical grid line position (#941)
  * Fix diglot pagebreaking on 2nd page
  
General enhancements:
  * Add Rohg script
  * Improved glossary filtering
  * Nicer defaults for textborder
  * Improve book filenames handling
  * Added shadow and outline effects
  * Support periphs with no ids in INT
  * Better error handling in changes.txt
  * Add more helpful tip to font-related error message
  * Add ink saturation limiting to cmyk pdf generation
  * (re-)Enable INT to be selected from the list of books
  * Make AdjustLists work on separate notes (foototes can be stretched/shrunk)
  * Make vectorian2 play nicer if there are very small text chunks
  * Get accelerator keys working on linux. Make ^1 toggle +1/+0
  * Solve issue on View+Edit tab when a file is not found.
  * Make sure periphs from the INT book are included even if FRT book is missing.
  * Do not save default values when picInfo.txt and picCheck.txt are written
  * Create default settings for scripture refs when unpacking DBL bundles
  * Try to obey PT settings for chapterverse and range separators
  * Cope with spaces in sidebar figure names (Note: affects pics in covers)
  * Add all Book headers as HEADER in merge
  * Make "font" figure size scale to the right fontsize
  * Define \reference to (a) be user-changable and (b) default to using ChapterVerseSeparator
  * Allow custom .py scripts to run with __main__ check
  * Add warning message help for bad copyright statement in tex.log
  * Cope with mt1 on line after an id
  * Improve logic on ommitting chapter numbers
  * Ensure that pagebreak-before-all-chapters doesn't crash regex
  * Refactor changes to include error messages
  * Add missing changes for bookresetcallers (Reset fn+xr callers at each book)
  * Support for footnote sanity checking via parlocs
  * Implement Box/BorderPaddingInnerOuter (note untested for RTL)
  * Treat percent sign as literal in piclist (#912)
  * Ensure figures and local/figures are also in the srchlist for pictures
  * Allow ^ in parents. Stop p^95 occursunder type errors (#925)
  * Implement bookresetcallers and fix some characters / escapes (tilde, backslash, pipe)
  * Improve handling of pics within Intro matter
  * Implement 'H' figure position (cHaracter-like HERE)
    ** To go with 'H', there are 2 new sizes, 'font' and 'line', 
    ** related to the font size and \baselineskip.
  * Minor underfilled page report improvement
  * Fix toc missing L and R side for 'bible' sort

Documentation:
  * Added various help files to technical documentation
  * Add keyboard shortcuts to Technical Reference Manual
  * Mode documentation
  * Add headers example snippet
  * Document new paragraphed notes controls
  * Document diacritic colouring in snippets.md
  * Updated and recoloured ornaments catalogue
  * Document and illustrate most of the new footnote options
  * Direct all More Info... Style links to appropriate documentation sites:
    ** Use recently created official docs site for all USFM markers
    ** And github-docs-help-zfoo.md pages for milestones (zbl, zlabel, zpage, zpmkr, zrule)
  * Add RTF version of AboutPTXprint with warnings and advice about 2.5 upgrade

Technical improvements:
  * Add after book hook as last thing in processing a book before released the id
  * Constrain / -> ZWSP to outside of attributes; Fix / -> ZWSP in scriptsnippets
  * Get \k style marks working
  * Separate out the box-based charstyle tests
  * Allow box-based character styles at paragraph level too
  * Add layout version control over fixing ISBN asymmetry
  * Implement minimum line widths for borders and zrules
  * Exclude variable fonts (need to use static fonts instead)
  * Keep track of how many times user clicks Print (for each config)
  * Avoid problems from id@@@ continuing after end of the book
  * Add labelling of tracing lines
  * Side-dependant numcuts and dropotherlines need to be counts
  * Make utility to get improved division accuracy
  * Various Documentation improvements
  * Chapter numbers should occur on their own line
  * Having + in tag_escapes stops parsing of nested markers, treating them as text.
  * Protect from logger crash on poor pt settings
  * Maybe fix odd interlinear alignment
  * Ensure QR spacebeside attr is a number
  * Make id:GEN|p style font definitions work properly
  * Make custom merge config files work
  * Solve bug with catprefix escaping groups
  * Silently ignore python processing if not present
  * Add resilience in usfm parser
  * Make verse ranges valid link-targets
  * Add more telemetry for page breaking
  * Another tweak to get hyphenation working just right
  * Added t@gging (and stop footnotes blowing up)
  * Add end of book hook when end of book decoration is included (#938)
  * Solve issue of breaking in overflowed notes
  * Improve snippet on diacritic colouring
  * Move bad fonts not switching in UI to environment variable
  * Unmerge note and output routines from paratex2.tex
  * Output bookendrule even when the first thing on the page is a title
  * Control hanging verse at dropcap
  * Implement ifHangVA
  * Correct logic so noteid change applied to non-paragraphed notes
  * Yet another parnotes option; un-break newparnotesfalse
  * Solve #915 potential insert loss
  * Make newparnotes unwrap first box (behave properly with endnotes)
  * Shaving values are now deltas
  * Add tags for figures
  * Make \fp* a noop (related to #813)
  * Add space to ensure multiply vs prefix
  * Add intropages

Issues Fixed:
  * Fix ToC leader bugs, and TOC with no leaders
  * Fix some edge-case wandering footnote bugs
  * Fix ISBN spurious space
  * Fix auto hyphenation
  * Fix Character style colouring
  * Fix table alignment controls
  * Fix nonpublishable UI linkage
  * Fix a bug in zEmptyPage
  * Fix QR bug when there was an = in the URL, make keywords set marks
  * Fix linebreak at \k and Update standards
  * Fix thumbtabvadj in texperthacks to work, rather than print
  * Fix Digital CMYK to actually be CMYK
  * Fix RTL in footnote paragraphs
  * Fix QRcode with numerical pgpos
  * Fix undefined item in sidebar figure placement
  * Fix usfmerge remove problems
  * Fix toc col width issue when > 999 pages in publication
  * Fix broken test cases and solve an error-loop
  * Fix gloss-rb link bug
  * Fix broken link localization with Google translate (not all are possible)
  * Fix RefRange.__contains__
  * Fix moving notes up and down at the end of books
  * Fix accidental centrecolum breakage
  * Fix long-standing bug where centre column refs were stealing space from main text.
  * Fix alignment of book headers
  * Fix codelet to insert book code as \h1
  * Fix problem with \|
  * Fix broken x-edgeadjust in figures, improve figure documentation
  * Fix hard hyphens in hyphenation
  * Fix feedback loop in balanced esp. for pages with a big gap
  * Fix joint of carried over and new notes
  * Fix chapter label dropping chapter marker/number
  * Fix bad image copyrights output to .tex (#929)
  * Fix zfiga bug of extra backslash showing up
  * Fix rangeref with verses off and different books
  * Fix big balancing
  * Fix reference tests after changes to b64codes
  * Fix @ issues with hyphenation and default texpert hacks values
  * Fix CenterColXrefs
  * Fix internotespace if not using newnotepar
  * Fix oldstyle parnotes
  * Fix buggy output templates in changes testing
  * Fix stray intranotespace if there is only one note
  * Fix up footnote callers for layout v2
  * Fix toc missing L and R side for 'bible' sort
  * Avoid lost last partial-page of SFM input
  * Page end textborder kern should only happen when page border in effect
  * Various python 3.12 cleanups (mostly affecting Regex)
_______________________________________________________________

Bug fixes and Improvements in 2.5 (28 Jun 2024)

  * Added Lock XeTeX Layout (retains backward compatibility to a particular
    Maximum Layout Version to ensure stability from layout-altering changes)
    ** Layout Version changed (2) to reduce space above note rules to regain control

  * Added Lock UI Layout (stop accidental changes to layout settings
    fonts, and styles while doing final page layout)

  * Fixed ToC leader bugs, and TOC with no leaders

  * Constrain / -> ZWSP to outside of attributes; Fix / -> ZWSP in scriptsnippets
  
  * Get \k style marks working
  
  * Added shadow and outline effects
  
  * (re-)Enable INT to be selected from the list of books
  
  * Nicer defaults for textborder, and fix a bug in zEmptyPage
  
  * Make vectorian2 play nicer if there are very small text chunks
  
  * Separate out the box-based charstyle tests
  
  * Allow box-based character styles at paragraph level too
  
  * Make AdjustLists work on separate notes
  
  * Fix over-full AdjLists (which was losing the end of PSA)
  
  * Add after book hook as last thing in processing a book before released the id
  
  * Solve some edge-case wandering footnote bugs.
  
  * Fix ISBN spurious space
  
  * Add layout version control over fixing ISBN asymmetry
  
  * Put the trailing space back in m@kenumber, but check usage, and use ns version where appropriate.
  
  * Refactor ifversion to make correction accurate
  
  * Get accelerator keys working on linux. Make ^1 toggle +1/+0
  
  * Better error handling in changes.txt
  
  * Add headers example snippet. Fix auto hyphenation
  
  * Added UI elements to make setting dynamic text borders easier
  
  * Prevent illegal note movement, get adjust list to apply to 2nd par of a non-paragraphed note
  
  * Better first line indent behaviour for notes
  
  * Gain control over 1st and 2nd footnote adjustments
  
  * Correct linespacing of final note when it's adjusted
  
  * Fix internotespace if not using newnotepar
  
  * Fix oldstyle parnotes
  
  * Sort out the ornaments and borders confusion
  
  * Fix buggy output templates in changes testing
  
  * Only correct prevdepth if there is a box there
  
  * Fix stray intranotespace if there is only one note
  
  * Improve UI for Creating Configs (Save As...) and Deleting Configs (Confirm first)
  
  * Do not warn about standalone markers in the stylesheet, as the definition is not getting changed
  
  * Better handling of zgetperiphs and periphs (watch for possible regression as we now process 
    zgetperiph in ptxprint rather than the macros now)
  
  * Reenable default noteparagraphnum
  
  * No indent before a single note
  
  * Up to a limit, caclulted note heights as though raising does not happen
  
  * Minor improvements to AboutPTXprint.txt documentation
  
  * Don't crash if view&edit with no project selected
  
  * Add biba..bibc to list of sort lists
  
  * Enable fontextension on footnotes
  
  * Fix up footnote callers for layout v2
  
  * Get log checking working when finalize changes the pdf name
  
  * Minor underfilled page report improvement
  
  * Improved error handling for issues in changes.txt
  
  * Get help directories working on Linux and Windows
  
  * Add RTF version of AboutPTXprint with warnings and advice about 2.5 upgrade
  
  * Fix toc missing L and R side for 'bible' sort
  
  * Updated and recoloured ornaments catalogue
  
Bug fixes and Improvements in 2.4.22 (4 Jun 2024)

  * Re-work import/unpack configuration settings to be more powerful
    ** Add UI elements for setting TARGET of import/unpack settings
    ** Enable importing from PDF/ZIP to a new/different config
    ** Allow extracting settings to a folder
    ** Added more import categories and also allow "Import Everything"
    ** Updated tooltips for clarification on import settings dialog
    ** Added logic to detect main project from a diglot archive

  * Improved diglot interlinears
    ** First implementation of \BelowBaselineX for diglot balancing
    ** Make pagehooks work for diglots
    ** Add punctuation controls to interlinear (on Advanced tab)
  
  * Table of Contents improvements
    ** Fix RTL and LTR Table of Contents generation and improve leaders
    ** Make toc leaders "fully" stylable
    ** Define toc fill in context, not before
    ** Allow disable TOC writing
  
  * White lines should use minwhiteline, not get ignored
    ** Standard rules should also be checked
  
  * Implement minimum line widths for borders and zrules
  
  * Improved layout and functionality of the Picture tab
  
  * Add more helpful tip to font-related error message
  
  * Exclude variable fonts (need to use static fonts instead)
  
  * Diglot availht calcs need to consider joint calcs.
  
  * Add per side IndentUnit in diglots
  
  * Increment print counter when we hit print
  
  * Improve handling of pics within Intro matter
    ** On generate create picture anchors with paragraph counts

  * Character style colouring fix
  
  * Avoid problems from id@@@ continuing after end of the book
  
  * Trigger side-hooks for mongolot sections of a diglot text
  
  * Add labelling of tracing lines, fix? table alignment controls
  
  * Side-dependant numcuts and dropotherlines need to be counts
  
  * Make utility to get improved division accuracy
  
  * Page end textborder kern should only happen when page border in effect
  
  * Add intropages. Support periphs with no ids in INT
  
  * Fix nonpublishable UI linkage
  
  * Fix gridline-column separator for left-opening (RTL-binding) diglots
  
  * Fix QR bug when there was an = in the URL, make keywords set marks
  
  * Fix linebreak at \k and Update standards
  
  * Fix thumbtabvadj in texperthacks to work, rather than print
  
  * Fix Digital CMYK to actually be CMYK
  
  * Various python 3.12 cleanups (mostly affecting Regex)
  
  * Various Documentation improvements
    ** Document ptxprint.spec a bit [Tech]
  
Bug fixes and Improvements in 2.4.21 (27 Apr 2024)

  * Chapter numbers should occur on their own line
  
  * Having + in tag_escapes stops parsing of nested markers, treating them as text.
  
  * Update test standards after table-column controls added (4a8e0df)
  
  * Add functionality to pre-populate the following Google Forms before submission:
    a) Request hi-res illustrations from SIL's repository of illustrations and maps
    b) Get Permission to use (mostly) David C Cook illustrations 
  
  * Improve glossary filtering
  
  * Add ink saturation limiting to cmyk pdf generation
  
  * Re-work the Global Options tab of the Pictures Page to improve usability
  
Bug fixes and Improvements in 2.4.20 (22 Apr 2024)

  * Add another example for range of verses to print non-contiguous in same chapter
  
  * Add Rohg script

  * Simplify wording on Advanced tab for changes.txt (to make it easier to find!)
  
  * Solve issue on View+Edit tab when a file is not found.
  
  * Make sure periphs from the INT book are included even if FRT book is missing.
  
  * Do not save default values when picInfo.txt and picCheck.txt are written
    (reduces the filesizes of these files significantly)

  * Protect from logger crash on poor pt settings

Bug fixes and Improvements in 2.4.19 (5 Apr 2024)

  * Fix RTL in footnote paragraphs
  
  * Add keyboard shortcuts to Technical Reference Manual
  
  * Ensure QR spacebeside attr is a number
  
  * Fix QRcode with numerical pgpos
  
  * Create default settings for scripture refs when unpacking DBL bundles
  
  * Try to obey PT settings for chapterverse and range separators
  
Bug fixes and Improvements in 2.4.18 (26 Mar 2024)

  * Make id:GEN|p style font definitions work properly
  
  * Fix undefined item in sidebar figure placement
  
  * Cope with spaces in sidebar figure names (Note: affects pics in covers)
  
  * Maybe fix odd interlinear alignment
  
  * Fix usfmerge remove problems
  
  * Solve diglot error with character styles in chapter-level heading paragraphs
  
  * Improve handling of cl in diglots
  
  * Dedup errors and warnings and limit remedies sometimes
  
  * Fix toc col width issue when > 999 pages in publication
  
  * Update shortcuts in the editor window:
       Ctrl-minus  =  Shrink - size of text
       Ctrl-equals =  Grow   + size of text
       Ctrl-s      =  Save file
       Ctrl-d      =  Duplicate current line
       Ctrl-l      =  deLete current Line
       Ctrl-0      =  Comment out/in the current line (uses \rem, #, %)
       Ctrl-,      =  Comment out/in the current line (uses \rem, %)
       Ctrl-Up     =  Move the current line/selection UP by one line
       Ctrl-Down   =  Move the current line/selection DOWN by one line
       
    In AdjList window:
       Ctrl-grave  =  Activate first shrink option in current paragraph
       Ctrl-1...9  =  Activate Nth grow option in current paragraph
  
Bug fixes and Improvements in 2.4.17 (18 Mar 2024)

  * Fix broken test cases and solve an error-loop
  
  * Minor tweak to AdjList generation (easier to edit)
  
  * Fix gloss-rb link bug
  
  * Make custom merge config files work
  
  * Add printcount to config files
  
  * Added shortcuts keys for editor (^d=duplicate, ^l=del Line, ^i=shrink, ^1-9=grow/shrink)
  
Bug fixes and Improvements in 2.4.16 (8 Mar 2024)

  * Added 'Give Feedback' button and link to Google user survey form
  
  * Fix broken link localization with Google translate (not all are possible)

  * Add control for position of drop-cap chapter numbers. **This may break existing layouts** if the default
alignment or left/right indent factors have been changed from their defaults (Alignment centre and indents zero).
Previously such changes were ignored, but now they have meaning.  Alignment=Right -- Use right indent (or left
if right indent is zero)_indent to set position of right-hand edge of number (left-hand edge in right-to-left publications).
Other alignment setings -- Left indent controls where the chapter number starts.

Bug fixes and Improvements in 2.4.15 (5 Mar 2024)

  * Don't report unbalanced last pages, and show page ranges in report
  
  * Fixed \cl in diglots
  
  * Minor UI tweaks - Page Size edits were in overwrite mode, enable search for drop cap
  
  * Add Adjlist syntax highlighting
  
  * Call usfmerge2() with debug flag controlled by log level (Writes test files to check that nothing got added/lost in merging)
  
  * Fix diglot cutout continuation problem(?)
  
  * Fix RefRange.__contains__
  
  * Add additional tests for references
  
  * Fix diglot vertical grid line position (#941)
  
Bug fixes and Improvements in 2.4.14 (28 Feb 2024)

  * Fix moving notes up and down at the end of books
  
  * Fix tests, remove Times New Roman
  
  * Add some test .sty files
  
  * Solve bug with catprefix escaping groups
  
  * Silently ignore python processing if not present
  
  * Start working on fractional heights
  
  * Solve a backing-up issue
  
  * Fix accidental centrecolum breakage
  
  * Fix long-standing bug where centre column refs were stealing space from main text.
  
  * Update templates, Fix CenterColXrefs
  
  * Merge branch 'notes - changes to footnote measurements
  
  * Check AdjustList for odd input, warn if there's a space
  
  * Add UI controls for note multipliers
  
  * Fix alignment of book headers
  
  * Add all Book headers as HEADER in merge
  
  * Fix codelet to insert book code as \h1
  
  * Add resilience in usfm parser
  
  * Fix diglot pagebreaking on 2nd page
  
  * Make verse ranges valid link-targets
  
  * Fix problem with \|
  
Bug fixes and Improvements in 2.4.13 (1 Feb 2024)

  * Make "font" figure size scale to the right fontsize
  
  * Provide status message with list of unfilled pages -- active with tracing{B}
  
  * Fix broken x-edgeadjust in figures, improve figure documentation
  
  * Don't let codelet buttons area expand when expanding parent window
  
  * Add more telemetry for page breaking
  
  * Fix hard hyphens in hyphenation
  
  * Another tweak to get hyphenation working just right
  
  * Define \reference to (a) be user-changable and (b) default to using ChapterVerseSeparator
  
  * Improve status line messages esp for underfilled pages
  
  * Check for (downloadable) updates more consistently

Bug fixes and Improvements in 2.4.12 (25 Jan 2024)

  * Allow letter-spaced text to be hyphenated
  
  * Style tab's More Info... now also link to github-docs-help-zfoo.md pages
       For internal milestones etc. zbl, zlabel, zpage, zpmkr, zrule, etc.
  
  * Implement 'H' figure position (cHaracter-like HERE)
       To go with 'H', there are 2 new sizes, 'font' and 'line', 
       related to the font size and \baselineskip.
  
Bug fixes and Improvements in 2.4.11 (23 Jan 2024)

  * Fix feedback loop in balanced esp. for pages with a big gap
  
  * Refactor hyphenation
  
  * Add option to force hyphens to be non-breaking
  
  * Added various help files to technical documentation
  
Bug fixes and Improvements in 2.4.10 (20 Jan 2024)

  * Make Quick Run option 'sticky' - keep with user config settings
  
  * Undo change related to t@gging (colstart param missing / fixes extra } error)
 
Bug fixes and Improvements in 2.4.9 (19 Jan 2024)

  * Added t@gging (and stop footnotes blowing up)
  
  * Add tags for figures
  
  * Temporary fix verse lists in interlinear
  
  * Add end of book hook when end of book decoration is included (#938)
  
  * Fix typo in ptx-output.tex
  
  * Allow custom .py scripts to run with __main__ check

Bug fixes and Improvements in 2.4.8 (18 Jan 2024)

  * Download updates button is now smarter
  
  * Shaving values are now deltas
  
  * Fix joint of carried over and new notes
  
  * Solve issue of breaking in overflowed notes
  
  * Fix typos in texpert.py
  
  * Merge branch 'notebreaking'
  
  * Update good test results (centrecolumns still a mess)
  
  * Start documenting milestones
  
  * Mode documentation
  
  * Fix chapter label dropping chapter marker/number
  
  * Fix bad image copyrights output to .tex (#929)
  
  * Add warning message help for bad copyright statement in tex.log
  
Bug fixes and Improvements in 2.4.7 (11 Dec 2023)

  * Improve snippet on diacritic colouring
  
  * Get correct UI level to show at startup
  
  * Internationalize URIs on Help tab via Google Translate
  
  * Remove preview when deleting pictures, and swapping configs
  
Bug fixes and Improvements in 2.4.6 (6 Dec 2023)

  * Make \fp* a noop (related to #813)
  
  * Refactor to get diacritic colouring working
  
  * Add docs for diacritic colouring in snippets.md
  
  * Diacritic colouring refinements to allow whole book colouring.
  
  * Point Style links to new USFM docs site
  
  * Fix zfiga bug of extra backslash showing up
  
Bug fixes and Improvements in 2.4.5 (30 Nov 2023)

  * Fix rangeref with verses off and different books
  
  * Avoid lost last partial-page of SFM input
  
  * Add space to ensure multiply vs prefix
  
  * Hopefully solve #915 potential insert loss
  
  * Fix big balancing
  
  * Unmerge note and output routines from paratex2.tex
  
  * Fix reference tests after changes to b64codes
  
  * Output bookendrule even when the first thing on the page is a title
  
  * Get diacritic colouring working (alpha)
  
  * Move bad fonts not switching in UI to environment variable
  
  * Control hanging verse at dropcap
  
  * Add Extra XDV Processing checkbox in UI and modelmap
  
  * Implement ifHangVA
  
  * Stitch in xdv processing

Bug fixes and Improvements in 2.4.4 (17 Nov 2023)

  * Fix @ issues with hyphenation and default texpert hacks values

  * Implement @diglot@pagebreak (correct paragraph break behaviour for diglots)

  * Document new paragraphed notes controls

  * create xdv filter, seems to do unity transfer atm

  * Improve logic on ommitting chapter numbers

  * Ammend standard test results with running header fix

  * Get new pyintaller and innosetup to work again ;;; _internal

  * Get pytest to work on MSYS2 (remove option to run on Win)
  
  * refactor xdv stuff
  
  * Update Crowdin localization
  
  * Document and illustrate most of the new footnote options
  
  * Tidy up code snippets for changes, getting \ correct

Bug fixes and Improvements in 2.4.3 (14 Nov 2023)

  * Correct logic so noteid change applied to non-paragraphed notes
  
  * Make new-style paragraphed notes mimic old-style paragraphed notes
  
  * Make newparnotes unwrap first box (behave properly with endnotes)
  
  * Clean up some unnecessary dimen usage
  
  * Yet another parnotes option; un-break newparnotesfalse
  
  * Less deltas for newparnotes
  
  * Improve book filenames handling
  
  * Fix typos around clearthenbackup
  
  * Repair broken clearthenbackup bug
  
  * Make UI footnote/xref control work on diglots
  
  * Cope with mt1 on line after an id
  
  * Ensure that pagebreak-before-all-chapters doesn't crash regex
  
  * Fix regex bugs
  
  * Refactor changes to include error messages
  
Bug fixes and Improvements in 2.4.2 (4 Nov 2023)

  * Add missing changes for bookresetcallers (Reset fn+xr callers at each book)
  
  * Support for footnote sanity checking via parlocs
  
  * Paranotes are incompatible with write nodes, at least old-style paranotes
  
  * Newparnotes confirmed compatible with noteid code
  
  * Implement Box/BorderPaddingInnerOuter (note untested for RTL)
  
  * Treat percent sign as literal in piclist (#912)
  
  * Update/add minitest files and standard
  
  * Fixed error on resetting UI level
  
Bug fixes and Improvements in 2.4.1 (2 Nov 2023)

  * Ensure figures and local/figures are also in the srchlist for pictures
  
  * Allow ^ in parents. Stop p^95 occursunder type errors (#925)
  
  * Implement bookresetcallers and fix some characters / escapes (tilde, backslash, pipe)
  
Bug fixes and Improvements in 2.4 (1 Nov 2023)

  * Make sure that the View Level is preserved when a config is reset or deleted
_______________________________________________________________

Version 2.4 release summary: (changes since last major version 2.3)

Significant New features:
  * Import feature (get settings from PDFs, ZIP Archives, or Proj+Config)
  * Added code snippets and actions to various tabs in View+Edit
  * Facility to download a sample image set and then Select Images to be used
  * Add support for QR code generation (using \zqrcode)

User Interface improvements:
  * A simple splash screen while loading [ptxprint -q to disable]
  * New hamburger menu to change View Level or Interface Language
  * Ensure DBL buttons are visible even in Basic mode
  * Ensure that color pickers don't hide behind dialogs
  * Button to edit Module definition files within View/Editor tab
  * Search now changes UI level for widgets not in the present view
  * Changed the manual highlighting color (Ctrl+Click) to Yellow
  * Added option for pagebreak before ALL chapters
  * Added option for 'Only Odd Tabs'
  * Added further options under Marks and Guides
  * Added link to \h header style on Header+Footer tab
  * Added Create Diff option (removed the hard-to-use button)
  * Improved interaction when chapter number is changed
  * Improved Cover tab UI with buttons for steps 1-3
  * Improved wording of picture copyright credits statement
  * Improved TeX log info/warnings/error reporting and suggestions
  * Improved error message when USFM file hits a Syntax Error (#889)

General enhancements:
  * Add Lao script support as per Thai
  * Add \marginversemarker{∙\kern 1pt} capability using \zmvm character style
  * Add a prototype script to read and summarize log files
  * Add punctuation processing to interlinear
  * Implemented ^95 notation for character styles (no need to create styles like \p_95)
  * Added extra diglot merging modes (without parameterisation of score mode) 
  * Allow custom scoring for diglots & added script for comparing diglot merge results
  * Allow monoglot GLO book(s) to use 2-column layout in a diglot
  * Allow stylesheet-based control of credit position along edge 
  * Auto-create BASIC FRTlocal.sfm when Front Matter is enabled, & disable colophon
  * Ensure marginal verse hyphens also appear with consecutive verses
  * Ensure that localChanges get run on INT book(s)
  * Handle set_positions for B suffix (Left/Right/Both)
  * Implement KeepFigure (allowing re-use of illustrations within the job)
  * Implement \ifKeepAllFigures (global boolean to keep all pics)
  * Implement \zsetref milestone (#894)
  * Implement outline-entry attribute (#597) for jump links in PDF
  * Implement smart gridding option for sidebars (none, smart, normal)
  * Improve column sync behaviour and document \zcolsync\  * #851
  * Improved: Verse ranges to include x:0
  * Make modules more resilient to missing text
  * Make space after GLO entry \k  * optional when filtering entries
  * Make sure check for updates doesn't run too often
  * Save current config per project in user config
  * Speed up PDF cover creation when set to screen (don't reprocess covers)
  * Support barcode price information
  * When 'Screen' PDF output is set, ensure the cover is also output

Technical improvements:
  * Update to TeX Live 2023 (on Windows)
  * Add --diffpages to limit size of output diff file
  * Add -f fontpath to fonts.conf on run
  * Add -V or --pdfversion as a command line option
  * Can now parse config and prjid from .zip archive without -Z
  * Add utility 'ptxunzippdf' to recover settings from PDF to specified folder 
  * Added category flattening to parsing ptxprint-mods.sty for import
  * Ensure INT books are added into archive
  * Have base and diglot views share the same picinfos (major change)
  * Make \zMarkVerseAgain for use in changes files (help identify scripture for text borders)
  * Make barcode errors print a warning rather than fail silently
  * Support various sidebar gridding options (not yet in the UI)
  * Add core code for bursting inserts (work in progress)

Issues Fixed:
  * Copyright Label Glitch on Pictures (#852, #776)
  * Make PDF binding depend of RTLBookBinding checkbox (MJ #856)
  * Solve issue of footnotes wandering (#862)
  * Allow modification of book end rule (#892)
  * Optionally only let margin verse markers print when not paragraph-initial (#886)
  * Eliminate SegFault due to issue with progress reporting (#888)
  * p^95 markup seems to override char-style stretch (#839)
  * Rationalise x-credit box settings (#896)
  * Have an initial font selected (#901)
  * Inner margin verses problem (#900)
  * Adjustment to page num posn in non-Diglot back matter (#904)
  * -f fontdir doesn't seem to work (#906)
  * PTXprint won't let me specify a reasonable \b line-spacing value (#909)
  * Truncated first page (#914)
_______________________________________________________________

Bug fixes and Improvements in 2.3.56 (31 Oct 2023)

  * Stay on Basic tab when changing Project or Configuration
  
  * Ensure TeXhacks values get loaded correctly on startup
  
  * Possible fix for reflow linespacing issue
  
  * File selector no longer clears PDF(s) if we click Cancel #887
  
Bug fixes and Improvements in 2.3.54 (30 Oct 2023)

  * Fixed Project and Config Overrides (sub-widgets now also get deactivated)
  
  * Separate diglot snippet into L and R sections
  
  * Polyglot phase 1: diglot as polyglot code generation
  
  * Set up one language per glot allowing hyphenation per glot
  
Bug fixes and Improvements in 2.3.53 (28 Oct 2023)

  * Find missing hamburger icon and ensure View Level is set when loading config
  
  * Ensure Texhacks stays enabled after re-starting
  
Bug fixes and Improvements in 2.3.52 (27 Oct 2023)

  * Use hamburger menu to replace the old View Level and Language choosers
    (known issue outstanding: View Level resets to Basic on restart)
  
  * Get the Single/Multiple radio button to remember setting
  
  * Make (some) file headers behave like paragraphs (#883)
  
  * Fixed: Reinstate support for outergutter
  
  * Fixed regression: subtle footnote shift

  * Remove redundant references to .map files from dvipdfmx.cfg which caused problems
  
  * Refuse to redefine TeX primitives
  
  * Warn when overwriting non-stylesheet macros with stylesheet
  
Bug fixes and Improvements in 2.3.51 (20 Oct 2023)

  * Update TechRef with language list
  
  * Reduce image info text width in image chooser, to stop glitchy resizing 
  
  * Add instructions on how to manually merge a polyglot file
  
  * Handle enter in image chooser. Prepare to recieve pop data in image sets
  
  * Various minor UI improvements (after day 1 of Dallas workshop)
  
  * Add experimental hamburger menu (param -E 1)
  
  * Add ToC merge codelet (from Jeff)
  
  * Make ui setting more robust, fallback to full view
  
  * Handle archives with no pictures
  
Bug fixes and Improvements in 2.3.50 (18 Oct 2023)

  * Crowdin sync - updated localization
  
  * Add extra space to the calcavailht if baselinesip < ascent
  
  * Fix URL for Biblica's open.bible site (DBL bundle downloads)
  
  * avoid crash with catless sidebar
  
  * Fix -c not setting config lock sensitivity. 
  
  * Better booklist analysis.
  
Bug fixes and Improvements in 2.3.49 (17 Oct 2023)

  * Implement ifAlwaysCheckAttributes logic
  
  * Add ParatextMerge.py (to be updated in PT 9.4 installation)
  
  * Ensure dialog title is correct on startup
  
  * Fix interlinear problems
  
  * Remove unwanted tag escapes from usfmerge
  
Bug fixes and Improvements in 2.3.48 (12 Oct 2023)

  * Fix some ISBNbarcode glitches
  
  * Make sure header/footer are not using fontextend
  
  * Make link-title with no link-href generate a PDF bookmark
  
Bug fixes and Improvements in 2.3.47 (7 Oct 2023)

  * Sidebar fixes: FgImageScaleTo calculations
  
  * Interpret lines starting # in piclist as comments
  
  * Make successive un-paragraphed notes obey their baselineskip (if no spacebefore)
  
  * Improve error reporting on status line, and after a crash
  
  * Fix infinite recursion if cannot infer sfm filename structure
  
  * Fix QR code bugs... (/ is now OK in both unicode and non-unicode data)
  
  * Fix missing QRcode.tex in the .spec file
  
Bug fixes and Improvements in 2.3.46 (28 Sep 2023)

  * Make space after GLO entry \k* optional when filtering entries
  
  * Update test-suite to avoid xfails
  
  * Correct the correction of pdfsavepos
  
  * Start support for sidebar gridding options
  
  * Fix \b to do what it should (#909) 
  
  * Rationalise x-credit box settings (#896)
  
  * "None" is a valid setting for the x-credit box type (#897)
  
  * Add a codelet for (parentheses on xrefs in GLO)
  
  * Tweak regex flags for python 3.11 compatability
  
  * Fixed gridding issues caused by restoring prevdepth guard value
  
  * Only include fonts that XeTeX can see.
  
  * Fix duff filename structure in Settings.xml
  
  * Implement smart gridding option for sidebars (none, smart, normal)

  * Fix long-standing bug with gridding of p (pc, pl, pr) sidebars.
  
  * Update documentation, add figures showing effect of gridding options.
  
  * Solve issue of unstable sidebar forground (cutout) image positioning
  
  * Update change rule in snippets (Amen!)
  
Bug fixes and Improvements in 2.3.45 (13 Sep 2023)

  * Correct figonpage counting and recording for sidebars
  
  * Improve TeX log info/warnings/error reporting and suggestions
  
  * Add codelet
  
  * Add missing writefontsconf param
  
  * Tweak use of getPicRe to work with Python 3.11

Bug fixes and Improvements in 2.3.44 (7 Sep 2023)

  * Fix font test

Bug fixes and Improvements in 2.3.43 (7 Sep 2023)

  * Save current config per project in user config
  
  * Only apply 'Adjust Center Header..' correction in parallel diglots
  
  * Anchor sidebar foreground cutout images to sidebar, not 1st paragraph
  
  * More resilience against buggy projects
  
  * End heading block at the start of zgetperiph, otherwise strange crashes happen
  
  * xfails: BellAndWhistles missing bits, minitests cropmark timestamp
  
  * Exclude woff files from fontconfig, given we can't process them
  
  * Add a prototype script to read and summarize log files
  
  * Tidy size of splash screen for Linux
  
  * Tweak Help tab for (potentially) larger number of users with PT9.4
  
Bug fixes and Improvements in 2.3.42 (7 Sep 2023)

  * First attempt at Left/right adjustment of sidebars / figures (#903)
  
  * Fixed figure scaling issues for sidebar foreground images 
  
  * Fixed don't blow up in modules if a pulled in snippet is empty
  
  * Set module inclusions based on UI settings
  
  * Make sure check for updates doesn't run too often
  
  * Fixed missing k. from generated piclists for GLO entries
  
  * Fixed minimise piclist loading and don't save on load
  
  * Add -f fontpath to fonts.conf on run
  
  * Add button to edit module definition files within View/Editor tab
  
Bug fixes and Improvements in 2.3.40 (1 Sep 2023)

  * Solve overwriting issue with small ISBN barcodes
  
  * Refactor runsplash to find images in pyinstaller build

Bug fixes and Improvements in 2.3.39 (31 Aug 2023)

  * Re-introduce a simple splash screen while loading [ptxprint -q to disable]
    (especially useful for new Paratext 9.4 users)
  
  * Make zfiga work on the cover (three letter book code = COV)
  
  * Have an initial font selected (#901)
  
  * Track down an odd font in a RTL (Nastiliq) project, and introduce
    workaround \noScaleAboveISBNtexttrue to stop ISBN causing crash.
  
Bug fixes and Improvements in 2.3.38 (25 Aug 2023)

  * Fix installer to handle new XeTeX directory structure
  
  * Add a DLL that fmtutil.exe needs (part of #894)
  
  * Don't use book= in zsetref since nobody ever wants the 
    header to come from the scripture. (Famous last words?)
  
  * Minor updates to documentation and Crowdin synchronisation
  
Bug fixes and Improvements in 2.3.37 (23 Aug 2023)- withdrawn

  * Move away from some W32TeX file locations
  
  * Update to TeX Live 2023 (on Windows)
    from the main TeX Live project https://tug.org/texlive/

  * Implement \zsetref milestone (#894)
    e.g. \zsetref|book="LUK" chapter="1" verse="1" \*

Bug fixes and Improvements in 2.3.36 (21 Aug 2023)

  * Implement outline-entry attribute (#597) for jump links in PDF
    \jmp John the Baptist|link-id="article-john_the_baptist" 
         outline-entry="John the Baptist" outline-level="2"\jmp*
  
  * Allow modification of book end rule (#892)
  
Bug fixes and Improvements in 2.3.35 (17 Aug 2023) - withdrawn

  * Try to eliminate SegFault due to issue with progress reporting (#888)
  
  * Fix faulty Hebrew digit mapping
  
  * Make barcode errors print a warning rather than fail silently
  
  * Support barcode price information
  
  * Paragraph breaks in paragraphed text now functioning as expected
  
  * Restore previous footnote behaviour by default
  
  * Optionally only let margin verse markers print when not paragraph-initial (#886)
  
  * Improve error message when USFM file hits a Syntax Error (#889)
  
Bug fixes and Improvements in 2.3.34 (4 Aug 2023)

  * Ensure marginal verse hyphens also appear with consecutive verses
  
Bug fixes and Improvements in 2.3.32 (1 Aug 2023)

  * Solve issue of footnotes wandering #862
  
  * Get import config from PDF working again

Bug fixes and Improvements in 2.3.31 (28 July 2023)

  * Add punctuation processing to interlinear
  
  * Fixed ifversehyphen bug
  
Bug fixes and Improvements in 2.3.30 (14 July 2023)

  * Picture selector integrated into UI
  
  * Add installed imagesets to piclist search directories list
  
  * Fix bibrefs and verses
  
  * Refactor image sets (currently only Creative Commons image set available)
  
  * Add nobook to reference separators
  
  * Improved a few codelets
  
  * Improved manual syncing of no-verses text
  
  * Box/BorderL/R/T/BPadding added to style editor
  
  * Can now parse config and prjid from .zip archive without -Z
  
  * Set allNeedEmptyingfalse at diglotsetup: prevent staggered 1st titles

Bug fixes and Improvements in 2.3.29 (4 July 2023)

  * Improve column sync behaviour and document \zcolsync\* #851
  
  * Handle set_positions for B suffix (Left/Right/Both)
  
  * Remove rems from FRT on run
  
  * Make sure cover periphs run with diglot turned off
  
  * Fuzzy match diglot pic filenames when generating L+R piclist

Bug fixes and Improvements in 2.3.28 (3 July 2023)

  * Ensure USFM2 figs don't get picked up again as USFM3 (piclist generation)

  * When 'Screen' PDF output is set, ensure the cover is also output
  
  * Add utility 'ptxunzippdf' to recover settings from PDF to specified folder 
  
  * Refactor view.getPDFconfig into utils
  
  * Diglot 'zcolsync' now accepts parameter and seems to work

Bug fixes and Improvements in 2.3.27 (29 June 2023)

  * Remove stray pdb trace causing style editor to hang/crash

Bug fixes and Improvements in 2.3.26 (28 June 2023)

  * Fix stray CRs in periph
  
Bug fixes and Improvements in 2.3.25 (28 June 2023)

  * Have base and diglot views share the same picinfos (major change)
  
  * Add logging to picture extraction
  
  * Fix keyword finding when parsing figs
  
  * One command to set up all 6 header positions
  
  * Repair footnotes on chapter numbers
  
Bug fixes and Improvements in 2.3.24 (27 June 2023)

  * Fix up pdf pages tree hierarchy in burst out insertions
  
  * Speed up PDF cover creation when set to screen (don't reprocess covers)
  
  * Refactor reading images from source files to insert GLO keyword terms
  
  * Improve pic copyright statement wording
  
Bug fixes and Improvements in 2.3.23 (26 June 2023)

  * Change the manual highlighting color (Ctrl+Click) to Yellow
  
  * Prevent old keywords and descriptions carrying over to next picture
  
  * Add \marginversemarker{∙\kern 1pt} capability using \zmvm character style
  
  * Fix margin verse positions
  
  * Set appropriate defaults for lacking style settings
  
  * Fix generating and not generating covers
  
Bug fixes and Improvements in 2.3.22 (22 June 2023)

  * Ensure that localChanges get run on INT book(s)
  
  * Add more components for Select Images dialog (work in progress)

Bug fixes and Improvements in 2.3.21 (20 June 2023)

  * Fix regex to handle nested \w glossary markup better
  
  * Implement \ifKeepAllFigures (global boolean to keep all pics)
     and at specific locations e.g.  \KeepFigure{MAT}{1.1}{}

Bug fixes and Improvements in 2.3.20 (8 June 2023)

  * Allow monoglot GLO book(s) to use 2-column layout in a diglot
    (enabled column-switching in serial-polyglots)
  
  * Finish(?) implementing zmakeinsert and multidepth periphs 
  
  * Reinstate IB series of illustrations with updated copyright info
  
  * Fix crashes with disabled footnotes in headings
  
  * Fix regression (covers stopped working)
  
  * Fix cmyk_black conversion in PDF finishing
  
  * Fix cover styling for diglots
  
  * Add test project for Covers, ToC, Thumbtabs and basic Front matter
  
Bug fixes and Improvements in 2.3.18 (5 June 2023)

  * Add UI elements for 'OnlyOddTabs' and 'Extract Color Inserts' (work in progress)
  
  * Fix bug affecting Diglot Introductory material causing crash
  
  * Ensure INT books are added into archive
  
  * Fix loss of B&W images in print spot output (per image and globally)
  
  * Progress towards automatic pdf-tagging of relevant peripheries
  
Bug fixes and Improvements in 2.3.17 (2 June 2023)

  * Added code snippets and actions to various tabs in View+Edit
  
  * Auto-create BASIC FRTlocal.sfm when Front Matter is enabled, & disable colophon
  
  * Implement KeepFigure (allowing re-use of illustrations within the job)
  
  * Include page gutter in Basic settings (as it was earlier)
  
  * Add support for QR code generation (using \zqrcode)
  
  * Use ifTabsOddOnly to set only tabs on odd pages
  
  * Add Lao script support as per Thai
  
  * Ensure that color pickers don't hide behind dialogs
  
  * Fixed magic adjust lines per page & color red when less than optimum (non-integer)
  
  * Don't overwrite \periphs in Front matter when (re-)creating the cover settings
  
  * Fixed path to Ornament Catalogue (on the cover settings dialog)
  
  * Fixed some cover merging errors
  
  * Fixed missing output intents in covers
  
  * Minor UI improvements based on user feedback from post-EMDC workshop
  
  * Tidy up cover box padding values and ensure cover boxes don't grow
  
  * Fixed setting figbleed properly
  
  * Protect stylesheet image paths against quotation marks
  
  * Add peripherals and new tracings to TechRef manual (ver0.85)
  
  * Fix coverartbleed from generating None
  
  * Enable multiline codelets, and allow ** as footnote caller
  
  * Add core code for bursting inserts (work in progress; need to add switches)
  
  * Add 'method' codelet ability (work in progress)

Bug fixes and Improvements in 2.3.16 (24 May 2023)

  * Don't output empty filenames in stylesheets
  
  * Several more fixes to the filename fixing styleeditor code
  
  * Hack up back cover page to not grow too wide
  
  * Started to add UI for image selector (unreleased)

Bug fixes and Improvements in 2.3.15 (21 May 2023)

  * Replace backslash with / in filenames in .sty files
  
  * And fix a bunch of minor bugs

Bug fixes and Improvements in 2.3.13 (21 May 2023)

  * Permit multi-character footnote callers to get through the SFM parser
  
  * Unset chapterwaiting earlier to prevent duplicate chapter numbers
  
  * Keep track of variables across diglot breaks
  
  * Fix paratext alternates for separator settings
  
  * Allow ToC files to include control sequences e.g. for font-switching
  
  * Revert styleeditor setval strcmp fix of f3ba39b. To get Italic setting to stick
  
  * Don't remember show USFMs since it changes layout
  
Bug fixes and Improvements in 2.3.12 (15 May 2023)

  * Implemented ^95 notation for character styles
  
  * Promote font features with slash to start of the list
  
  * Added two additional options to Marks and Guides options:
     * Show Adj Points
     * Show USFM Codes

  * Updated documentation:
     * Added Techincal Reference Manual (to GitHub documentation)
  
  * Check if keepperiph has been defined before running the periphery
  
  * Fixed output intents for cover PDF (always print cover in color)
  
  * Make modules more resilient to missing text
  
  * Fixed active quotes not getting deactivated
  
  * Have search change UI level for widgets not in the present view
  
  * Ensure DBL buttons are visible even in Basic mode

Bug fixes and Improvements in 2.3.10 (2 May 2023)

  * Improved: Verse ranges to include x:0
  
  * Fixed modules to include content based on body tab settings
  
  * Fixed module ref final empty element clearing
  
  * Correct delimiters for \asterisk etc.
  
  * Fixed auto generated front matter text to not output anything
  
  * Partial fix: Allow fractional lines in picture cutouts
  
  * Allow custom scoring for diglots
  
  * Add changes to clean up whitespace (and remove extra blank lines)
  
  * Address #852 and strip final empty elements from ref results in modules
  
  * Fix path not having len()
  
  * Build all documentation pdfs

Bug fixes and Improvements in 2.3.9 (26 Apr 2023)

  * Don't crash if glossary line contains multiple keywords
  
  * Merge branch 'figplacemnt'
  
  * Fixed broken footnote hanging around during backing up #862
  
  * Improved UI: Remove Create Diff button and replace with a selectable option
  
  * Fix CMYK black processing & Don't reverse a white image
  
  * Improved: Round margins to 0.01
  
  * Make ifFinalNotesDown work properly
  
Bug fixes and Improvements in 2.3.8 (19 Apr 2023)

  * Updated Crowdin localization strings
  
  * Make \zMarkVerseAgain for use in changes files (help identify scripture for text borders)
  
  * Text border must check for new "intro" mark from intro paragraphs
  
  * Fixed Use correct USFM encoding for reading pictures
  
  * Fixed Handle importing configs with no vars section
  
  * Fixed spelling in documentation (MJ's PR #861)
  
Bug fixes and Improvements in 2.3.7 (18 Apr 2023)

  * Improve Cover tab UI with buttons for steps 1-3
  
  * Refine import settings dialog, and wordsmith tooltips
  
  * Handle missing spinewidth for command-line initiated cover page
  
  * Barcode improvements:
      - Check digit count to avoid crashes
      - Automatically generate ISBN13 if ISBN10 is provided
      - make \ISBNfont apply to all lettering
  
  * Make PDF binding depend of RTLBookBinding checkbox (MJ #856)
  
  * Fix peripheral and cover front import
  
  * Fix 'Choose books' broken (#860)
  
  * Add delayed file handling
  
Bug fixes and Improvements in 2.3.6 (17 Apr 2023)

  * Added NEW feature to allow importing of selected settings from 
    PDF files, ZIP archives or Proj+Configs
  
  * Added category flattening to parsing ptxprint-mods.sty for import
  
  * Fixed sliver of image showing beside the figure credit box
  
  * Improved UI interaction when chapter number is changed (so multiple 
    books isn't selected when you tab out of the 'To chapter' field
  
  * Allow stylesheet-based control of credit position along edge 
    (\SpaceBeside) or inside/outside edge (\SpaceBefore).

  * Allow lineskiplimit overrides <0pt
  
  * Fixed Style editor row deletion when filtering is on
  
  * Ensure that zornament works nicely in RTL-land
  
  * Added link to \h header style on Header+Footer tab
  
  * Fixed out of date documentation about sidebar border padding
  
  * Updated documentation for ornaments
   (put the grammar for `\OrnamentScaleRef` back where it belongs)
  
  * Fixed style merging by ensuring we use the same Marker() dict in Sheets
  
Bug fixes and Improvements in 2.3.5 (6 Apr 2023)

  * Fix SkipMissingPictures (which now works as advertised)
  
  * Improved various UI tooltips and interactions
  
  * Solved some figure-credit issues
  
  * Fixed ornament placement with xfobj
  
  * Fixed behaviour when \k is used in a section header
 
Bug fixes and Improvements in 2.3.4 (1 Apr 2023)

  * Added option for pagebreak before ALL chapters
  
  * Fixed broken figure credits
  
  * Improved wording of Merging Modes tooltip

Bug fixes and Improvements in 2.3.3 (31 Mar 2023)

  * Update cover documentation, and code snippets

  * Preserve the introduction page number

  * Added -V or --pdfversion as a command line option
    PDF Version to read and write * 10 (default=14)

  * Added extra diglot merging modes (without parameterisation of score mode) 

  * Added more telemetry to .parlocs

Bug fixes and Improvements in 2.3.2 (25 Mar 2023)

  * Add --diffpages to limit size of output diff file
  
  * Make feature-maths work properly for p^95 type adjustments.
  
  * Enable (diff-friendly) debugging and log output from script
  
  * When in debug mode, also output columns to separate files for easy diffing with original
  
  * Fixed figures-included-on 2ndary bug
  
  * Solved (?) duplicated footnotes on overlarge partial page
  
  * Solve double-line issue between books
  
  * zfillsignature now getting maths right and using actual page counts
  
  * Fix zrule depth problem. Don't switch column layouts needlessly
  
  * Bodge a partial fix for separated book titles

Bug fixes and Improvements in 2.3.1 (15 Mar 2023)

  * p^95 markup seems to override char-style stretch (#839)
  
  * Refresh Crowdin localizations (esp. French, Chinese)
  
  * Fixed issue relating to \figbleed (when running from command line)
  
  * Use correct dimension for moving covers issue
  
  * Added script for comparing diglot merge results

Version 2.3 release summary: (changes since last major version 2.2)

Significant New Features:
  * Added ability to create a Cover page PDF (with front, back, spine; crop marks & bleed)
  * Added feature to import settings from a PDF (previously generated by PTXprint)
  * Added other external cross-reference sources (incl. TSK, UBS, BibleWorks lists)
  * Added feature to insert Strong's numbers in the text based on term renderings
  * Added ability to use Transcelerator questions (Notes+Refs > Study Notes+Questions)
  * Added feature generate Permission Request letter (for David C Cook)
  * Added ability to lock specific settings using config and/or project override files
  * Added RTL support for booklet pagination on finishing tab

UI-improvements:
  * No need to define styles for stretch/shrink (use \p^95 notation instead of \p_95)
  * Improved Style Editor reliability, added filter option and improved search
  * Improved interaction on the Layout tab (hover over highlights settings)
  * Check for program updates and indicate if an updated version is available
  * Added extra color to PDF diff output: "red has fled, blue is new"
  * Added auto-save option for the settings file editor
  * Added capability to reset to default values on spin buttons

General enhancements:
  * Allow inner, outer, & right options for margin notes and marginal verses
  * Added format labels (RGB, CMYK, BW, Spot, etc.) to output filenames
  * Ensure pictures are pulled in from secondary project for non scripture books
  * Added control to adjust gap between caption and figure (TeXpert Hacks)
  * Added conditional marker \zifvarset (useful for auto ISBN display on covers)
  * Added various blank/empty page controls (\zEmptyPage, \zNeed[Odd|Even|Quad]Page)
  * Added TeXpert Hacks tab for highly advanced options (with limited support)
  * Added option to control Rule Thickness (Advanced tab)
  * Removed warning if SIL found in copyright statement (as EL has been modified)
  * Added all OpenType lookup tags for font features
  * Improved creation of hyphenation file with user options and better logic
  * Improved Indic syllable-based hyphenation rules
  * Add facility for project-specific digit mappings
  * Added Hebrew digit mapping

Technical improvements:
  * Display help for command line parameters on Windows (using -h flag)
  * Enabled installer to run PTXprint on ARM64 architecture
  * Config password is now hashed (to avoid being readable)
  * Added client/server IPC for Paratext integration
_______________________________________________________________________________________

Bug fixes and Improvements in 2.3 (13 Mar 2023)

  * Cover generation now works more predictably with more options

  * Use font-dependent spaces for underlining (#836)

  * Added justification mode 'leftbal' (and made 'left' behave more life expected)

  * Improvements to Generate Cover UI dialog

  * Enable turning off previously set sidebar figure

  * Fix strange behaviour of zvars on covers (and probably elsewhere too)

Bug fixes and Improvements in 2.2.52 (8 Mar 2023)

  * Multiple improvements to cover generation (still a work in progress)
  
  * Run captions through changes.txt
  
  * Added Hebrew digit mapping
  
  * Added conditional marker \zifvarset (useful for auto ISBN display on covers)
  
  * Added new scope modifiers for changes.txt BKK[CAP/REF] (e.g. GLOCAP and GLOREF)
  
  * Introduced Figure bleed (\figbleed) for covers

  * Fixed config file with newly hashed password needs to autosave on open
  
  * Fix up forced break before chapter 1, now with an ifPBOnBody
  
Additions, Improvements and Bug fixes in 2.2.51 (4 Mar 2023)

  * Added Generate Cover PDF (some features are still under construction)
  
  * Added Import Settings dialog (currently incompleted feature)
  
  * Added Notes (Description field in Paratext) to Strong's index generation
  
  * Added Per diglot footnote controls
  
  * Added Hook for first chapter e.g.: \sethook{first}{c}{\zrule\*}
  
  * Added control to adjust gap between caption and figure (TeXpert Hacks)
  
  * Added ability to use double underline (but not recommended)
  
  * Ensure pictures are pulled in from secondary project for non scripture books
  
  * Don't merge pictures for non scripture diglot (peripheral books
    don't get merged as a diglot, so get their own L & R pictures)
  
  * Improved stretch+shrink (changed \p_95 into \p^95 so multiple styles
    no longer need to be manually defined for all possible _NN values)

  * Improved relative path guessing to not fail when switching drives
  
  * Improved Read INT before FRT so that it has the periphs

  * Improved Permission Request letter and ensure user fills in missing zvars
  
  * Improved Config password is now hashed (to avoid being readable)
  
  * Improved Make zglot work outside ptxfiles
  
  * Turn inptxfile on and off in (un)prepusfm, so zglot works in colophon
  
  * Fixed Ensure that FRT is loaded with diglot off
  
  * Make \zfiga and \k trigger diglot-marked figures
  
  * Improvement Make project overrides lock the same way config overrides do
  
  * Improved Add constraint testing to values coming in from stylesheets
  
  * Improvements Add lock around changing marker in style editor so no changes propagate to old marker
  
  * Improved Handle headers as well as footers at the start of books (#782)
  
  * Handle loc p/a/w values for pictures with irregular sources

  * Handle pic loc p/a/w permission overrides
  
  * Improved Be more informative when xdvi or pdf fails to process (add xdvipdfmx logging)
  
  * Obey page breaks for inter book peripherals
  
  * Catch failed PDF loads, and don't load them
  
  * Insert section intros for diglots
  
  * Refactored ModelMap entries to be a class; added import category to ModelInfo
  
  * Fixed Textborder only showing bottom corner element (#826)
    (repair non-xobj border placement)
  
  * Fixed Space above/below illustrations is no longer adjustable (#828)
  
  * Fixed Persistent pagebreak (#814)
  
  * Fixed Cutouts in diglots/polyglots get it wrong if they cross a chunk (#680)
  
  * Fixed stray space in \literalkerns (Caused off-centre book title)
  
  * Fixed accidental bug breaking LogFonts
  
  * Fixed bug where XeTeXuseglyphmetrics=0 was breaking underline positioning
    (Negative UnderlineLower as being below baseline, as opposed to below descenders)
  
  * Fixed attributes of char styles which include other styles (with attrs)
  
  * Fixed diglot file chaining
  
  * Fixed Use L for diglot stylesheet loading
  
  * Fixed marginal verses esp. for reader's editions
  
  * Fixed Ensure switching between projects reads the config and checks fonts
  
  * Fixed saving and reading picture media settings
  
  * Fixed FG BG image filename display issue
  
  * Fixed monoglot files in diglot environment
  
  * Fixed Prevent multiple activation of custom chars from killing original catcode
  
  * Fixed Don't delete the chapter marks along with glossary enties 
   (when the glossary chapter marks get pushed onto the next line)
  
Bug fixes and improvements in 2.2.50 (31 Jan 2023)

  * Apply a space after nb processing is done, since \c kills spaces (#819)
  
  * Added several snippets to documentation

  * Handle fractional nb raise adjustments [MH]
  
  * Don't save overrides in PDFs

  * Protect from missing image files

  * Quieten SFM parser for stylesheets
  
  * Fixed adding variables

  * Avoid problems with lefttext, righttext

  * Make c@rrdstat empty if zglot disables no-glot

  * Try to avoid absolute paths in tex file

  * Fixed local piclist filename generation
  
  * Fixed missing picpages file (ensure immediate file opens)
  
Bug fixes and improvements in 2.2.49 (24 Jan 2023)

  * Fixed editable in setvar problem
  
  * Possibly fixed diglot synchronisation loss if a side has no text

Bug fixes and improvements in 2.2.48 (20 Jan 2023)

  * Fixed disabling and/or highlighting editable override variables
  
  * Added start and end hooks to interlinear use sethook{start/end}{gloss|rb}
  
  * Added strikethrough for disabled markers

Bug fixes and improvements in 2.2.47 (20 Jan 2023)

  * Override settings can now be locked (disabled) or *Editable (painted peach)

Bug fixes and improvements in 2.2.46 (18 Jan 2023)

  * Fixed layer violation between view and gtkview in updateProjectSettings

Bug fixes and improvements in 2.2.45 (18 Jan 2023)

  * Config settings overrides are now possible to lock down specific settings
      Project-overrides: \shared\ptxprint\ptxprint_project.cfg
      Config-overrides:  \shared\ptxprint\<configName>/ptxprint_override.cfg

  * Handle unpublishable periph sections better

  * Fixed xobject ornaments

  * Added logging to PDF reprocessing

Bug fixes and improvements in 2.2.44 (11 Jan 2023)

  * Added ability to create a cover page PDF (with front, back, spine, bleed, etc.)
     - this option is currently only available using the -z 16 commandline parameter
     - it will become mainstream after further testing and when documentation is ready

  * Enabled installer to run PTXprint on ARM64 architecture

  * Improved resetting/deleting the Default config

  * Improvement to now use pdf xform objects for ornaments

  * Improved tooltip documentation for pictures (anchor & no of lines)

  * Sidebar settings are in focus when cat:...esb is selected in the style editor

  * Removed warning if SIL found in copyright statement (as EL has been modified)
  
  * Put some sanity into the PT copyright statement handling (if > 100 chars in length)

  * Fixed crash on unknown artist used in copyright credits

  * Fixed Black+White output PDF stream issue

  * Fixed grid boxing for vertical text (used for Mongolian script)

  * Fixed picCopyright statement generation (artistWithMost error)

  * Fixed broken zvar bug

  * Fixed style editor for font reset and 0 non diffs
  
Bug fixes and improvements in 2.2.43 (17 Dec 2022)

  * Added feature on Pictures tab to generate Request Permission letter (DCC)
  
  * Added font size slider to View+Edit tab

  * Rename output files, and add output format labels (RGB, CMYK, BW, Spot, etc.)

  * Improved wording on body tab for one/two layout for certain books 
  
  * Improved diff PDF UI 
  
  * Improved Basic View by exposing some relatively new UI elements
  
  * Improved mymr syllable breaking logic
  
  * Implement ifSeparateVerseAdornments for standard case

  * Fixed ornaments and ornament catalogue

  * Don't attempt link to USFM online documentation if a complex style is selected

  * Fixed Strong's text matching regex creation

  * Fixed RefList output to include book if preceded by a reference from another book

  * Work in progress: (UI yet to be exposed)
     * Cover and Spine foundations in place 
     * Added documentation for covers
     * Enable covers using commandline option -z 16
     * Refactored cover tab layout and added extra controls

Bug fixes and improvements in 2.2.42 (2 Dec 2022)

(Note: This is a post-workshop release with a large number of minor changes
       made as a result of feedback from participants.)
   
  * Added various blank/empty page controls (zEmptyPage, zNeed[Odd|Even|Quad]Page)
  
  * Added between hooks 
  
  * Added MarkAdjustPoints
  
  * Add cv hook for GEN1.0 etc (before chap number)
  
  * Add cv hook for all1.0 etc (before chap number)
  
  * Added \zornament milestone
  
  * Treat p_95 as p in occursunder hierarchy
  
  * Allow line final \ extension in changes.txt files
  
  * Add snippet to change glossary page numbering
  
  * Select marker after adding a new marker in style editor
  
  * Add sm@rtquotes to enable smart quotes alongside liter@lkerns to turn them off
  
  * Display status line for no differences found when comparing pdfs
  
  * Output gray CMYK as gray
  
  * Update Base Indent wording
  
  * attempt to fix missing definitions for diglot defs
  
  * Invert model controls for module inclusions; x-credit background default to white
  
  * Set first verse of module ref range to 0 if 1
  
  * href-targets should also be reference labels.
  
  * Tweak UI range values for left indent and border width
  
  * correct occursunder for esb
  
  * Fixed textborders
  
  * Fix accidental forced-space in endlastparstyle
  
  * ifClipOrnaments (Ornaments by default clip themselves to a certain box. That box 
    is sometimes just too small for real beauty, so clipping has been disabled. 
    \ClipOrnamentstrue restores previous behaviour.)
  
  * Fix a bug where zrule was defining the category badly
  
  * Fix ornaments problem
  
  * Push merged footnotes down to bottom of page
  
  * Work around odd SFM in merging
  
  * Get \mod working
  
  * RTL non-paragraphed notes get the 1st Line indent correct
  
  * First line indent for footnotes
  
  * RTL support for paragraphed-notes first line indent
  
  * Use embedded styles for \w

  * Don't read reference separators from Paratext Settings if RTL
  
  * Fix RTL reference separators
  
  * Include \periph in output FRT etc. as opposed to stripping it
  
  * Change local FRT to use .SFM instead of .tex (MJ)
  
  * Implement \ztocbefore and ...after
  
  * Added \zfooter to enable footer styling
  
  * Exemplify empty cell in table
  
  * try to do a better job on headers
  
  * fix style leaks, finally?
  
  * Apply header/footer font changes in the right place
  
  * Fix finalising output formats
  
  * Fix PDF/X1-A headers
  
  * Add upwardsHackDiff
  
  * Fix activ@tecustomchars not early enough
  
  * Exec .py in private context
  
  * Fix edge case bugs in reference sequences
  
  * Make imported modules look in same place as original module
  
  * Fix incorrect borders on partial 
  
  * Preserve spaces after forward slash
  
  * Fix bookend-final error
  
  * Do not apply rotated dimensions to graphic images
  
  * Fix broken \zgetperph for people who do not include INT
  
  * Fix tabs in python, make \zgetperiph diglot-aware
  
Bug fixes and improvements in 2.2.41 (21 Nov 2022)
  
  * Read Reference Separators from Settings.xml if possible
  
  * Add tex model names as well as widget names to -I tooltips
  
  * Fix wrong diglot line spacing
  
  * Fixed Confusing label for option about footers in margin #781
  
  * Fix config setting from texpert
  
  * Try fixing an odd OSError -2 on convert().load()
  
  * Mask tiff convert in cropping
  
  * Various TeX macro fixes:
    * hook tracing and try zusermarks
    * more macro tracing, add ifstretchtabs
    * Stretchtabs and improved trigger marking
    * fix tabs bug, rename zusermarks to zcustommarks and fix it
    * fix unwanted space in style stack

Bug fixes and improvements in 2.2.40 (12 Nov 2022)
  
  * Get commandline -m working (Integrate macros dir into the job)
  
  * Fixed faulty 0.0 AdjList references
  
  * Added UI for global (layout-altering) misc settings
  
  * Refactor createDiff to enable a separate app pdfdiff
  
  * First cut at stemmed strongs cross references
  
  * Double rule zrules and testing that sidebars in sidebars work

Bug fixes and improvements in 2.2.39 (8 Nov 2022)
  
  * Added UI for Transcelerator checking questions (Notes+Refs > Study Notes+Questions)

  * Bring xrefs back in Basic view mode (#767)
  
  * Handle cross drive font issues

  * Be smarter finding Paratext data folder if no registry entry located

  * Don't break between multiple spaces. Allow any break before a ZWSP

  * Refactor hardwired penalties in M/NQUAD to use BADBREAK

  * Pull out ISBN font so that it can be specified
  
  * Remove slashes from \k...\k* reference (related to #766)
  
  * Fix issue with regurgitated char styles (#766)

  * Remove struts from notes. 
  
  * Fix note indent.
  
  * Update Strong's databases (better linkage between cross-references and index)
  
  * Fix balancing colnotes overflow with page
  
  * Fix accidental new lines around keyterms
  
  * Make the files generation part of printing more interactive
  
  * Get external processing scripts to run if not .py

Bug fixes and improvements in 2.2.37 (2 Nov 2022)
  
  * Added extra color to diff output: "red has fled, blue is new"
  
  * Fix separate footnotes outputting two struts.
  
  * Distinguish milestone code from hooks
  
  * Fix hebrew & greek wrapping \wh & \wg

Bug fixes and improvements in 2.2.36 (29 Oct 2022)
  
  * Fix crashing on syntax error in most places

  * Refactor to use cstyle{}{}

  * Make logging on loading styles a bit smarter

  * Improved hook handling (the 'forget' functionality was over-zealous)
  
  * Add and update snippets.md and markers.md
  
  * Add fault capture for Strong's matching

  * Various other minor fixes:
    - spelling of Spanish (Espanol) in language selector
    - fix typo in sanitise
    - fix wh and wg handling

Bug fixes and improvements in 2.2.35 (25 Oct 2022)
  
  * Added option (\versehyphenfalse) to not insert hyphen between adjacent 
    bridged marginal verses

  * Added RLE,LRE,PDF to turn off interchar spacing

  * Added support for including Transcelerator questions (now awaiting UI)

  * Refactored description of full marker

  * Refactored x-credit:box=Dark|fig to Dark|x-credit

  * Fixed deleting a style

  * Correct accidental inversion of child/parent

  * Grid partial to main paragraph baseline
  
  * Added a couple of changes.txt examples to snippets.md 
  
  * Fixed colophon vertical position (an empty footer box is not void. 
    Change to test for height.
  
Bug fixes and improvements in 2.2.34 (20 Oct 2022)
  
  * Updated Crowdin localization strings

Bug fixes and improvements in 2.2.33 (18 Oct 2022)
  
  * Minor UI improvements (link to \xts)

  * Fixed import PDF to work even if Adj files are missing
  
Bug fixes and improvements in 2.2.32 (15 Oct 2022)

  WARNING: This update may change the positioning of text compared to previous
           versions of PTXprint. Backup settings and be prepared to roll back.

  * Improved: Remove undesired break-point in diglot box joining
  
  * Added capability to reset values on any spin buttons
  
  * Added NonJustifiedFill setting for paragraphs on Styles tab
  
  * Logic to blank out p@gefirstmark in footline as well as headline #712
  
  * Fixed loss of FRT when switching projects
  
  * Fixed appropriate positioning of study note columns and handle empty columns OK
  
  * Fixed cutouts after 1 line paragraph. (#757)
  
  * Fixed no-ink-in-margin positioning 
  
  * Refactor tests for quality and speed and update standards

Bug fixes and improvements in 2.2.31 (12 Oct 2022)

  * Improved handling of complex font settings (GR etc.) in Style editor
  
  * Fixed bold and italic and fonts in style editor
  
  * Fixed ragged paragraph end to ragged
  
Bug fixes and improvements in 2.2.30 (10 Oct 2022)

  * Improved layout graphics (swapped sides for colored arrows)
  
  * Added option to control Rule Thickness (Advanced tab)
  
  * Fixed marginal notes (verses appearing in center between text)
  
  * Fix RTL aligned (not justified) text (for example, \qr)
  
  * Fix header rule for RTL inner+outer layouts
  
  * Adjust and monitor column threshold for margin notes

Bug fixes and improvements in 2.2.29 (9 Oct 2022)

  * Fixed Help | PTXPrint Docs Path link opens app not help #730
  
  * Improved Layout tab to make footer settings clearer #742
  
  * Improvement: Ensure consistent position for footers
  
  * Refactor page layout bottom margins and update .cfg (Inverted noinkmargin) 
  
  * Get inner, outer, & right working for marginnotes and marginal verses
  
  * Fixed: inner and outer marginal verses for 2 cols and also RTL 1-col or 2-cols
  
  * Fixed: Allow marginal verse numbers on last line
  
  * Adjust headers and footers to fit with offset columns (single and double)
  
  * Fix word boundaries for ZWSP
  
  * Added bookstart trigger for quick & dirty front covers
  
  * Enable imposition for cut first
  
  * Added a few other common paper sizes
  
  * Added Fold First option to pagination

Bug fixes and improvements in 2.2.27 (29 Sep 2022)

  * Fixed crash when switching configuration files within a project #744, #750
  
  * Fixed reference containment testing
  
  * Added milestone-like zglot to switch monoglot style (for peripheral books)

Bug fixes and improvements in 2.2.26 (27 Sep 2022)

  * Fixed archive creation for modules #739
  
  * Fixed Thai Sara am acts like a CM
  
  * Improvement for imported PDFs which are now sanitised #740
  
  * Fixed piclist generation for peripheral books #735
  
Bug fixes and improvements in 2.2.25 (22 Sep 2022)

  * Added RTL support for booklet pagination on finishing tab

  * Make auto-tag Hebrew and Greek words more robust
  
  * Fixed various module bugs
  
  * Don't insert inter-char space between numbers
  
  * Minor UI tweaks on View+Edit and Notes+Refs tabs #733
  
  * Fixed reflist simplification with full chapter references
  
  * Fixed reference simplify
  
  * Added spaces and documented them (docs/documentation/special_chars.md)

Bug fixes and improvements in 2.2.24 (20 Sep 2022)

  * Added other external cross-reference sources (incl. TSK, UBS, BibleWorks lists)

  * Fixed missing bridged verse xrefs
  
  * Added feature (defaulted ON) to auto-tag Hebrew and Greek words with \wh and \wg

  * Added warning for IB seriers illustrations (until permissions have been restored by Biblica)

  * Added option for number of in-line Strongs numbers to be displayed in text

  * Fixed Final reference in header one too high #734

  * Fixed Creating new saved configuration resets Scope and sets password #731
  
  * Fixed git having no head ref and resetting style setting values
  
  * Fixed TeX to do something sensible if style wrongly specifies 0ht paragraph
  
  * Fixed resetting book choice when saving new config

Bug fixes and improvements in 2.2.22 (13 Sep 2022)

  * Added feature to insert Strong's numbers in the text based on term renderings

  * Strip H and G from reverse index if only Greek or Hebrew was requested
  
  * Fix reverse index to work off primary keys
  
  * Load project after importing settings from PDF

Bug fixes and improvements in 2.2.21 (10 Sep 2022)

  * Fix multiple ZWSP between syllables causing spacing problems for multibook jobs
  
  * Fix RTL on picture credits and captions
  
  * Fix reset Print button status after changing projects
  
  * Fix typo to enable periph introductions to work as advertised

Bug fixes and improvements in 2.2.20 (5 Sep 2022)

  * Fix font features preventing bold, ital and BI typefaces from showing up #715
  
  * Allow empty stylesheets
  
  * Default \fig captions to be italic and slightly smaller than body text
  
  * Minor bug fixes #720, #724

Bug fixes and improvements in 2.2.19 (3 Sep 2022)

  * Now displays help for commandline parameters on Windows (using -h flag)

  * Added feature to import settings from previously generated PDF
  
  * Fixed missing tooltips on thumbtab page and updated wording
  
  * Now using dynamic lock and unlock icons for protecting Configs
  
  * Tidied up UI on Styles tab to handle resizing main window better
  
  * Fixed booklet signature creation for n>2
  
  * Fixed erroneous space after \k in Strong's index creation
  
  * Tweaked baseline of Strong's numbers
  
  * Fixed signature PDF generation so Acrobat can also load PDFs
  
  * Tidied up UI to have standardized widths on each tab
  
Bug fixes and improvements in 2.2.18 (29 Aug 2022)

  * Added abilty to use add extra parameters with pictures (e.g. rotate)
  
  * Fixed SSL issue so that Download Updated Version button shows up
  
  * Updated Crowdin localization files

Bug fixes and improvements in 2.2.17 (24 Aug 2022)

  * Added abilty to filter markers in use in Styles editor
  
  * Improved search for style to extend to names (not just markers)
  
  * Improved creation of hyphenation file with user options and better logic
    (also added hyphenation fallback to script syllable breaking)
  
  * Ensure the actual marker is displayed as part of the name in style list 
    rather than what the name might say it is
  
  * Fixed printing reflists in the same book
  
  * Fixed tooltip css and remove background opacity
  
  * Tidied up snippets.md file for easier use
  
Bug fixes and improvements in 2.2.16 (20 Aug 2022)

  * Improve status bar message with a Dismiss button instead of Hide link
  
  * Updated various tooltips to reflect new behaviour
  
  * Add error message for faulty color defition in style files
  
  * Highlight margin settings when hovering over settings
  
Bug fixes and improvements in 2.2.14 (16 Aug 2022)

  * Improved Indic syllable-based hyphenation rules
  
  * Fixed generate hyphenation file (to not include ZWJ and ZWNJ)
  
  * Added printing bridged verse 1 snippet

Bug fixes and improvements in 2.2.13 (13 Aug 2022)

  * Prevent excessive vertical growth when expanding Style attributes

  * Fixed output path to PDF on Help tab
  
  * Ensure piclist is populated after project is changed
  
  * Improved show/hide graphics for tabs
  
  * Changed colour (to blue) for picture location previews

Bug fixes and improvements in 2.2.11 (10 Aug 2022)

  * Added client/server IPC for Paratext integration
  
  * Add -N command-line parameter to disable internet access
  
  * Added option to only show verse number on \fr and \xo
  
  * Improved startup time
  
  * Fixed config version numbers not updating
  
  * Fixed Strong's cross-references (again)
  
  * Adjusted hyphenation list limit (again)
  
  * Tweaked button labels and status bar location & behaviour
  
Bug fixes and improvements in 2.2.10 (6 Aug 2022)

  * Added auto-save option for file editor
  
  * Added other languages (es, fr, pt, ru) to installer & tweaked install icon
  
  * Refactor Strong's to include all interesting Strong's and shorten output
  
  * Minor strongs xref bug fixes
  
  * Increased maximim hyphenation file size
  
Bug fixes and improvements in 2.2.9 (4 Aug 2022)

  * Fix missing footer problem and inconsistent controls #705
  
  * Add all OT lookup tags; Fix typos
  
  * Fix style element comparison for dimensions
  
  * Further UI improvements to aid just-in-time tooltip documentation
  
  * Fix Config name not working

Bug fixes and improvements in 2.2.8 (2 Aug 2022)

  * Re-enabled check for program updates (with newer SSL library)
  
  * Further refinement to the UI
  
  * Ensure no web links are visible when Disable ALL Internet Access is enabled
  
  * Fixed \pn within \li# does strange things #706
  
  * Fixed signature pagenum calculation (again) #692
  
  * Fixed selecting last search element in search pop-up list #694

Bug fixes and improvements in 2.2.7 (29 Jul 2022) [Withdrawn]

  * More UI refinements based on Paratext's UX team's advice

Bug fixes and improvements in 2.2.6 (28 Jul 2022)

  * Improve layout and interactive behaviour of various tabs
  
  * Simplify the Footnotes tab
  
  * Stay on the same tab when switching between View modes
  
Bug fixes and improvements in 2.2.5 (20 Jul 2022)

  * Improve behaviour of View/Edit tab for saving and refreshing files
  
Bug fixes and improvements in 2.2.4 (13 Jul 2022)

  * Don't resize Style Editor when a different style is selected
  
  * Added vertical scroll bar to copy config dialog
  
  * Shorten confirmation message when about to overwrite AdjList files

Bug fixes and improvements in 2.2.3 (24 Jun 2022)

  * Add facility for project-specific digit mappings

  * Reorder ptxprint-mods.sty to after ptxprint.sty so that it can override

  * Give non paragraphed footnotes a good last line

Bug fixes and improvements in 2.2.2 (21 Jun 2022)
  
  * Use placeholders instead of text in special book list (stops unexpected column layouts).

  * Fixed filtering & show glossary entries as footnotes for non-standard markup in GLO book.
  
Bug fixes and improvements in 2.2.1 (14 Jun 2022)
  
  * Updated Crowdin localization, and fixed spelling of Portuguese

  * Fixed crash due to very short error logs

Bug fixes and improvements in 2.2 (13 Jun 2022)
  
  * Fixed faulty signature creation #692 
  
  * Clear "peached" highlighting when searching for next setting
  
  * Ensure ptxprint-premods.tex gets copied to new configs
  
Bug fixes and improvements in 2.1.27 (8 Jun 2022)
  
  * Added Search for settings (to find settings based on key words)
  
  * Highlight settings and buttons on search
  
  * Improved updating GUI while waiting for a thread
  
  * Added logging statements to track startup activities better
  
  * Added keyboard shortcuts and tidied up help page links
  
  * Improved PDF Output options
  
  * Improved performance of CMYK conversion with numpy
  
  * Improved spot color handling
  
  * Added converter of CIE colour spaces
  
  * Implemented \GraphicOrnament - enabling images to be used as ornaments
  
  * Handle L images in PDF analysis
  
  * Stop repeated entries in stylesheet
  
  * Solved issue of non-skipping char style inside skipping char style
  
  * Fixed crashing for obscure colorspaces
  
  * Fixed missing styles on config output
  
  * Fixed broken ornamental zrules, fill calculation
  
  * Fixed transition from body to title at start of new document
  
  * Fixed bugs for graphite fonts and RTL cross references
  
  * Fixed paragraphed footnotes paragraph fill
  
Bug fixes and improvements in 2.1.26 (26 May 2022)
  
  * Make Bold and Italic work with FontName
  
  * Fixed fonts: italic bold fonts in styles
  
  * Fixed duotone
  
  * Fixed 'at' changes (which were skipping some verses)
  
  * Fixed alternate diglot losing info
  
  * Fixed printing multiple refs of the same book in odd orders
  
  * Fix oddity with indentation
  
  * Fix more pdf image stuff and parsing strongs.xml
  
Bug fixes and improvements in 2.1.25 (25 May 2022)
  
  * Fixed missing lib (numpy) issue
  
  * Refactor alternate usfmerge ready for multi-glot 
  
  * Fixed cropmarks
  
  * Fixed refactoring of diglots to allow polyglots
  
  * Correctly save calculated L and R units
  
Bug fixes and improvements in 2.1.24 - withdrawn (23 May 2022)
  
  * Added ability to select a spot color (for 2-color printing)
  
  * Added ornaments to the distribution (UI to follow)

  * Fixed wrapping TOC entries & toc-tc1 now has hanging indent

  * Psalm chapters 100-150 overwrite parts of second line #682
  
  * Fixed spot colour generation for CMYK docs
  
  * Fixed "^^5e" bug

Bug fixes and improvements in 2.1.23 (19 May 2022)
  
  * Added ability to select a spot color (for 2-color printing)

  * Fixed Table of Contents leaders (again!)

  * Added stage 1 of Find Help (work in progress...)
  
  * TeX: Added textborder on whole diglot page (UI to follow)
  
  * TeX: Set baseline correctly for di/polyglots
  
  * Fixed smallcaps typo in style editor
  
  * Fixed PermissionError issue with _diff.pdf being un-deleteable
  
  * Fixed marker name auto update in Add/Edit Style dialog
  
  * Fixed runaway headingbox
  
  * Fixed control over drop chapter number sizes (automatic if <= 1.5)

  * Fixed crashing on diff if page sizes differ
  
Bug fixes and improvements in 2.1.22 (14 May 2022)
  
  * Added ability to create 4, 8, 16 page signatures on finishing tab
    (for booklet printing and more)
  
  * Don't include consultant notes projects and study bible additions
  
  * Pad intro material to grid
  
  * Create captions appropriately and measure
  
  * Fixed error message when deleting temp files
  
  * Fixed iterating verses beyond range of scripture in doc
  
  * Fixed hiding \s1 \s2 when section heads should be hidden
  
  * Fixed interlinear refs in error message
  
  * Fixed peripheral section introductions
  
Bug fixes and improvements in 2.1.21 (9 May 2022)
  
  * Refactored tests to use pdf differencing (Standards to follow)
  
  * Added -F --diff arg for cmd-line driven diffs (helps bulk testing)
  
  * Added -Z --zip arg to unZip and run directly from a .zip archive
  
  * Fixed multiple issues in copy config to other projects
    (and make sure base settings are created for future merges)
  
  * Fixed gridding after p images/sidebars (once and for all?)
  
  * Fixed prepress pdf filenames
  
  * Removed SSL from setup.py (causing issues in Jammy #676)
  
  * Remove ZWSP from nonbodymarkers
  
Bug fixes and improvements in 2.1.20 (5 May 2022)

  * Refactored fig reading to support periphs better #648 #648 #640
  
  * Fix vertical text cropmarks
  
  * Improved spacing for captions
  
  * Fixed "Failed to create" error #664
  
  * Improved wording of tooltips for several controls
    (including warning about Char spacing affecting Hyphenation)
  
  * Added MAL and TAM to Crowdin localization
  
  * Added ParallelNoteNumbering{f} command #674 
  
  * Temporary fix for TOC page number filling
  
Bug fixes and improvements in 2.1.19 (30 Apr 2022)

  * Added Sinhala-script hyphenation option
  
Bug fixes and improvements in 2.1.18 (30 Apr 2022)

  * Remove ptxprint.sty stylesheet when deleting Default config
  
  * Ignore non publishable border styles
  
  * Border catalogue and border improvements
  
  * Increase resiliance against .git version missing or faulty
  
Bug fixes and improvements in 2.1.17 (27 Apr 2022)

  * Fix outputting whole chapters in references list (e.g. PSA 23; 100)
  
  * Handle study column gutter and note rule
  
  * Border improvements (Additional border styles, Styles for ornamental zrules,
    text border spacing logic)
  
  * Added locale files for all 14 localization languages

Bug fixes and improvements in 2.1.16 (21 Apr 2022)

  * Added options for Copying Configuration to other projects (preserve/merge/overwrite)
    which allows cluster projects to have the configs UPDATED rather than just replaced

  * Added ability to call Plugins (on Advanced tab) which enables facing-page polyglots
    and also paves the way for Ornaments
  
  * Added underline position and thickness adjustments (Misc settings on Advanced tab)

  * Added Finishing tab with several new features (not all implemented yet)
  
  * Added feature to Compare PDFs to show any differences
  
  * Added feature to retain N previous copies (*_1, *_2, *_3 etc.) of generated PDFs
  
  * Added 'Screen' PDF Output Format for fastest re-generation of PDFs
  
  * Added option to lock ratio of font and baseline
    (Complete scalability on a single factor #651)
  
  * Fixed Missing section heading #659

Bug fixes and improvements in 2.1.15 (7 Apr 2022)

  * Fixed \cat in footnotes
  
  * Put git version into config, and into PDF properties
  
  * Fixed book change not changing view+edit
  
  * Fixed save picture list filtering to config
  
  * Put PTXprint version and SHA into the error messages people submit
  
  * Fixed Table of Contents ordering
  
  * Improved docs and control for ornaments
  
  * Follow (symbolic) links in the figures folders 
   (enabling multiple locations to be searched for the most appropriate image)
  
  * Added documentation for periph: and id: styling. 
    (mechanism for python to use for periph-based formatting)
  
Bug fixes and improvements in 2.1.13 (2 Apr 2022)

  * Handle figures/illustrations in FRT matter better #640
  
  * Handle arbitrary non-standard SFM filenames in a project directory #642
  
  * Handle periph sections being included anywhere in the output
  
  * TeX code added for ornaments (UI for this is not yet implemented)
  
  * Output software version in pdf properties
  
  * Add config and project ids to ptxprint.cfg
  
  * Fixed restore linepenalty after temporary change by // (#599, #643)
  
  * Fixed table column logic
  
  * Fixed sidebar pX positions
  
  * Sort Table of Contents 'post' and 'pre' on page number
  
  * Fixed references including :0  (e.g. MRK 4:0-6)
  
  * Introduced spacebefore/spaceafter for figs and sidebars (not yet in UI)
  
  * Handle unsupported \fp marker in footnotes (insert ' --- ' instead)
  
Bug fixes and improvements in 2.1.12 (29 Mar 2022)

  * Add debug logging for style editing (known issue still lurking here!)
  
  * Footers are no longer placed in bottom margin area (but there is a
    compatibility option to allow footers into the bottom margin area)
  
  * Added support for id:MAT| style prefixes 
  
  * Stop switching page dimensions with full page images

  * Fixed after-paragraph image positions
  
  * Fixed ToCs (both RTL and LTR) to work properly again with leaders
  
  * Fixed known gridding issues with sidebars 
    NB: If the linespacing is different to the main text, then it is the
        *bottom* line that should be expected to be on-grid.

  * Fixed the line spacing so that categories don't nobble it
  
  * Get sidebars back on the grid
  
  * Save/restore cutout parameters before/after a side-bar
  
  * Fixed top of page inline esb gridding, and quotes around image files

  * Fixed tabs output
  
  * Auto-expand Paragraph settings twisty for table cell styles in editor
  
  * Fixed minor typo in 2.1.11
  
  * Update Text Script tooltip with list of complex scripts that have
    additional script settings
  
Bug fixes and improvements in 2.1.10 (23 Mar 2022)

  * Fixed \zfiga bug which meant pictures in non-scripture books were missing
  
  * Improved bridged hanging poetry numbers (to go vertical)
  
  * Improved stylesheet settings and updated tracing-s
  
  * Handle chapter ranges in references
  
  * Fixed localizing of $(REFs) for modules
  
  * Fixed various minor TeX macro issues
  
Bug fixes and improvements in 2.1.9 (19 Mar 2022)

  * Added syllable based hyphenation for 5 Indic scripts: mlym taml telu knda orya
  
  * Ensure Archive contains all files in config
  
  * Fixed buglets in \input
  
  * Fixed bug in changing fontsize of p in sidebars
  
  * Improved error messages to show the most useful part of error log
  
  * Fixed notes settings styletype
  
  * Trigger files are TeX and Trigger groups are USFM
  
  * Fixed issues with lost and/or repeated footnotes
  
  * Change how // is handled (in colophon text)
  
  * Help sfm parser to better handle milestones
  
  * Added extra logging levels: 5 for full files, 7 for individual string changes
  
  * Improved tables, making them less horrible by default
  
  * Added extra figure option to scale relative to paper *width* rather than text width
  
  * Improved handling of wide table columns to be somewhat graceful
  
  * Fixed fontscale bug on fallback font
  
  * Improved handling on non-standard font\-names in fc-list
  
Bug fixes and improvements in 2.1.8 (12 Mar 2022)

  * Get custom scripts working #629 and allow .py files to be run directly

  * Fixed missing filepath tooltips on some key files
  
  * Fixed table columns for RTL and TOC
  
  * Fixed table leaders incl for RTL
  
  * Solve (most?) issues for tables with categories

Bug fixes and improvements in 2.1.7 (9 Mar 2022)

  * Allow reference chapter ranges like PSA 23 or JHN 2-4
  
  * Added option Show Strong's Numbers
  
  * Fixed Strong's reference issue specific to Windows encoding
  
  * Various TeX bug fixes

Bug fixes and improvements in 2.1.6 (8 Mar 2022)

  * Fixed RTL Table of Contents
  
  * Include referenced books in Module archive
  
  * Fix table column widths
  
  * Ensure Marginal Verses and Hanging Verses are not both enabled at the same time
  
  * Fix marginal verses
  
  * Fix setting table column widths
  
  * Add automatic name update on marker creation (in Styles)

Bug fixes and improvements in 2.1.5 (3 Mar 2022)

  * Enhanced book list which can also contain a list of references #76
    (allows list of passages like: GEN 1:1-end PSA 23:1-end LUK 15:11-32 GLO)

  * Added option to allow side column x-refs to align to the side of the text

  * Use script-specific reference separators for Arabic script which fixes 
    RTL marker causes printing a Bible Module to fail #618
  
  * Align marginal verses with the baseline
  
  * Cross-references in 2 cols now balance
  
  * Fixed table of contents widths and leaders #615, treat spacebefore=0 as autowidth
  
  * Fixed hang over missing verse numbers

  * Fixed guide rules for centre notes
  
  * Fixed missing footnotes on final page #617
  
  * Minor improvements to tooltips
  
  * Multiple behind the scenes improvements to the TeX macros
  
Bug fixes and improvements in 2.1.4 (14 Feb 2022)

  * Keep centre xref column the same height as the text blocks
  
  * Fixed final page single column footnotes #617
  
  * Fixed FileNotFoundError on generate final SFM #607
  
  * Fixed regular typeface doesn't always show in font chooser #609
  
  * Remove space leakage in marginal verses
  
  * Reduce threshold to actual rag
  
Bug fixes and improvements in 2.1.3 (13 Feb 2022)
  
  * Fixed typo in archive creation
  
  * Fixed cross ref files in archives
  
  * Fixed bad last page breaks
  
Bug fixes and improvements in 2.1.2 (12 Feb 2022)
  
  * Improved ending 2 cols to the minimum balanced height
  
  * Improved slop handling for cutouts

  * Fixed shifting marginal verses
  
  * Fixed missing pictures
  
  * Fixed poor page breaking
  
  * Fixed gridding for bottom-aligned sidebar figures
  
Bug fixes and improvements in 2.1.1 (8 Feb 2022)
  
  * Fixed missing Table of Contents
  
  * Added KBS max page size as an option
  
  * Added after chapter/verse space factor controls on Advanced tab

  * Ensure sidebar foreground and background images are also archived
  
  * Removed superfluous error message when deleting a config
  
Bug fixes and improvements in 2.1 (5 Feb 2022)

  * Study Bible layouts are now supported (\ef, \ex, \esb, etc.)

  * 2 columns give the best balance that has a line difference <= Unbalanced Lines setting
  
  * Added outer gutter setting to layout options (for journaling layouts)
  
  * Added Space beside parameter for cutouts/sidebars
  
  * Added vertical and horizontal padding controls to sidebar borders
  
  * Added \zlabel, \zpage, \zref milestones (for cross-referencing page numbers)

  * Fixed centre column notes lines heights, and prevent them overfilling
  
  * Fixed above rule spaces
  
  * Fixed editing booklist from the keyboard
  
  * Fixed window can't be resized to fit the narrower content #605

Bug fixes and improvements in 2.0.34 (24 Jan 2022)

  * Added Delete button to Help tab to remove temporary folders
  
  * Fixed UI suddenly closing when interacting with Styles tab #608
  
  * Improved layout of Rule and Spacing options (fix for Indonesian)

Bug fixes and improvements in 2.0.33 (21 Jan 2022)

  * Added cat-esb UI elements in Styles area (not yet accessible)
  
  * Added Sidebar Images dialog (not yet accessible)

  * Added column controls for study notes
  
  * Added rule options for Study Notes
  
  * Added UI for Stretch option in font dialog
  
  * Added Ornament boxes (mostly functioning)
  
  * Added -I option to commandline options to show widget identities

  * Improved Cascading Styles in TeX macros
  
  * Improved xref and external xref list UI interaction
  
  * Improved handling of categories in tables (work in progress)
  
  * Improved appropriate single book default for new project
  
  * Make BorderHPadding work with plain and double-bordered boxes
  
  * No longer loads Default config when starting from command line
  
  * Modified fwd version changes to updates so can run on newer files
  
  * Fixed starting up with no config
  
  * Fixed footnote rules for study bibles
  
  * Fixed missing ToC leaders issue
  
  * Fixed xref handling of books with no xrefs

  * Fixed booknames and the attribute naming mess
  
  * Fixed booknames inference from usfm files
  
  * Fixed buglet in handling books with no names
  
  * Fixed images in sidebars with GUI-prefered configuration
  
  * Fixed header styling bug
  
Bug fixes and improvements in 2.0.30 (12 Jan 2022)

  * Override styles for \nd and \pn to NOT use underlining (on by default in usfm.sty)
  
  * Add basic support for \ef StudyNotes
  
  * Add Treasury of Scripture Knowledge data
  
  * Cache cross reference lists to run faster
  
  * Cross reference resizing fixes
  
  * Prettify Strong's numbers
  
  * Clear fontscale if set fontsize and vice versa (regain control over font sizes)

  * Fix annoying notes wrapping bug. Resize final page with notes better
  
  * Fix diglot stylesheet loading in tex on windows
  
  * Fix single column cross references and study notes
  
  * Fix nested paragraphs in notes (e.g. \fp)
  
Bug fixes and improvements in 2.0.28 (13 Dec 2021)

  * Various improvements to Strong's index UI and file creation (XXS book is default
    (book for index, ragged column option, variables set within same dialog, option
     to open index after creation, index automatically gets added to booklist)
  
  * Fixed column-balancing algorithm to better handle rounding errors of height calcs
  
  * Peripherals page tidied up so that variables can be edited aside from front matter
  
  * Fix not multi editing the same settings file
  
  * Fix missing Cancel + Apply buttons in Mini and Basic views
  
Bug fixes and improvements in 2.0.24 (11 Dec 2021)

  * Removed all references to SSL which had a cryptography dependency which seems to
    have been triggering a false positive virus warning* on some (bitdefender) systems
    * 13/11 - This is still an ongoing issue on systems with bitdefender anti-virus

  * Fixed: Reference allrefs handles non scripture books

  * Fixed: Default internet access off while there is no user config

  * Fixed: Books indexing from 0 rather than 1. Recalculate books available

Bug fixes and improvements in 2.0.22 (10 Dec 2021)

  * Rolled back recent changes to foundational TeX macros to maintain stability
    (Revert "Merge branch 'fix576')

  * Patched \pipe warning/error in ruby glossing

Bug fixes and improvements in 2.0.21 (9 Dec 2021)

  * Click to Download Updated version button now works
  
  * Fixed: changes to locked config were being saved when a config was changes
  
  * Fixed: Pictures weren't showing up when config was saved with a new name

Bug fixes and improvements in 2.0.20 (7 Dec 2021)

  * First public release through recently updated TeamCity build server

  * Remove extraneous spaces from TOC entry processing #595 (\toc1 marks cause 
    the following paragraph to have incorrect justification)
  
  * Ensure \cl marker is applied to all books/chapters when enabled (affects XX* songbook)
  
  * Updated code for generated batch file script to just work without first changing path
  
  * Turn on page numbers by default at the start of a new book
  
  * Fix styleditor to not show standalones and fix up naming in the tree view
  
  * Add smarter links to style editor for Strong's dialog
  
  * Remove leaking space in RTL page layout
  
 (* Click to Download Updated version button is still broken - SSL library issue)
  
Bug fixes and improvements in 2.0.17 (4 Dec 2021)

  * Added Strong's Numbers cross-reference system along with a powerful, configurable
    localized Strong's Index generator - hiding under 'External Cross-reference Settings'
    tab of the Notes+Refs page. It generates an XXA/B.../G file to be included in booklist.

  * Added configuration-specific PrintDraftChanges (changes.txt is now for config-specific 
    changes, while project-wide changes remain in PrintDraftChanges.txt) #587

  * Various improvements to View/Edit page:
    - preserve edits when switching between tabs
    - blank lines are no longer hidden/invisible in tabs (Front Matter, AdjList, Final SFM)
    - two tabs available for editing settings (making it easier to edit commonly used files)

  * Enhanced Style editor to handle Vertical Position for table \tc markers
  
  * Copy Configuration dialog now shows projects horizontally in alphabetical order
  
  * Added option to suppress insertion of a blank (even) page after front matter

  * Fixed: Footnotes on final page of book missing

  * Fixed: Marginal verse column shift leaking into introductions #594

  * Fixed: Update button on status bar (now shows up if a newer version is available)

  * Fixed: Generated AdjList for diglot publications are faulty #581

  * Fixed: stylesheet handling making an incorrect assumption #577
  
  * Fixed: Footnotes Style Control for Paragraph Indention not working #560
  
  * Fixed: FirstIndent for footnotes, improved book name calculations and note columns

Bug fixes and improvements in 2.0.15 (19 Nov 2021)

  * Fixed: Now respects \nopagenums for front matter pages of diglot publications
  
  * Fixed: Verse numbers in header of diglots sometimes innaccurate
  
  * Note: setting \MarkTriggerPointstrue helps identify paragraphs in intro matter

Bug fixes and improvements in 2.0.14 (18 Nov 2021)

  * Fixed: Alignment of page numbers on title page footers
  
  * Improved compliance with PDF/X-1a (which bans /Actions)
  
  * Fixed: Diglot on-grid alignment

Bug fixes and improvements in 2.0.13 (17 Nov 2021)

  * Fixed: Missing initial Table of Contents line for Primary diglot table
  
  * Fixed: ptxprint.sty file was getting excluded for non-diglot projects
  
Bug fixes and improvements in 2.0.11 (14 Nov 2021)

  * Fixed: Refresh captions now works and also updates diglot captions as advertised
  
  * Fixed: Front matter fonts and styling in diglots now follow primary settings
  
Bug fixes and improvements in 2.0.10 (13 Nov 2021)

  * Fixed: unwanted diglot pagebreak after mt
  
  * Fixed: Ch:Vs separator selection not being remembered
  
  * Fixed: PicList table kept switching to wrong view
  
Bug fixes and improvements in 2.0.9 (11 Nov 2021)

  * Table of Contents for Diglot publications can specify L (Pri) or R (Sec) filters
  
  * Fixed: Diglots failed to print with .doc error
  
Bug fixes and improvements in 2.0.6 (10 Nov 2021)

  * Picture captions can now be refreshed from Paratext USFM files #435
  
  * Allow switching 1->2 cols for specific books (previously only 2->1 was possible)
  
  * Improved tooltip to help prevent error if you enter # in a header string. #551
  
  * Slow run warning for CMYK picture conversion (affects non-"Digital" outputs)
  
  * Allow negative fake italic slant
  
  * Handle badly formed USFM files better
  
  * View/Edit button changes according to context #554
 
  * Show full name rather than truncating '.pdf' from filenames in peripherals
  
  * Added include "Filename" support to PrintDraftChange
  
  * Handle standalone markers in parser

  * Fixed: crash if a faulty xdv is generated, e.g. bad font. 
  
  * Fixed: Bug in ToC when two \toc1 markers occur on a single page #569
  
  * Fixed: Module behavior differs between Paratext and PTXprint #571
  
  * Fixed: Trying to manually add an image to PicList failed #563
  
  * Fixed: picture associated with poetry won't output #573
  
  * Fixed: glyph metrics warning when returning from diglot #542
  
  * Fixed: page growth when blank page inserted
  
  * Fixed: Warning re compatibility settings - don't show to new users #553
  
Bug fixes and improvements in 2.0.5 (27 Oct 2021)

  * Fixed: Rendering issue with some Devanagari conjuncts if letter spacing is on #561

  * Fixed: Creating an Archive fails (sometimes) #562
  
  * Fixed: After creating a new configuration, trying to open output folder location failed #564
  
  * Fixed: Spurious space in marginal verses
  
  * Fixed: Only pad certain images (don't pad when creating cutouts)

  * Fixed: Chapter label \cl handling was being overriden
  
  * Improved: Keep book number together with book name "1 Kings", "2 Samuel" within \xt
  
  * Improved: Allow non paragraphed footnotes to rag
  
  * Improved: Seemingly 'erroneous error messages' now give more information to track them down #552

  * Added: \zglm marker to format font, size, colour, position of glossary *marks* #565

  * Added: Support for Creative Commons license logos with CMYK using \zccimg for front matter or colophon
    e.g. \zccimg by-nc-nd|size="col" pgpos="pc" scale="0.15"\*

Bug fixes in 2.0.4 (21 Oct 2021)

  * Fixed spaces in the caller area of the footnotes #557
  
  * Fixed font codes leaving a space in footnotes (v2.0.2) #556
  
  * Fixed repetitive use of PTXprint (for >3 hours?) causes a ValueError #555
  
  * Fixed (?) Glossary Words Markup Style selector not working
  
  * Fixed PicList blanks out when config name is edited but not changed
  
Bug fixes in 2.0.2 (20 Oct 2021)

  * Fixed erroneous error message #552
  
  * Added missing eng.vrs file for referencing to work properly
  
  * Fixed style editor issues when adding new markers
  
  * Handle 'at REF' change specification better for bridged verses

Bug fixes in 2.0.1 (19 Oct 2021)

  * Fixed Odd changes in v2.0 - Base Paragraph Indent gone wrong #550

Bug fixes and Improvements in 2.0 (18 Oct 2021)

  * https://software.sil.org/ptxprint/whats-new-in-version-2-0/ reflects changes made since 1.0

  * Increase dead cycles from 75 to 100 to prevent giving up with pictures in diglot prematurely 
  
  * Fixed crash on trying to delete one or more rows from PicList
  
  * Fixed faulty usfm and usfmerge not breaking nb in diglots
  
  * Fixed fn/xr callers/callees in headings and diglots not respecting font settings #541
  
Bug fixes and Improvements in 1.9.7 (16 Oct 2021)

  * Allow better control over Dual Captions in diglots (and show in PicList table)
  
  * Fixed wrong folder location displayed after creating Archive #545
  
  * Don't allow changing font size, line spacing of \p marker (use Layout tab instead)
  
  * Fixed 'at' rules from wrongly targeting other chapters (\c 2 was matching \c 20 etc.)
  
  * Fixed bugs in 'Add/Edit Style'
  
  * Fixed \wh ...\wh* and \wg ... \wg*  to handle runs of RTL and LTR text better
  
Bug fixes and Improvements in 1.9.6.2 (13 Oct 2021)
  * Note: Compatibility settings on Advanced page get reset by this version
    (and an informative message is displayed - which most people can safely ignore)

  * Improved UI resizing behaviour on Pictures page
  
  * Fixed Chapter numbers are sometimes missing #538
  
  * Fixed 'Hide empty verses' still leaving empty whitespace in PDF #540
  
  * Fixed Notes/Xrefs missing when 'Start each on new line' was set
  
  * Fixed Crash on 1st startup if never been run before on machine
  
  * Fixed bug where config-specific PicLists were being overwritten by Default PicList
  
  * Fixed missing icons
  
Bug fixes and Improvements in 1.9.6 (8 Oct 2021)

  * Added ability for selection and editing of multiple pictures #479
  
  * Illustrations in diglots can now have multiple captions #511
  
  * Moved digit mapping to be part of the font definition within the font chooser #433
    (This allows different styles to use the same font but with different digit mappings.)

  * Added greater flexibility for positioning lines for footnotes and cross-refs #527
  
  * Added most-recently used functionality to booklist #521

  * Added a 3-tier view (Mini, Basic, Full) system for UI to replace Basic and Advanced
  
  * Improved wording of mysterious error messages for markers #536
  
  * Improved logic for AdjList creation (specifically, overwrite y/n behaves now)

  * Fixed multiple PicInfo.txt files found in a project #512
    (Renamed publication specific picInfo.txt to picChecks.txt)
	
  * Fixed diglot merging of \cl chapter label issues #485
  
  * Fixed RTL books don't have correct binding side #525
  
  * Fixed error on attempting to Select Page Border (or any other PDFs) #535
  
  * Fixed multiple diglot merge issues (inc. primary text repeats leaving gaps #532)

  * Fixed footnotes from getting lost on 2->1 and 1->2 col transition #533
  
  * Fixed outputting footnotes at end of singlecolumn books
  
  * Fixed side-bar width issue, and zgap after a rem

Bug fixes and Improvements in 1.9.5 (19 Sep 2021)

  * Added option to allow for unbalanced columns (Bottom Rag on Layout page)
  
  * Added ability to suppress, re-enable and reset page numbers (esp. for FRT matter)
      using codes: \nopagenums, \dopagenums, \resetpagenums N   (if N<0: i, ii, iii)
  
  * Added support for Paratext's traditional manual line break (i.e. // = \u2028)

  * Added "A4 with crop marks" as an optimum paper size for local printing and binding
  
  * Remember folder location of previously selected PDF when selecting a new file #520, #188
  
  * Provide an alternative way to format Table of Contents entries #73  
  
  * Improved logic for "Prevent Orphan Words" to only force shorter words

  * Improved logic for calculating adjust lists (indicating grow and shrink options) #493

  * Fixed odd empty line at bottom of page #489
  
  * Fixed Full-page picture vertical alignment issues #505
  
  * Fixed Hide Empty Verses affecting the output of a change rule (\pagebreak missing) #522

  * Fixed Adding a new style doesn't always work the 1st time around #513  
  
  * Fixed intro matter jumping off grid causing misalignment
  
Bug fixes and Improvements in 1.9.4 (11 Sep 2021)

  * Added option to have the header in a second language/script #500
  
  * Added an alternative way to format Table of Contents entries (cat:toc|tr etc.) #73
  
  * Added option to have Leaders in Table of Contents #490
  
  * Added ability to create "Reader layout" with verse numbers in center gutter (beta)
  
  * Make it obvious that VALUES need to be filled in on the variable list #492
  
  * Fixed PTXprint doesn't start after installing #516
  
  * Fixed Adding a new style doesn't always work the first time around #513
  
  * Fixed Creating FRT matter often fails when starting off #514
  
  * Fixed bug of "Hide Empty Verses" having a dependency on "Auto-Correct USFM" in UI #502
  
  * Add / verify "start chapter 1 on new page" support in diglots #429
  
  * Added \zgap and \zrule as configurable milestones #488
	e.g.  \zgap|9em plus 2em\*     or     \zgap|0.7in\*
          \zrule|align="c" width="0.75" thick="0.5pt"\*    or   just \zrule \*

  * Fixed full-page picture vertical alignment issues #505
  
  * Fixed 1-line diglot footnotes get a footnoterule going through them #508
  
Bug fixes and Improvements in 1.9.3 (30 Aug 2021)
  
  * CHANGED: output location from "<projID>\PrintDraft" to "<projID>\local\ptxprint" folder
	* All temporary files are hidden away in sub-folders of this target folder
  
  * Added Peripherals tab to UI for better handling of config-specific front matter
	* Added feature to create config-specific front matter with variables
	* Added feature to import Paratext PDFs as part of front matter
	* Added feature to import Paratext FRT periph sections as part of front matter
	* Improved table of contents, including various options to categorize and sort
  
  * Added feature to copy configs to other Paratext projects #480
  
  * Improved 'Hide Empty Verses' and added option to show ellipsis #478

  * Typing new configuration name no longer selects similar configuration instead #468
  
  * Improved 'Column of xRefs' feature to also work with single-column layout
  
  * Added warning for lack of EL compliance if 'SIL' found in copyright statement
  
  * Non-English UI web links (to USFM help) are routed through translate.Google.com
	* and 'Only use English Links' option added to prevent the new behaviour if needed
  
  * Added advanced option 'Disable ALL internet use' - especially for sensitive locations

  * Fixed Multi Credit Overlays to work with verbose picture filenames
  
  * #475 Preserve notes on 1->2 and 2->1 column transitions

  * #483 fix ptxprint-mod.sty not being included from secondary diglot text 
  
  * #486 fix --book fails to select book(s) to print on command line 
  
Bug fixes and Improvements in 1.9.2 (29 Jul 2021) 

  * Temporarily removed "Update Available" feature due to current Python SSL bug
  
Bug fixes and Improvements in 1.9.1 (28 Jul 2021) 

  * Added Update button to status bar (shows if a newer version is available)
  
  * Diglot should obey nobreaks after headings better now
  
  * Added diglot copyright default (enabling info from both projects to be displayed)
  
  * Fixed bug to support \zimagecopyrights with no lang be formatted with non \pc markers
  
  * Fixed bug of files missing from archive
  
  * Fixed missing missing page number on even Intro pages (NoVevenfooter)
  
  * Improved hiding of Intro matter and Intro-Outlines to be more reliable
  
Bug fixes and Improvements in 1.9 (6 Jul 2021) 

  * Added button to Return to primary project when configuring secondary project of diglot
  
  * Fixed USFM parser heirarchy recovery
  
  * Fixed AdjList creation bug, and introduced better error message reporting
  
  * Hopefully prevent pagebreak mid-cutout for raised chapter labels
  
  * Fixed wrapping marginal verses
  
  * Improved functionality of 'at' changes so that this is now also possible:
        at ROM 1:3 '\\v 3' > '\\v 3-4'
        at ROM 1:4 '\\v 4 ' > '' 
  
  * Fixed and improved mymr syllable breaking
  
Bug fixes and Improvements in 1.8.9.1 (25 Jun 2021) 

  * Added option to Omit Captions for illustrations
  
  * Added PDF Output Format option for PDF standards conformance (Advanced page)
    (Digital=RGB, Print=CYMK, Transparency, and Archive)
  
  * Allow PDFs to be used as illustrations
  
  * Updated wording and graphics on the Layout page
  
  * Changed hard-to-find Adv/Basic mode slider to a Show More/Less button
  
  * Added hook to allow triggering of caller reset on chapter breaks
  
  * Fixed bug in auto-numbered callers and enable 
  
  * Fixed chapter number cutouts for \nb (no-break para over chapter boundary)

  * Fixed calculation for 'Space above header' on Layout page
  
  * Fixed error with picture positioning set for 'After Paragraph'
  
  * Fixed position of final major line in graph-paper

  * Fixed page break \pb or \pagebreak support in diglots

Bug fixes and Improvements in 1.8.3 (11 Jun 2021)

NOTE: The child markers of \f and \x now follow the settings of their parent marker styles.
      As a result there may be changes in the way footnotes and cross-references appear.
	  It is recommended that you RESET these styles to use the default settings prior
	  to trying to remedy settings manually.
	  
  * Fix handling of Grk/Hbr embedded within RTL/LTR text e.g. \wh Hebrew\wh*
  
  * Fix bug in style editor affecting the setting of bold italic etc.
  
  * Fix diglot gridlines
  
  * Polyglot support now available in TeX macros (but not yet in PTXprint user-interface)

  * Fixed AdjList generation
  
  * Fixed interlinear alignment issues
  
  * Allow PrintDraftChanges.txt to do location-specific changes using keyword 'at'
    e.g.  at GAL 3:16 "yesukrist" > "yesu krist"  (only make this change in one verse)
	or    at JHN "kurpa" > "permata daya"         (only make this change in one book)

Bug fixes and Improvements in 1.8.2 (2 Jun 2021)

  * Fixed module handling (again) to be more flexible with references
  
  * #457 Vertical Space Separating Footnotes and XRefs fixed
  
  * #458 Indent First Paragraph fixed
  
  * #459 Hide/Exclude Contents of Marker fixed for all markers
  
Bug fixes and Improvements in 1.8.1 (29 May 2021)

  * Fixed Paratext module processing to be more robust
  
  * Fix resetting style font to main font
  
  * Fixed Hyphenation file generation issues
  
  * Fixed #452 Adding a new style fails
  
  * Fixed #451 Footnote problems

  * Allow page size separator to use , or x as dimension separator
  
  * Fix strange colophon behaviour
  
Bug fixes and Improvements in 1.8 (24 May 2021)

  * Added new feature to include cross-references from external lists in centre column
  
  * Fix bug which caused modules with spaces in their name to create an unopenable PDF
  
  * Fix centring header centre when marginal verses
  
  * Provide more context in error messages to help track issues better
  
  * Add bridgeVerses macro enabling on-the-fly bridged verses (useful for marginal verses)
  
  * Ensure .triggers files are included in .zip archives

Bug fixes and Improvements in 1.7.9 (20 May 2021)

  * Show flattened module in Final SFM tab when typesetting a module
  
  * Fixed not showing chapter numbers in single chapter books

  * #447 Add \CalcChapSizefalse to force user-specified chapter size and raise
    rather than auto-calculated values
  
WARNING: For those using RTL scripts:
     The TeX macros have been changed for RTL for Right and Left Justification 
     such that they are swapped. This means that you no longer have to swap the 
     Right and Left Justifications on markers like \q. If justification is Left, 
     it will be Right-justified. PTXprint *should* update your styles automatically.		 

NOTE: For those previously using various Border and Grid PDFs as watermarks:
     There is now a better system for Guides and Grids (see Layout page), so the
	 various Border and Grid PDFs have been removed from the Watermark PDFassets.
	 Also note that the 'Crop Marks' option still exists, but on the Advanced tab.

Bug fixes in 1.7.2 (15? May 2021)

  * Fix bug in PicList generation for USFM3 files

Bug fixes in 1.7.1 (11 May 2021)

  * TypeError bug fix for Style editor

Bug fixes and Improvements in 1.7 (30 Apr 2021)

  * Added UI localisation for Indonesian (tooltips yet to be done) - thanks to DC & RN
  
  * Add Western-Cham digits as an option
  
  * Add alternative diglot merging/aligning scheme
  
  * Add diglot feature "Adjust Center Header" to align with the gutter/line 
  
  * Allow Anchor Reference column to be resized in PicList viewer
  
  * Disable splitting footnotes across pages (caused duplicate FN fragments to show up)

  * Fix moving end of ayahs and end of ayah marks around verse ranges
  
  * Fix fontscale switching messing with the value
  
  * #441 Fix strange rangeref with no verses in a column issue
  
  * #438 Pictures now work more predictably in non-scripture books (FRT, BAK etc.)
  
Bug fixes and Improvements in 1.6.9 (23 Apr 2021)

  * Added option to include Guides (rules and baselines) and/or custom Grid behind text
  
  * Fixed overflowing pages with footnotes
  
  * Footnotes don't overfill the page now (but could have extra space at end of page)
  
  * Fix footnote spacing below text
  
  * Space above and below footnote rule can now be set independently
  
  * Fixed another bug in unpacking DBL bundles
  
  * Letter spacing no longer breaks strings with stacking viramas, ZWJs or ZWNJs
  
  * Generate Table of Contents no longer crashes when Letter Spacing is enabled

Bug fixes and Improvements in 1.6.1.1 (16 Apr 2021)

  * Fix TeX macro which was causing a crash when 'Minus'/'Plus' occured after a verse number
  
  * Various minor improvements to TeX macros

Bug fixes and Improvements in 1.6.1 (13 Apr 2021)

  * Add "End-of-Ayah" option for verse decorator on the Tabs+Border tab 
  
  * Added option to move "End-of-Ayah" to end of verse

  * If "Include Pictures" is checked but no PicList is found, auto-initiate "Generate" dialog
  
  * Autoinsert beginL/R in zimagecopyrights
  
  * Make DBL bundle unzipping more intelligent so that it finds the metadata file even if buried
  
  * Update styles by version
  
  * Provide helpful feedback if user tries to print when fonts have not yet been set 
  
  * Add "How?" link to Pictures "Omit only app and web pics" option
  
  * Fix derived fonts on reset configurations
  
  * Fix interlinear for Intro matter (ch1:vs0)
  
  * Fixed Preferred image type handling to follow the list of extensions strictly
  
Bug fixes and Improvements in 1.6.0.4 (1 Apr 2021)

  * Added Decorative Section Heading graphic for 2-col layouts
  
  * Fixed RTL defaults
  
  * Added autogenerated tooltips to Font Feature selection dialog
  
  * Fixed Copyright credits missing "All other illustrations..."
  
  * Allow longer Colophons to flow onto subsequent page
  
  * Turn off image copyrights for colophon if pictures are not enabled

Bug fixes and Improvements in 1.6.0.3 (26 Mar 2021)

  * Fixed Adjust Lists for diglots (again!)

Bug fixes and Improvements in 1.6.0.2 (25 Mar 2021)

  * Paragraphed endnotes are now working
  
  * The whole of the Arabic UI is RTL (when used with the appropriate locale settings)
  
  * PDF bookmark list improved
  
  * Fixed Adjust Lists in diglots (not!)
  
  * Don't swap left and right style alignment when choosing script direction (as the macros handle it)
  
  * Make sure all Footnote and Cross-Reference settings are remembered and do as advertised

  * Removed "Persian" digits from list of scripts - use "Arabic-Indic" instead
  
  * Added "Fullwidth" digits to list of scripts - mainly used with CJK scripts
  
  * Fixed picture media settings: (P)rint  (A)pp  (W)eb  now respect default values

  * Outstanding known issue: There is an occasional problem with (long?) footnotes getting doubled in diglots.
    This is probably triggered when a footnote is the reason for a heading to be moved onto the next page, so
	a good workaround is to use the AdjList to jiggle the text at that point until it resolves.

Improvements in 1.6 (19 Mar 2021)

  * Diglot code has been re-written to be more robust and adaptable to structural differences between texts

  * Enabled Diglot texts to switch sides (left/right inner/outer - especially useful for RTL)
  
  * Button to automate optimizing of the column widths for primary and secondary columns of diglots
  
  * Localization of UI is now available through Crowdin via https://crowdin.com/project/ptxprint

  * Added ability to overlay image credits on pictures (specifically to comply with David C Cook image use requirements)
  
  * Pictures in peripheral books (INT, BAK, GLO etc.) can now be manipulated via the PicList like all other pictures
	
  * PTXprint now ships with its own version of XeTeX so that it can even run without Paratext installed

  * Can now select and use any folder for projects if "My Paratext 8/9 Projects" folder isn't found
  
  * Font feature editor added to Font Selection dialog (enabling specific features to enabled/disabled)
  
  * Added "Quick Run" option with a Warning/Status message in red on the bottom status bar after a run

  * Page numbering now allows negative numbers - which enables roman numerals for introductory pages
  
  * Allow horizontal spacing between footnotes (and cross-references) to be specified with min+max values

  * Spacing before/after footnotes (and/or cross-references) can now be specified in Styles editor

  * Colophon can now be forced to a new page if needed, and can include special characters
  
  * Magic codes: \zcopyright, \zlicense and \zimagecopyrights can now also be used in FRT or INT books
  
  * Generated \zimagecopyrights statements can now be localized by adding a language code: \zimagecopyrightsfr
  
  * DBL bundles and PT modules now work more smoothly 

  * Several Tooltips have been updated to reflect addition of the Styles editor

  * Several tabs have shortcut links to appropriate Styles in the editor, and Styles can now be searched for
  
  * All program exceptions (crashes) are reported and copied to the clipboard for easier reporting
  
  * Margin settings have been greatly simplified and include graphics to show what exactly is being set
  
  * Magic buttons to optimize line spacing or top/bottom margins to optimize layout and minimize wasted space

  * Tooltips updated with more accurate context-specific help information 

  * Dozens of other minor bug fixes since 1.5 

Bug Fixes in 1.5.22 (18 Mar 2021)

  * Fix: Unable to print after creating archive

  * Fix broken Tooltips
  
  * Fix note spacing problems
    
Bug Fixes and Improvements in 1.5.21 (17 Mar 2021)

  * Major review and update to tooltips
  
  * Update UI significantly and shuffle some of the pages into a more logical order
  
  * PicList generation for Diglot pictures improved significantly
  
  * #422 Generate..." Picture references for books UNCHECKS the "Only Show" option
  
  * #424 PTXprint reopens previous Project config, after making a new Project Config
  
  * DBL Bundle download and install process made more straightforward
  
  * Note that the option to "Combine PDFs" has been removed - it is now always the default

Bug Fixes and Improvements in 1.5.18 (12 Mar 2021)

  * Pictures in peripheral books now work and can be manipulated via the PicList settings 
    Notes: you will need to regenerate the PicList for those peripheral books
           you can also use a \k keyword or phrase\k* as picture Anchor Ref (e.g. BAK k.keywordorphrase)
  
  * Title bar now reflects Diglot project name and config
  
  * Adjust margins when upgrading from existing saved configs
  
  * Fix AdjList generation so that it is sorted properly
  
  * Thumbtab UI improved 
  
  * Installer shows the Release Notes BEFORE installation (giving you a chance to back out if needed)
  
Bug Fixes and Improvements in 1.5.17 (10 Mar 2021)

  * Bug fix: Media permission tooltip (in Pictures, Details) works now - was broken since localization was introduced
  
  * Diglot printing of chapter ranges for single books now works, and chapter ranges are ignored for multi-book diglots
  
  * After the magic column width is calculated it now prints the diglot - so you can immediately see the result
  
  * Check to see if all required books are available in BOTH projects before attempting to create a diglot publication

  * Bug fix: false assumption that Andika is installed (changed tracing font to Arial)

Bug Fixes and Improvements in 1.5.16 (6 Mar 2021)

  * Allow \zimagecopyrights and following language code to be case-insensitive
  
  * Several bug fixes to Diglot handling
  
  * Updated margin graphics to reflect more accurate bottom margin
  
  * Better TeX error log handling
  
  * Credit Overlays can be applied to multiple pictures
  
Bug Fixes and Improvements in 1.5.15 (4 Mar 2021)

  * Fixed a bunch of bugs that new users would encounter when starting to use PTXprint
  
  * Add Credit Overlay for (DCC!) illustrations
  
  * Diglot macros have been significantly improved to be more robust [but testing is ongoing...]
  
  * Handle syntax errors in referenced scripture from a module
  
  * Set footnotes to be smaller by default
  
  * Magic button to calculate & optimize column widths for diglot publications
  
  * Swap Pri/Sec sides of diglot works now and also makes appropriate changes to headers
  
  * Improve diglot merge chunking and reordering
  
  * Enable localized \zimagecopyrights (by adding language code) -> \zimagecopyrightsfr (for French)
  
  * Fixed issues with \toc3, thumbtabs and ToC

Bug Fixes and Improvements in 1.5.14.4 (25 Feb 2021)

  * Fix module loading

  * Allow DBL import for in spec (old spec) DBL bundles

  * Fix Linux PPA building

Bug Fixes and Improvements in 1.5.14.1 (22 Feb 2021)

  * Fix fatal (Faux) error when trying to switch UI languages
  
  * Fix #405 missing Param
  
  * Fix linux install application fonts path
  
  * Add Use Glyph Metrics legacy control
  
  * Fix missing remembered paratext directory
  
  * #394 xt regex and usfm exception reporting
  
  * Fix piclists for add and remove
  
  * #393 Always output any selected borders in ZIP Archive even if borders are turned off
  
  * Fix #406 regexes for excluding intro materials
  
Bug Fixes and Improvements in 1.5.13 (21 Feb 2021)

  * Allow \zimagecopyrights to be localized by adding language code to end of marker
  
  * UI changes on Layout tab to make margin settings clearer
  
  * Magic button to optimize line spacing, or top and bottom margins
  
  * Temporarily removed Image Credit Overlays (coming back soon)
  
  * Pictures tab has been re-worked to be easier to use and maintain
  
  * Address #399 and spurious bolding of style labels
  
  * Add SourceCodePro font for use in Cropmark text
  
  * Centre watermarks on the text page
  
  * Prevent letter spacing from messing up page breaks
  
Bug Fixes and Improvements in 1.5.12 (15 Feb 2021)

  * Added missing margin graphics files to installer
  
  * Added French A5-EBAUCHE.pdf (=DRAFT) to available watermarks, and an additional A5 border
  
  * Added missing icon(s): Clear edit, Selected Checkmark

Bug Fixes and Improvements in 1.5.11 (15 Feb 2021)

  * Font Size Factor now has a label displaying the (actual) calculated point size

  * UI changes made to facilitate all the margin settings on the same page

  * Credit Overlays has been introduced on the Pictures tab (4th sub-tab) - Warning: Work in Progress
    (Note that "Enable Colored Text" needs to be enabled for this feature to work with Light/Dark background shading)
	
  * #385 Footnote spacing fixed
  
  * #386 Fixed? Issue with Colophon not working
  
  * #389 Archive was failing to be built
  
  * #390 Saving edits to a named project
  
Bug Fixes and Improvements in 1.5.10 (8 Feb 2021)

  * Font Size Factor on Styles tab is now exactly that - rather than a point size
    (Note: we still need to add a label/tooltip displaying the actual calculated point size)

  * Enabled Diglot texts to switch sides (especially useful for RTL)

  * Changed magic codes to lowercase so they can be typed in paratext \zcopyright, \zlicense and \zimagecopyrights

  * Added "Quick Run" option with a red Warning/Status message on bottom status bar

  * Fixed not being able to delete new styles after saving and reloading

  * "Preserve Intermediate files" option has been removed. 
    (Note: "Remove Temp Files" button is now the recommended way to tidy up unwanted files in PrintDraft folder)
  
  * Removed variable line spacing from UI 
    (Note: this is still available through .tex file mods \XeTeXuseglyphmetrics=0).
  
  * Ensure auto-correct typing (c) --> © works in both copyright statements 

  * Fixed #376 regarding missing directories
  
  * Fixed #379 Empty \h fields are now ignored
  
  * Fixed bug where (Omit) Verse Numbers was doing nothing

  * Prevent crash from occurring if you hit print with an empty Settings page open (in View+Edit)
  
Bug Fixes and Improvements in 1.5.9.3 (3 Feb 2021)

  * Fix non-starting PTXprint due to lack of lang code in user config
  
  * Get rtl and ttb working again

Bug Fixes and Improvements in 1.5.9.1 (3 Feb 2021)

  * #368 Added Localization selection from within PTXPrint
  
  * Several fixes to localization (incl. glossary markup etc.)
  
  * Auto set line break locale for CJK scripts
  
  * Fixed #369 Page numbering failing (in specific case where there was no text on the page)
  
  * Show subset of Fonts+Script tab settings for basic users
  
Bug Fixes and Improvements in 1.5.9 (RC for ver 1.6) (2 Feb 2021)

  * Ensure settings are actually reset when reverting to default values in Style editor
  
  * Allow horizontal spacing between Notes (and cross-references) to be specified with min+max values
  
  * Close up gap between main body text and footnotes
  
  * Updated to TeX Live 2020 (on Windows)
  
  * Fixed bug of losing fonts when a project is changed
  
  * Make "Create Archive..." more robust (skips over any missing files)
  
  * Various refinements to underlying XeTeX macros

Bug Fixes and Improvements in 1.5.8.4 (28 Jan 2021)

  * Localization of UI is now available through Crowdin - contributions welcome! https://crowdin.com/project/ptxprint
    (aiming to release several languages for ver 1.6)
	
  * Fixed #349,#351 Verse numbers missing or too large in certain situations
  
  * Fixed #342,#354 Base Paragraph Indent value reverting to 1.0 after restart
  
  * Fixed bug on adding a first picture
  
  * \pb pagebreaks no longer cause an error message from the USFM validator
  
  * Colophon can now be forced to a new page if needed, and can include special characters

  * Note that PTXprint now ships with its own XeTeX binary so that it can run without Paratext being present
  
  * PTXprint will prompt for a folder with the (Paratext) Project Data if Paratext isn't installed 
  
Bug Fixes and Improvements in 1.5.7 (25 Jan 2021)

  * Allow configurations to be reloaded, and Default config to be "Deleted" (or re-initialized)
  
  * Updated various Tooltips to reflect current way of working
  
  * Gutter rule now perfectly in centre
  
  * Chapter selection no longer lost on project restart #283 (& use spinners rather than drop-downs)
  
  * Note that Colophon display has a known issue - spreads over multiple pages - (to be resolved next week)

Bug Fixes and Improvements in 1.5.6 (21 Jan 2021)

  * Fixed issue with saving/naming configurations
  
  * Page numbering now allows negative numbers - which enables roman numerals for introductory pages
  
  * Fixed AdjList generation
  
  * Adjusted FN and XR controls in UI to prevent nonsensical settings
  
  * Updated help in several Tooltips to reflect addition of Styles editor

Bug Fixes and Improvements in 1.5.5 (20 Jan 2021)

  * Fix exception generated from multi-threading

Bug Fixes and Improvements in 1.5.4 (18 Jan 2021)

  * Enable searching for Styles
  
  * Ensure that all exceptions are caught and put on the clipboard for better error reporting
  
  * Change some default values (poetry left aligned instead of justified; custom.sty is OFF by default)

Bug Fixes and Improvements in 1.5.3 (14 Jan 2021)

  * Several PicList bugs fixed - especially relating to diglot illustrations
  
  * Initialization of new projects and configs fixed
  
  * Fixed broken ImageCredits in colophon
  
Bug Fixes and Improvements in 1.5.2 (12 Jan 2021)

  * Pictures tab: Enable/Disable Details and Checklist tabs when Show/Hide Advanced features is clicked
  
  * Fix pictures not displaying without section headings present

  * Font feature editor added to Font Selection dialog
  
  * Re-enable fallback font selection
  
  #337 - weird fig list order fixed
  
  #338 - styles in the STY file were getting reordered
  
  #339 - Xref callers problem fixed
  
Bug Fixes and Improvements in 1.5 (23 Dec 2020)

  * Interlinear/Ruby glossing is now possible (for early testing and feedback)
  
  * Font selection and setup has been completely re-worked to enable more flexibility
  
  * Fancy Borders now has a lot more control over placement and scaling of decorations
  
  * Several UI improvements, and more flexibility in Style Editor
  
  * Printing possible from a DBL bundle (minimally tested, work in progress) 

Bug Fixes and Improvements in 1.4.3 (3 Dec 2020)

  * Switch \LineSpacing to be a multiple of base line spacing. 1.0 means base line spacing.

  * Fix deleting the output pdf as a temporary file

  * Delete old NestedStyles.sty files

  * Fix marks in tables in diglots

  * Give visual traceback for errors in archive creation

Bug Fixes and Improvements in 1.4.2 (1 Dec 2020)

  * Eliminate the need for NestedStyles.sty (this file can now be deleted permanently)
  
  * Significant improvements and bug fixes in the Style Editor
  
  * Updated Picture Checklist wording and integrated Reverse/Mirror settings with Details tab settings

  * Added "Location on Page" previews to PicList editor
  
  * Renamed various controls to reflect Base (on Layout tab) + Factor (on Style tab) settings
  
  * Added Help page link to Scripture Software Community
  
  * Fixed (Relative) Font Size and (Absolute) Line Spacing settings in Style editor
  
  * #306 Fixed adjusting Main Title's before and after space causing crash

  * Moved "Variable Line Spacing" to Advanced tab [currently still broken] 
  
Bug Fixes and Improvements in 1.3.8 (19 Nov 2020)

  * Re-arrange Pictures UI items and fix multiple bugs relating to picture handling

  * Moved links to a new Help tab
  
  * Improvements to Style editor
  
  * Fixed #293 for more logical access to ToC settings
  
  * #290 Add notes in Pictures Checklist 
  
  * #291 Add filter for Checking Status of Pictures

Bug Fixes and Improvements in 1.3.3 (14 Nov 2020)

  * Localized UI for Spanish (es) added - thanks to Phil Leckrone and team

  * Fixed verses in tables
  
  * Missing images now display as placeholders 
  
  * Errors display as dialogs
  
  * Prevent PTXprint locking up completely after failed outputs
  
Bug Fixes in 1.3.2 (11 Nov 2020)

  * Localized references now display properly in Modules
  
  * Inverted Show/Hide Advanced Settings switch (Defaults to off, remembers state in user settings)

  * Fixed averaging balancing (esp. for end of books)

  * Linux: Fixed description and icon entry
  
Bug Fixes and Improvements in 1.3.1 (5 Nov 2020)

  * Endnotes should now display at the end of each book
  
  * Add option to crop borders on all images (eliminates spurious lines on edges of illustrations)
  
  * Add (another) button on Help & Links tab to Create ZIP Archive (in the context of filing bug reports)

  * Fixed: #237 Piclist spinners not retaining typed values 
  
  * Fixed: #265 Changes to the picture scale not retained after closing and opening the app

  * Fixed: #267 Colophon did not print for single book PDF
  
  * Fixed: #268 Always start 1st Chapter on new page

  * Fixed: #269 Unable to add A4 watermark
  
  * Fixed: #271 We can't change a picture's filename inside PTXprint
  
  * Fixed: #273 Header can't display verse numbers when Marginal verse numbers used

  * Fixed: #275 Selecting "Letter spacing" prevents printing
  
Bug Fixes and Improvements in 1.3 (23 Oct 2020)

  * Stylesheet editor
  
  * PicList handling completely revamped
  
  * Media options 'P'rint, 'A'pp, and/or 'W'eb can be set according to series permissions 
  
  * Colophon text can now be generated automatically with Copyright, License & Pic Credits
  
  * Enabling PDF/X1-A outputs pictures in CMYK and doesn't compress the pdf (in order to conform with PDF/X1-A)

  * Buttons on View+Edit tab made context-sensitive 
  
  * Lock Config (on Basic tab) should now prevent settings being overwritten
  
  * Removed the Quick Run option as it is quicker now anyway, and the dialog is editable while you wait for the PDF

  * Fixed problems resulting from PicList not being saved
  
  * Fixed file-naming issues when creating new config
  
Significant Improvements in 1.2 (3 Oxt 2020)

  * Interface is now localizable (ask for details if you want to contribute a translated interface)
  
  * Added PicList parameter editor with preview to make it easier to edit parameters
  
  * Added in-line & cutout positioning options for illustrations (can also scale and mirror)
  
  * Added questions regarding appropriateness of illustrations (to encourage testing and reflection on which pictures are used)
  
  * Copyright Credits for illustrations are autogenerated (use the \zimagecopyrights marker in SFM to insert this automatically)
  
  * Thumb Tabs for booknames on outer edge of page
  
  * Added button to switch back and forth between two diglot projects
  
  * Added hanging verses to most poetry markers

  * Added feature to Auto-correct USFM for common syntax errors (or at least flag issues that need to be fixed) 
  
  * The Generate button on the FinalSFM tab in View/Edit now works (without having to Print first)
  
  * Default settings now live in a "Default" folder (which can be deleted if you need to reset all settings)

  * Auto-update PicList and other config filenames to now be based on new file naming system which includes the config name
  
Bug Fixes since version 1.1 (3 Oxt 2020)
   
  * Ensure captions in PicList display in the right font for the project
  
  * Fixed bug to ensure pictures show up even when no PicList is being used

  * Address issues with page dimensions and border size
  
  * Get Decorative PDFs to work reliably
  
  * Fixed Fancy Intro Outline right-leaders (and removed validation of SFM before enabling option)
  
  * Fixed a bug to cope with incomplete settings in settings.xml

  * Fixed bug when copying Config files to new "Default" folder location
  
  * Fixed bug of Configs (and everything else) being inaccessible on startup
  
  * Fixed wide Footnote/X-ref callers
  
  * Fixed Smart Quotes occuring in picture captions
  
  * Fixed threads from crashing
  
  * Fixed Repeated values in the Thumb Tabs

  * Fix truncating books in multi book projects
  
  * Fix to ensure first page has page 1 headers and footers

  * Fix certificate (again!) so no warnings are issued during installation
  
Bug Fixes and Improvements in: 1.1 (21 Sep 2020)

  * Last-used Project name and Config settings are now preserved between sessions
  
  * Several improvements to diglot layout (but diglot illustrations are still fragile/experimental)
  
  * Better handling of Headers/Footer - especially for Diglots (specify Pri or Sec formatting)
  
  * Added options to allow PTXprint to override Paratext's Footnote and Cross-Reference settings
  
  * Added picture size options of "page" (fits within margins) and "full" (cover entire page)
  
  * Fix Header and Footer for non-scripture books (GLO, BAK etc.)
  
  * Fix chapter numbers which were interfering with ascenders in line of text below
  
  * Fix multiple issues with end of book decoration, verse number decoration, borders and related PDFs
  
  * Fix RTL text not right-aligned in poetry
  
  * Fix non-Roman digits for Extended-Arabic (Persian)
  
  * Fix installer certificate

First Public Release: 1.0 - (13 Aug 2020)

  * Minor UI adjustments
  
  * Add link to ptxprint folder with helpful docs
  
  * Enable PTXprint to run directly from .cfg file (if extension has been associated by OS)

Bug Fixes: 0.9.3

  * Fix Watermark and Border PDFs so that they can both work concurrently
  
  * Fix Use Exclusive Pictures Folder
  
  * Fix Padding of illustrations when too tall for page
  
  * Fix Remove unwanted space before footnote and x-ref callers
  
  * Fix Add missing Tooltips and improve layout of Notes + X-ref Tab
  
Bug Fixes: 0.9.2

  * Fix loss grid-misalignment from 1-2 cols transition
  
  * Support fig scale. Don't remove topspace from title boxes
  
  * Reset tolerance and emergencystretch
  
  * Minor tweaks to UI wording (Title Case) and positioning

Bug Fixes and Improvements in: 0.9.1

  * Make main dialog resize-able so that the viewer is easier to use

  * Several improvements to diglot layout (but diglot illustrations are still fragile/experimental)

  * Several more options for the placement of illustrations are now possible
    (see: https://github.com/sillsdev/ptx2pdf/blob/master/docs/documentation/figures.md for details)
  
  * Moved main tabs to be vertical, and moved Notes and Cross-References to a new tab
  
  * Various diglot options (fuzzy/unaligned) have been removed (align on paragraph is now assumed)
  
  * Command-line options added/enhanced: 
        pid - Project id    OR   full path to a ptxprint.cfg file
		-f FONTPATH         Specify directory of fonts to include
        --nofontcache       Don't use system fonts
		
  * End of Book decorator is enabled (on Diglot+Borders tab)
  
  * Hide Advanced Features is more subtle (hiding discreetly next to the About box)
  
  * ESC no longer closes PTXprint
  
  * Show/Hide tabs removed completely (no longer deemed important)

  * Shade of blue (to show feature is active) improved on Picture, Diglot+Border tabs  

  * Bug Fix: Configuration Naming and path issues resolved
  
Bug Fixes and Improvements in: 0.8.8

  * Added ability to place figures/illustrations inline with the text (needs testing and documentation)

  * Enabled .bmp images to be used for illustrations (supported: jpg,jpeg,png,bmp,tif,tiff,pdf)
  
  * Enabled Diglot PicLists and AdjList to pull info from both Pri and Sec projects with R/L suffixes when required
  
  * Re-ordered Viewer tabs to be more logical
  
  * Automatically show .log file in Viewer tab if failed to produce a PDF
  
  * Improved page-breaking logic and removed infinte looping bugs

  * Fixed bug of missing illustrations when building PicLists
  
  * Fixed bug of URL links opening two identical tabs for each click
  
  * Added "Create ZIP Archive" primarily to assist with troubleshooting
  
Bug Fixes and Improvements in: 0.8.7

  * Installer now uses the folder for 64-bit applications (C:\Program Files\ rather than the 32-bit x86 location)
  
  * Re-arranged UI to put all font and script elements on a new Font tab
  
  * Removed "Omit..." wording from check-boxes to reduce confusion
  
  * Blended Diglot and Border tabs; moved Viewer to the final tab position
  
Bug Fixes and Improvements in: 0.8.6

  * Added IndentUnit option on Advanced tab to control how much paragraphs and poetry get indented
  
  * Fixed bug with missing back-matter PDF
  
  * Fixed path to ptxprint-mods.tex
  
Bug Fixes and Improvements in: 0.8.5

  * Fix page-size calcs causing some projects with illustrations to fail
  
Bug Fixes and Improvements in: 0.8.4

  * Output PDF filenames now include SavedConfig name

  * Fix PicList path to use Saved Config location
  
  * Various illustration-related bug fixes
  
  * Enable several more UI controls to show font/script of target text (with fallback to Sans)
  
  * Cascading Styles improved
  
  * Suppress creation of a blank custom.sty if file not found
  
  * Fixed centered table cells
  
  * More improvements and bug fixes to diglots

Bug Fixes and Improvements in: 0.8.3

  * Repair Footnote callers (were all turning to '+')
  
  * Fancy Borders now works as expected on Windows
  
  * Paths for generated PicLists and AdjLists fixed
  
  * Issue PicList warning if multiple images are found in a single verse
  
  * Clicking on link to download latest version now works again
  
  * Repair collateral damage caused by single word orphan changes

Bug Fixes and Improvements in: 0.8.2

  * Various tex macro bug fixes

  * Initial stab at supports \+ char styles

  * Add Bad Breaking Space for reducing orphan words

  * Get \thc working

  * Fix properly styled fonts getting used in TeX from ptxprint

  * Setup.py fixes

  * Fix chapter labels

Bug Fixes and Improvements in: 0.8.1

  * Refresh fonts button (on Advanced tab) to reset the font list if it gets stale
   
  * \FontScale in .sty files is now honoured
   
  * Independent font sizes are now honoured for both sides in diglot
   
  * You can now hit save config without a config name
   
New Features and Improvements in: 0.8.0

  * Allow multiple stylesheets for diglots to define fonts and styles for each side independently
  
  * Scale images to fit available space on page (rather than run off the page and disappear completely)
  
  * Removed dependency on img2pdf so that TIFs now get converted to become JPGs 
  
  * Better handling of line and page breaking (especially in poetical books)
  
  * Click on 'reload' fills footnote and cross-ref callers with default set (if none found in Paratext)
  
  * Chapter Numbers in peripheral (non-scripture) books are now suppressed by default (but can be re-enabled on the Advanced tab)
  
Bug fixes and improvements in: 0.7.1

  * Added ability to create aligned Diglots (with limited capability), and simplified Diglot tab
  
  * Diglot and Border tabs are now ON by default (as they are working more predictably)
  
  * Highlight Picture, Diglot and Border tabs in blue when their feature is enabled
  
  * Allow pictures in Diglots (largely untested feature - probably requiring improvement)
  
  * Fixed bug in PicList generation
  
  * Fixed bug in Lock/Unlock password setting/clearing
  
  * Make folders and links clickable in the Viewer
  
  * Added option (on Advanced tab) to prevent re-running the job when only testing, and needing to produce a quick PDF
  
  * Disable all settings until a project has been selected
  
Bug fixes and improvements in: 0.7.0

  * Add option to force Exclusive Use of Figures Folder (without searching any other folders or subfolders)
  
Bug fixes and improvements in: 0.6.9

  * Improved column balancing (allowing the final line to be filled at end of page)
  
  * More improvements to Notes paragraphing
  
  * Change attribute of \d into a Section style (rather than verse text) - for better drop-caps in Psalms
  
  * Fine-tune \q marker indents (still experimenting...)
  
  * Multiple XeTeX macro enhancements (\FontScale, footnote caller size, header baselines) and bugs fixed 
  
Bug fixes and improvements in: 0.6.8

  * Colors are now working the same in Paratext and in the PTXprint PDFs
  
  * Picture captions are better "balanced" when they go onto 2 or more lines
  
  * Missing Pictures are listed on Pictures tab after the PDF has been produced (not yet consistently, though)
  
  * Start at Page number option added on Advanced tab
  
  * Allow books (eg. PSA and PRO) to switch to Single-Column mode in a primarily Double-Column document
  
  * Improved notes formatting
  
  * Apply baseline for headings
  
  * Fix regression of PicLists and AdjList not being applied if a pre/post Process has been applied

Bug fixes and improvements in: 0.6.7

  * Significant improvements in footnote paragraph layout

  * Can now also specify FontSize and LineSpacing for Notes (Footnotes and Cross-References)
  
  * Set all Fonts based on Paratext font settings when a project is first opened
  
  * Generated NestedStyles.sty now happens before PrintDraft-mods.sty to allow user overrides to happen
  
  * Fixed bug which was bolding (again) a Bold typeface in fake Bold-Italic

Bug fixes and improvements in: 0.6.6

  * Allow larger hrd and ftr position values

Bug fixes and improvements in: 0.6.5

  * Added option on Body tab to Filter Glossary entries (to only show entries marked up in the text)
  
  * Fixed bug in Fancy Intro Outline code, and stopped this from running on non-scripture books
  
  * Slight improvement in Diagnostic Error messages
  
  * Fixed missing '.' in keep Books together with ch[:.]vs refs
  
  * It now offers to delete ALL TEMPORARY files in PrintDraft folder when unchecking 'Preserve Intermediate Files'.

Bug fixes and improvements in: 0.6.4

  * "Process text with custom script..." (e.g. call a .bat script, or .py program, etc.) is working, but minimally tested
  
  * Fixed various TeX issues (missing \Fontsize, spaces in color code)
  
  * Fix file chooser filters

  * PTXprint now has an automated CI build process to help feed into the software.sil.org/ptxprint page (coming soon...)

Bug fixes and improvements in: 0.6.3

  * Improved scrolling in the Viewer/Editor tab(s)
  
  * Allow \fig ... \fig* to be used in non-scripture books even if PicLists are being used
  
  * Fixed Colors to handle Paratext's system
  
  * Warn if PDFs are still locked in uncooperative PDF viewer (before trying to create PDF)
  
  * Disabled Splash screen on startup - as it was causing problems
  
  * Add code to allow running conversion scripts (pre/post other processes) - untested and EXPERIMENTAL

Bug fixes and improvements in: 0.6.2

  * markup such as \nd ... \nd* can use \SmallCaps in the stylesheet, and \FontSize can be scaled

  * Eliminate "nonpublishable" markers
  
  * Omit Ch:vs refs from captions now only affects the reference field

Bug fixes in: 0.6.1

  * Found the missing Application icon
  
  * Fixed the path to Secondary Merge PDF for Diglots

List of improvements: 0.6.0

  * Added new custom-built Font Chooser dialog so that only valid and usable
    font files will be listed (and no more ToFu font names, or problems with
    Oblique/Italic and Bold Oblique/BoldItalic fonts being ignore)
  
  * Added helpful diagnostic messages when creating PDF fails
  
  * Added default paths for folders, & other PDF assets (watermarks borders)
  
  * Added support for Chapter Labels in specific user-defined books (Psalms,
    Proverbs, etc.)
  
  * Re-arranged some UI elements to make it more intuitive and less crowded
  
  * By default, books are arranged into a logical order, but this can be
    overwritten by editing/re-arranging the list of books

  * Allow out of canonical sequence for books 
    (e.g. INT MAT ... REV PSA PRO BAK TDX NDX GLO)


List of improvements: 0.5.4

  * Enable headless (no GUI) running of PTXprint so that PDFs are produced 
    from the commandline (great for regression testing, and much more)


List of improvements: 0.5.3

  * Color has been added - so that if \Color is defined in the .sty file(s)
    those colors can be applied in the text if the option is Enabled on the
    Advanced tab
  
  * Eliminate looping in the UI when changing projects and there are multiple
    Saved Configurations
  
  * Eliminate an endless loop when trying to balance a tight page (XeTeX)
  
  * Handle \Bold - in .sty and also for Italic, Underline, etc.
  
  * Fix Empty (ch:vs) refs in captions 


List of improvements: 0.5.1

  * Illustration Handling has been made more flexible and robust to handle
    special characters in image filenames
  
  * PicLists have the same options as inline \fig ... \fig* illustrations
    (hide caption, skip missing pics, etc.)
  
  * Fixed a few XeTeX bugs


List of improvements: 0.5.0

  * Saved Configurations are now possible, and these are shared via S/R
    with other Paratext users of the same project

  * All the Tabs can be Shown/Hidden as required - enabling a very simple
    view for users who don't need complexity

  * Handling of illustrations has been completely revamped and hopefully
    greatly improved with increased flexibility

  * Conversion of TIF images to the PDF image format happens automagically
    when required

  * Illustrations in USFM3 markup are now handled natively by XeTeX (but has
    only been minimally tested)

  * Top-to-Bottom (Left-to-Right) text flow direction is now supported
    (i.e. vertical text layout)

  * The Tooltip messages have been enhanced significantly

  * Font-based Glyph Metrics can now override the line spacing options
    (dynamic vertical line spacing for Arabic script)

  * A warning is issued if an improperly installed font is chosen from
    the Font chooser dialog

  * Graphite rendering has always been enabled by default (if the font
    supports it), but can now be disabled if needed

  * An extra/fallback font can be defined to handle (punctuation) characters
    that are not found in the Regular font

  * A button that helps you locate/list any characters that are missing from
    the Regular font has been added

  * Minor improvements in the Footnotes area - buttons to re-load the Callers
    from PT's settings, and the ':' addition:

  * Clicking the "Print" button makes it GREEN to show that it is working

  * When you Regenerate PicLists or AdjLists, it checks if you want to
    overwrite any existing files

  * There's an option to print the name of the Saved Configuration as footer
    of the first page of each book

  * There's an option to bridge empty verses adding {...} in place of the
    missing text

  * All dialog boxes and error messages now stay on top
  
  * Keyboard shortcuts for Print (Ctrl-P) and Save (Ctrl-S) have been added

  * A splash-screen pops up when PTXprint starts, letting you know that
    something's actually happening

  * An About dialog has been added, with an MIT license and credits

Bug fixes:

  * Setting the Script for Digits now works as advertised

  * Changes to PrintDraftChanges.txt were not being picked up until
    PTXprint was re-started

  * Specific rules specified in PrintDraftChanges.txt were being ignored

  * Footnotes disappeared off the end of the page under certain conditions

  * USFM filenames using a Prefix as well as a Suffix weren't being found

  * Font features were not being activated
